<?php



if (defined('PS_ADMIN_DIR') && file_exists(PS_ADMIN_DIR . '/../classes/AdminTab.php'))
    include_once(PS_ADMIN_DIR . '/../classes/AdminTab.php');

require_once(dirname(__FILE__) . '/amazon.php');

require_once(dirname(__FILE__) . '/classes/amazon.tools.class.php');
require_once(dirname(__FILE__) . '/classes/amazon.order.class.php');

class OrdersAmazon extends AdminTab
{

    private $module = 'amazon';
    public $multishop_context;
    public $multishop_context_group;
    public $id_lang;

    public function __construct()
    {
        global $cookie, $_LANGADM, $_MODULE;

        if (version_compare(_PS_VERSION_, '1.5', '>='))
        {
            $this->multishop_context = Shop::CONTEXT_ALL;
            $this->id_lang = (int) Context::getContext()->language->id;
        }
        else
        {
            $this->id_lang = (int) $cookie->id_lang;
        }

        $langFile = _PS_MODULE_DIR_ . $this->module . '/' . Language::getIsoById($this->id_lang) . '.php';

        if (file_exists($langFile))
        {
            include($langFile);

            foreach ($_MODULE as $key => $value)
                if (preg_match('#^..' . $this->module . '#', $key))
                    $_LANGADM[str_replace('_', '', strip_tags($key))] = $value;
        }
        $path = __PS_BASE_URI__ . basename(_PS_MODULE_DIR_) . '/' . $this->module . '/';

        $this->images = $path . 'images/';

        // Amazon Europe
        //
      $this->amazonEurope = unserialize(base64_decode(Amazon::configurationGet('AMAZON_EUROPE')));
        $this->actives = unserialize(base64_decode(Amazon::configurationGet('AMAZON_ACTIVE')));

        if ($this->amazonEurope && $this->marketPlaceMaster = unserialize(base64_decode(Amazon::configurationGet('AMAZON_MASTER'))))
        {
            $marketPlaceRegion = unserialize(base64_decode(Amazon::configurationGet('AMAZON_REGION')));
            $masterPlatform = 0;


            if ($marketPlaceRegion)
                foreach ($marketPlaceRegion as $language_id => $region)
                    if ($this->marketPlaceMaster == $region)
                        break;

            $this->marketPlaceMasterId = $language_id;
        }

        else
            $this->marketPlaceMasterId = false;

        // Custom style depending PS release
        //
      if (preg_match('/^1\.[1-3]/', _PS_VERSION_))
        {
            $this->radiostyle = '';
            $this->flagstyle = 'position:relative;top:-3px;';
        }
        else
        {
            $this->radiostyle = 'position:relative;top:-3px;';
            $this->flagstyle = 'position:relative;top:-3px;';
        }
        $this->_amazon = new Amazon();

        parent::__construct();
    }

    public function l($string, $class = false, $addslashes = FALSE, $htmlentities = TRUE)
    {
        return( $this->_amazon->l($string, __CLASS__, $addslashes = FALSE, $htmlentities = TRUE) );
    }

    public function DisplayCountries()
    {
        $currencies = unserialize(base64_decode(Amazon::configurationGet('AMAZON_CURRENCY')));
        $count = 0;
        $html = '';
        $html = '<fieldset>
        <legend><img src="../img/admin/world.gif" alt="" class="middle" />' . $this->l('Choose Amazon Platform') . '</legend>';



        if ($this->amazonEurope)
        {
            // Display Master MarketPlace
            //
      $html .= '<img src="' . $this->images . 'eu.gif" style="' . $this->flagstyle . '" alt="Europe" />&nbsp;';
            $html .='<span><b>' . $this->l('Europe') . '</b>:&nbsp;&nbsp;</span>';

            // Bad fix for Europe
            $others = '';
            $firstActive = 0;
            // Display Amazon Europe
            //
      foreach (Amazon_Tools::languages() as $language)
            {
                $id_lang = $language['id_lang'];
                $count++;

                // Active / Inactive
                //
                if (!isset($this->actives[$id_lang]))
                    continue;

                // Is not inside Europe Area
                //
                if (!Amazon_Tools::isEurope($language['iso_code']))
                    continue;

                if (!$firstActive)
                {
                    $firstActive = $id_lang;
                    $html .= '<input type="radio" name="amazon_lang" style="' . $this->radiostyle . '" value="' . $firstActive . '" rel="1" />&nbsp;&nbsp;' . "\n";
                }

                $others .= '<img src="' . $this->images . 'geo_flags/' . $language['iso_code'] . '.gif" style="' . $this->flagstyle . '" alt="' . $language['name'] . '" />&nbsp;&nbsp;' . $language['name'] . '&nbsp;&nbsp;';
            }
            $html .= $others;
        }


        // Display Other Platforms
        //
    $other = '<br /><br /><span style="font-weight:bold">' . $this->l('Other Platforms') . ':</span>&nbsp;&nbsp;';

        foreach (Amazon_Tools::languages() as $language)
        {
            $id_lang = $language['id_lang'];
            $count++;

            if (!$id_lang)
                continue;

            // Active / Inactive
            //
            if (!isset($this->actives[$id_lang]))
                continue;

            // Is inside Europe Area
            //
            if (Amazon_Tools::isEurope($language['iso_code']) && $this->amazonEurope)
                continue;

            // Exclude Master (Europe)
            //
            #if ( $this->marketPlaceMasterId == $id_lang  ) continue ;

            $other .= '<input type="radio" name="amazon_lang" style="' . $this->radiostyle . '" value="' . $id_lang . '" rel="0" />&nbsp;&nbsp;';
            $other .= '<img src="' . $this->images . 'geo_flags/' . $language['iso_code'] . '.gif" style="' . $this->flagstyle . '" alt="' . $language['name'] . '" />&nbsp;&nbsp;' . $language['name'] . '&nbsp;&nbsp;';
        }
        if ($other)
            $html .= $other;

        $html .= '</fieldset><br />';

        echo $html;

        return($count ? $count : false);
    }

    public function display()
    {
        global $cookie;
        $name = 'amazon';
        $module = __PS_BASE_URI__ . basename(_PS_MODULE_DIR_) . '/' . $name . '/';
        $images = $module . 'images/';
        $loader = $images . 'loading.gif';
        $lookup = $module . 'functions/orders.php';
        $import = $module . 'functions/import.php';

        $jsFile = dirname(__FILE__) . '/js/orders.js';

        /* d�ja d�fini mais bug avec la translation i18n/smarty de prestashop ? */
        /* http://www.prestashop.com/forums/viewthread/97423/rapports_de_bugs/i18n__panneau_dadministration__outils__traductions___classes_adjacentes___constantes_/ */
        $statusName = array();
        $statusName['Pending'] = $this->l('Pending - This order is pending on the Market Place');
        $statusName['Unshipped'] = $this->l('Unshipped - This order wait to be shipped');
        $statusName['PartiallyShipped'] = $this->l('Partially Shipped - This order was Partially Shipped');
        $statusName['Shipped'] = $this->l('Shipped - This order was Shipped');
        $statusName['Canceled'] = $this->l('Canceled - This order was canceled');

        @includeDatepicker(array('datepickerFrom', 'datepickerTo'));

        $currentDate = date('Y-m-d');


        $day = 86400;
        $days = 7;
        $initialDate = date('Y-m-d', time() - ($day * $days));
        
        $tokenOrders = Tools::getAdminToken('AdminOrders' . (int) Tab::getIdFromClassName('AdminOrders') . (int) $cookie->id_employee);

        echo '
        <img style="float:right" src="' . $images . 'amazon.png" alt="' . $this->l('Amazon Market Place') . '" /><br /><br />
        <form action="' . $_SERVER['REQUEST_URI'] . '" method="post" id="updateAmazon">
          <input type="hidden" id="id_lang" value="' . $this->id_lang . '" />  
    	  <input type="hidden" id="orders_url" value="' . $lookup . '" />
    	  <input type="hidden" id="import_url" value="' . $import . '" />
    	  <input type="hidden" id="msg_date" value="' . $this->l('You have to choose a date range') . '" />
        <input type="hidden" id="img_loader" value="' . $loader . '" />
        <input type="hidden" name="currentDate" value="' . $currentDate . '" />
        <input type="hidden" name="token_order" value="' . $tokenOrders . '" />

        ';
        $amazonTokens = unserialize(base64_decode(Amazon::configurationGet('AMAZON_CRON_TOKEN')));

        foreach ($amazonTokens as $id_lang => $token)
        {
            echo '
                <input type="hidden" id="amazon_tokens" name="amazon_token[' . $id_lang . ']" value="' . $token . '" />';
        }

        if (!$this->DisplayCountries())
        {
            die($this->l('Module must be configured'));
        }

        echo '<div>
          <fieldset style="width:650px; font-size:13px;">
          <legend><img src="../img/admin/date.png" />' . $this->l('Lookup for Orders') . '</legend>
    			<div>
    					<p>
                <span>&nbsp;&nbsp;' . $this->l('From') . '&nbsp;&nbsp;</span>
                <input type="text" name="datepickerFrom" id="datepickerFrom" value="' . $initialDate . '">
                <span>&nbsp;' . $this->l('To') . '&nbsp;&nbsp;</span>
                <input type="text" name="datepickerTo" id="datepickerTo" value="' . $currentDate . '">


            </p>
            <br />

              <span>' . $this->l('Status') . '&nbsp;&nbsp;</span>
            <select name="statuses">
              <option value="All">' . $this->l('Retrieve all pending orders') . '</option>';

        foreach ($statusName as $key => $val)
        {
            if ($key == 'Unshipped')
                $selected = ' selected="selected"';
            else
                $selected = '';

            echo '<option value="' . $key . '"' . $selected . '>' . $val . '</option>';
        }

        echo '   </select>
            <br /><br />';

        echo '
  			</div>
  			<br /><br />
        <input type="button" style="float:right" class="button" id="lookup" value="' . $this->l('Lookup') . '" />
  		</fieldset>
     </div>
     </form>
     <br />';


        echo '
    	<div id="pending" style="display:none">
          <fieldset style="min-height:400px;">
            <legend><img src="../img/admin/search.gif" alt="" class="middle" />' . $this->l('Pending Orders from the Amazon Market Place') . '</legend>
          <br />
          <div id="result"></div>
          <br />
          <div id="amz-loader"><img src="' . $loader . '" style="margin-left: 50%;" alt="' . $this->l('Lookup') . '..." /></div>
          <fieldset id="result2" style="display:none;"></fieldset>
          </fieldset>
    		<br />
      </div>
      ';

        // jQuery Functions
        //
      $js = file_get_contents($jsFile);

        echo '<script type="text/javascript">' . $js . '</script>';
    }

}

?>
