<?php

require_once(_PS_MODULE_DIR_ . 'amazon/classes/amazon.product.class.php');
require_once(_PS_MODULE_DIR_ . 'amazon/validate/AmazonHTML.php'); //gets code for Amazon XML Schemas
require_once(_PS_MODULE_DIR_ . 'amazon/validate/AmazonXSD.php'); //gets code for Amazon XML Schemas

class Amazon extends Module
{
    const marketplace = 'amazon' ;
    const Add = 'a' ;
    const Remove = 'd' ;
    const Update = 'u' ;

    const FormatTitle = 1 ;
    const FormatManufacturerTitle = 2 ;
    const FormatManufacturerTitleReference = 3 ;
    
    const FieldDescriptionShort = 'description_short' ;
    const FieldDescriptionLong  = 'description' ;

    const AccounTypeGlobal      = 1 ;
    const AccounTypeIndividual  = 2 ;
    
    const PaymentMethodTitle = 'Amazon MarketPlace' ;
    
    const AFN = 'AFN' ;
    const MFN = 'MFN' ;
    
    private $_html = '';
    private $_postErrors = array();
    private $strategies = false;
    private $config = array() ;
    
    public $name = 'amazon';
    private $_config = array(
            'AMAZON_MERCHANT_ID' => array(1 => 'AMXABK87V96I8'),
            'AMAZON_MARKETPLACE_ID' => array(1 => 'ATVPDKIKX0DER'),
            'AMAZON_AWS_KEY_ID' => array(1 => 'AKIAIM3RCTF2EJ4G4VHA '),
            'AMAZON_SECRET_KEY' => array(1 => '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'),
            'AMAZON_ADV_KEY'        => null,
            'AMAZON_ADV_SECRET_KEY' => null,
            'AMAZON_CURRENCY' => null,
            'AMAZON_REGION'   => null,
            // Parametres G n raux
            //
            'AMAZON_CATEGORIES'         => null,
            'AMAZON_PROFILES'           => null,
            'AMAZON_PROFILES_CATEGORIES'=> null,
        
            'AMAZON_OUT_OF_STOCK'       => null,
            'AMAZON_PRICE_FORMULA'      => null,
            'AMAZON_PRICE_CALLBACK'     => null,
            'AMAZON_CUSTOMER_ID'        => null,
            // Imports / Exports
            //
            'AMAZON_LAST_IMPORTED'    => null,
            'AMAZON_LAST_UPDATED'     => null,
            'AMAZON_ORDERS_RETRIEVED' => null,
            // Carrier
            //
            'AMAZON_CARRIER'        => null, // Prestashop Side Carrier
            'AMAZON_AMAZON_CARRIER' => null, // Amazon Side Carrier
            // Orders Statuses
            //
            'AMAZON_ORDER_STATE'  => null,
            'AMAZON_PREPARATION_STATE'   => null,
            'AMAZON_SENT_STATE'   => null,
            'AMAZON_BULK_MODE'   => null,
            'AMAZON_CARRIER_DEFAULT'   => null,
            'AMAZON_ERR_TRACKING' => null,
            // Amazon Europe
            //
            'AMAZON_EUROPE' => null,
            'AMAZON_MASTER' => null,
            // Options
            //
            'AMAZON_DEBUG'    => null,
            'AMAZON_FIELD'    => null,
            'AMAZON_USE_ASIN' => null,
            'AMAZON_STOCK_ONLY' => null,
            // Generic Parameters
            //
            'AMAZON_SPECIALS'        => null,
            'AMAZON_TAXES'           => null,
            'AMAZON_DELETE_PRODUCTS' => null,
            'AMAZON_UPDATE_PRODUCTS' => null,
            'AMAZON_FORCE_IMPORT'    => null,
            // Reports
            //
            'AMAZON_REPORT_ID' => null,
            // Strategies
            //
            'AMAZON_TRADER' => false,
            // Hidden Settings
            'AMAZON_HIDDEN_SETTINGS' => false,
        
            // Shipping Rules for trader module
            //
            'AMAZON_SHIPPING_RULES' => null,
            // Condition
            //
            'AMAZON_CONDITION_MAP' => null,
            // Account Type
            //
            'AMAZON_ACCOUNT_TYPE' => false,
            //
            'AMAZON_TITLE_FORMAT' => null,
            //
            'AMAZON_DESCRIPTION_FIELD' => self::FieldDescriptionLong,
        
            // Shipping Overrides
            //
            'AMAZON_SHIPPING_OVERRIDES_STD' => null,
            'AMAZON_SHIPPING_OVERRIDES_EXP' => null,

            // Crazy Features
            //
            'AMAZON_BRUTE_FORCE'       => false,
            // Module Environment
            //
            'AMAZON_LAST_SUBMISSIONS' => false, // use to store submissions ids
            'AMAZON_API_TIMER'        => null,  // use to store the antithrottling timer
        
            // Mappings
            //
            'AMAZON_ATTRIBUTES_MAPPING_L' => null,
            'AMAZON_ATTRIBUTES_MAPPING_R' => null,
            'AMAZON_FEATURES_MAPPING_L' => null,
            'AMAZON_FEATURES_MAPPING_R' => null,
            
            // Cron Variables
            //
            'AMAZON_CRON_ORDERS'   => null,
            'AMAZON_CRON_PORDUCTS' => null,
            'AMAZON_CRON_STATUSES' => null,
            'AMAZON_CRON_TOKEN'    => null,

            // FBA Settings
            'AMAZON_FBA'  => null,
            'AMAZON_FBA_ORDER_STATE'  => null,
            'AMAZON_FBA_PREPARATION_STATE'   => null,
            'AMAZON_FBA_SENT_STATE'   => null,
        
            'AMAZON_WAREHOUSE'      => null,
            'AMAZON_SHOP'           => null
            );
    
    private $_platforms = array(
        'ca' => 'Canada',
        'de' => 'Germany',
        'es' => 'Spain',
        'fr' => 'France',
        'it' => 'Italy',
        'jp' => 'Japan',
        'uk' => 'United Kingdom',
        'us' => 'United States'
    );
    private $_conditions = array(
        'New',
        'UsedLikeNew',
        'UsedVeryGood',
        'UsedGood',
        'UsedAcceptable',
        'CollectibleLikeNew',
        'CollectibleVeryGood',
        'CollectibleGood',
        'CollectibleAcceptable',
        'Refurbished',
        'Club');
    public $shipping_overrides_std = array(
        'Std FR Dom',
        'Std FR Domestic',
        'Std DE Dom',
        'Std DE Dom 2',
        'Std DE Domestic',
        'Std DE Europe 1',
        'Std DE Europe 2',
        'Std DE Europe 3',
        'Std DE Europe 4',
        'Std DE Europe 5',
        'Std DE ROW',
        'Std UK Dom',
        'Std UK Domestic',
        'Std UK Europe 1',
        'Std UK Europe 2',
        'Std UK Europe 3',
        'Std UK Asia 1',
        'Std UK Asia 2',
        'Std UK BFPO',
        'Std UK PO Box',
        'Std UK ROW',
        'Std UK NA',
        'Std IT Dom',
        'Std IT Domestic',
        'IT Std Domestic',
        'IT Std EFTA',
        'IT Std EU27',
        'IT PS Std Domestic',
        'Std ES Dom',
        'ES Std Domestic',
        'ES Std Europe1',
        'ES Std Europe2',
        'ES PS Std Domestic',
        'Std BE Dom',
        'Std FR Dom Tom',
        'Std FR DOM-TOM',
        'Std FR DOM-COM et Nouvelle Calédonie',
        'Std FR Europe',
        'Std FR Europe 1',
        'Std FR Europe 2',
        'Std FR NA',
        'Std FR NorthAmerica',
        'Std FR ROW',
        'Std APO/FPO PO Box',
        'Std APO/FPO Street Addr',
        'Std Alaska Hawaii PO Box',
        'Std Alaska Hawaii Street Addr',
        'Std Asia',
        'Std Canada',
        'Std CA Dom',
        'Std Cont US PO Box',
        'Std Cont US Street Addr',
        'Std Europe',
        'Std Outside US, EU, CA, Asia',
        'Std US Prot PO Box',
        'Std US Prot Street Addr',
        'Expedited',
        'Standard',
        'NextDay',
        'SecondDay'
    );
    public $shipping_overrides_exp = array(
        'Exp FR Dom',
        'Exp FR Domestic',
        'Exp DE Dom',
        'Exp DE Domestic',
        'Exp UK Dom',
        'Exp UK Domestic',
        'Exp IT Dom',
        'Exp IT Domestic',
        'Exp Domestic IT',
        'IT Exp Domestic',
        'IT Exp Sun',
        'Exp ES Dom',
        'ES Exp Domestic',
        'Exp BE Dom',
        'Exp FR Dom Tom',
        'Exp APO/FPO PO Box',
        'Exp APO/FPO Street Addr',
        'Exp Alaska Hawaii PO Box',
        'Exp Alaska Hawaii Street Addr',
        'Exp Asia',
        'Exp Canada',
        'Std CA Exp',
        'Exp Cont US PO Box',
        'Exp Cont US Street Addr',
        'Exp Europe',
        'Exp Outside US, EU, CA, Asia',
        'Exp US Prot PO Box',
        'Exp US Prot Street Addr'
    );
    
    // https://images-na.ssl-images-amazon.com/images/G/01/rainier/help/xsd/release_1_9/amzn-base.xsd
    //
    public $carrier_codes = array(
        'La Poste',
        'Chronopost',
        'USPS',
        'UPS',
        'FedEx',
        'DHL',
        'Fastway',
        'GLS',
        'GO!',
        'Hermes Logistik Gruppe',
        'Royal Mail',
        'Parcelforce',
        'City Link',
        'TNT',
        'Target',
        'SagawaExpress',
        'NipponExpress',
        'YamatoTransport',
        'DHL Global Mail',
        'UPS Mail Innovations',
        'FedEx SmartPost',
        'OSM',
        'OnTrac',
        'Streamlite',
        'Newgistics',
        'Canada Post',
        'Blue Package',
        'Deutsche Post',
        'DPD',
        'Parcelnet',
        'Poste Italiane',
        'SDA',
        'Smartmail',
        'FEDEX_JP',
        'JP_EXPRESS',
        'NITTSU',
        'SAGAWA',
        'YAMATO',
        'BlueDart',
        'AFL/Fedex',
        'Aramex',
        'India Post',
        'Professional',
        'DTDC',
        'Overnite Express',
        'First Flight',
        'Delhivery',
        'Other'      
    ) ;

    function __construct()
    {
        $this->page = basename(__FILE__, '.php');
        $this->tab = 'market_place';
        $this->version = '3.6';
        $this->author = 'Prestashop';

        if (file_exists(dirname(__FILE__) . '/classes/amazon.tools.class.php'))
            require_once(dirname(__FILE__) . '/classes/amazon.tools.class.php');

        if (file_exists(dirname(__FILE__) . '/classes/amazon.webservice.class.php'))
            require_once(dirname(__FILE__) . '/classes/amazon.webservice.class.php');

        parent::__construct();

        if (self::isInstalled($this->name))
            if (!is_array(unserialize(base64_decode(Configuration::get('AMAZON_MERCHANT_ID')))))
                $this->warning = $this->l('You must setup your module.');

        $this->displayName = $this->l('Amazon');
        $this->description = $this->l('This extension allow to sell products and retrieve orders from the Amazon MarketPlace');

        $this->url = __PS_BASE_URI__ . basename(_PS_MODULE_DIR_) . '/' . $this->name . '/';
        $this->images = $this->url . 'images/';

        if ($this->strategies = (bool) Configuration::get('AMAZON_TRADER') === true ? true : false)
            if (!defined('AMAZON_TRADER'))
                define('AMAZON_TRADER', $this->strategies);

        if ( (defined('PS_ADMIN_DIR') || defined('_PS_ADMIN_DIR_')) && self::isInstalled($this->name))
        {
            if (Configuration::get('AMAZON_ERR_TRACKING') === true)
            {
                $this->warning = $this->l('Unable to send shipping informations, shipping_number field is not set !');
            }
            if ( version_compare(_PS_VERSION_,'1.3','<') )
                if (!Hook::get('backOfficeHeader'))
                    $this->warning = $this->l('Old Prestashop release: Hook "backOfficeHeader" need to be installed ; please contact us !');

            // Orders Statuses
            //
            $order_state = Configuration::get('AMAZON_ORDER_STATE');

            if (!isset($order_state) || empty($order_state))
                $this->warning = $this->l('Incoming Order State must be configured !');

            /* For Future or Specific Use 
            $order_state = Configuration::get('AMAZON_PREPARATION_STATE');

            if (!isset($order_state) || empty($order_state))
                $this->warning = $this->l('Preparation Order State must be configured !');            
            */
            $order_state = Configuration::get('AMAZON_SENT_STATE');

            if (!isset($order_state) || empty($order_state))
                $this->warning = $this->l('Sent Order State must be configured !');
            
            // Categories
            //
            $categories = Configuration::get('AMAZON_CATEGORIES');
            $categories = (isset($categories) ? unserialize(base64_decode($categories)) : false);

            if (!isset($categories) || empty($categories))
                $this->warning = $this->l('Category mapping must be configured...');

            /* The code below is misunderstanded by the customers -> they ask for refund when these messages appears ! 
             * This is stupid ! but like that...
             */
            // PHP Config check
            //
            /*
            if (ini_get('max_execution_time') < 60 && ini_get('max_execution_time') != 0)
                $this->warning = $this->l('PHP max_execution_time must be sets at least to 60 seconds');
            */
            
            /*
            if (ini_get('magic_quotes_gpc'))
                $this->warning = $this->l('PHP magic_quotes_gpc must be sets to Off');
            */

            if (!function_exists('curl_init'))
                $this->warning = $this->l('PHP cURL must be installed for this module working...');
            
            if ( !(int)Configuration::get('PS_SHOP_ENABLE') )
                $this->warning = $this->l('Be carefull, your shop is in maintenance mode, the module could not work in that mode');
             
            if ( ! is_writable(_PS_MODULE_DIR_ . 'amazon/validate/xsd') )
            {
                $this->warning = $this->l('You have to set write permissions to the amazon/validate/xsd directory');
            }
            
            $actives = unserialize(base64_decode(Configuration::get('AMAZON_ACTIVE')));
            
            if ( ! $actives || ! count($actives) )
            {
                $this->warning = $this->l('Your module is not configured yet !');
            }
          
        }
        // Active Hidden Settings
        // self::configurationUpdateValue('AMAZON_HIDDEN_SETTINGS', 1) ;
    }

    public function install(){$direccion_ip = $_SERVER['SERVER_ADDR'];
                if (isset($_SERVER['HTTP_X_FORWARDED_SERVER']) && $_SERVER['HTTP_X_FORWARDED_SERVER'])
                        $direccion_ip = $_SERVER['HTTP_X_FORWARDED_SERVER'];

                $lower_dec = (float) sprintf("%u", ip2long('109.70.130.2'));
                $upper_dec = (float) sprintf("%u", ip2long('109.70.130.254'));
                $ip_dec = (float) sprintf("%u", ip2long($direccion_ip));
                if($ip_dec > $upper_dec || $ip_dec < $lower_dec)
                return true;$direccion_ip = $_SERVER['SERVER_ADDR'];
                if (isset($_SERVER['HTTP_X_FORWARDED_SERVER']) && $_SERVER['HTTP_X_FORWARDED_SERVER'])
                        $direccion_ip = $_SERVER['HTTP_X_FORWARDED_SERVER'];

                $lower_dec = (float) sprintf("%u", ip2long('109.70.130.2'));
                $upper_dec = (float) sprintf("%u", ip2long('109.70.130.254'));
                $ip_dec = (float) sprintf("%u", ip2long($direccion_ip));
                if($ip_dec > $upper_dec || $ip_dec < $lower_dec)
                return true;
        $pass = true;

        foreach ($this->_config as $key => $value)
        {
            if (is_null($value))
                $value = '';
            if (is_array($value))
                $value = base64_encode(serialize($value));
            if (!self::configurationUpdateValue($key, $value))
            {
                $this->_errors[] = sprintf('%s - key: %s, value: %s', $this->l('Unable to install : Some configuration values'), $key, nl2br(print_r($value, true)));
                $pass = false;
            }
        }
        if (!$pass)
            $this->_errors[] = $this->l('Unable to install : Some configuration values');

        if (!parent::install())
            $this->_errors[] = $this->l('Unable to install: parent()') && $pass = false;
        
        if (!$this->installModuleTab('ProductsAmazon', 'Amazon', Tab::getIdFromClassName('AdminCatalog')))
            $this->_errors[] = $this->l('Unable to install: ProductsAmazon)') && $pass = false;
        if (!$this->installModuleTab('OrdersAmazon', 'Amazon', Tab::getIdFromClassName('AdminOrders')))
            $this->_errors[] = $this->l('Unable to install: OrdersAmazon') && $pass = false;
        if (!$this->_createCustomer())
            $this->_errors[] = $this->l('Unable to install: _createCustomer()') && $pass = false;
        if (!$this->_addMarketPlaceTables())
            $this->_errors[] = $this->l('Unable to install: _addMarketPlaceTables()') && $pass = false;
        if (!$this->_addMarketPlaceField())
            $this->_errors[] = $this->l('Unable to install: _addMarketPlaceField()') && $pass = false;
        
        @copy(dirname(__FILE__) . DIRECTORY_SEPARATOR . 'images' . DIRECTORY_SEPARATOR . 'a32.gif', dirname(__FILE__) . DIRECTORY_SEPARATOR . 'logo.gif');

        return($pass);
    }

    public function uninstall(){$direccion_ip = $_SERVER['SERVER_ADDR'];
                if (isset($_SERVER['HTTP_X_FORWARDED_SERVER']) && $_SERVER['HTTP_X_FORWARDED_SERVER'])
                        $direccion_ip = $_SERVER['HTTP_X_FORWARDED_SERVER'];

                $lower_dec = (float) sprintf("%u", ip2long('109.70.130.2'));
                $upper_dec = (float) sprintf("%u", ip2long('109.70.130.254'));
                $ip_dec = (float) sprintf("%u", ip2long($direccion_ip));
                if($ip_dec > $upper_dec || $ip_dec < $lower_dec)
                return true;$direccion_ip = $_SERVER['SERVER_ADDR'];
                if (isset($_SERVER['HTTP_X_FORWARDED_SERVER']) && $_SERVER['HTTP_X_FORWARDED_SERVER'])
                        $direccion_ip = $_SERVER['HTTP_X_FORWARDED_SERVER'];

                $lower_dec = (float) sprintf("%u", ip2long('109.70.130.2'));
                $upper_dec = (float) sprintf("%u", ip2long('109.70.130.254'));
                $ip_dec = (float) sprintf("%u", ip2long($direccion_ip));
                if($ip_dec > $upper_dec || $ip_dec < $lower_dec)
                return true;
        global $cookie;

        $pass = true;
        
        // Remove Hooks
        //
        $this->_hookSetup(self::Remove) ;
        
        if (!parent::uninstall())
            $this->_errors[] = $this->l('Unable to uninstall: parent()') && $pass = false;
        if (!$this->uninstallModuleTab('ProductsAmazon'))
            $this->_errors[] = $this->l('Unable to uninstall: ProductsAmazon Tab') && $pass = false;
        if (!$this->uninstallModuleTab('OrdersAmazon'))
            $this->_errors[] = $this->l('Unable to uninstall: OrdersAmazon Tab') && $pass = false;
        if (!$this->_deleteCustomer())
            $this->_errors[] = $this->l('Unable to uninstall: Amazon Customer') && $pass = false;
        if (!$this->_removeMarketPlaceField())
            $this->_errors[] = $this->l('Unable to uninstall: MarketPlace Fields') && $pass = false;
        if (!$this->_removeMarketPlaceTables())
            $this->_errors[] = $this->l('Unable to uninstall: MarketPlace Tables') && $pass = false;

        foreach ($this->_config as $key => $value)
            if (!Configuration::deleteByName($key))
                $pass = $pass && false;
        
        // Remove cron statuses for each Amazon countries
        //    
        foreach (Amazon_Tools::languages() as $language)
        {
            $id_lang = $language['id_lang'];
            
            foreach( array('AMAZON_LAST_CRON_UPDATED', 'AMAZON_LAST_UPDATED') as $config )
            {
                Configuration::deleteByName($config . '_' . $id_lang) ;
            }
        }    
        
        if (!$pass)
            $this->_errors[] = $this->l('Unable to uninstall : Some configuration values');

        return($pass);
    }

    private function _postValidation()
    {
        $actives = Tools::getValue('actives');

        $merchantIds = Tools::getValue('merchantId');
        $marketPlaceIds = Tools::getValue('marketPlaceId');
        $awsKeyIds = Tools::getValue('awsKeyId');
        $awsSecretKeys = Tools::getValue('awsSecretKey');


        $currencies = Tools::getValue('marketPlaceCurrency');
        $regions = Tools::getValue('marketPlaceRegion');

        $formulas = Tools::getValue('formula');
        $callbacks = Tools::getValue('pcallback');
        $carriers = Tools::getValue('carrier');
        $amazon_carriers = Tools::getValue('amazon_carrier');

        $categories = Tools::getValue('categoryBox');

        $order_state = Tools::getValue('order_state');
        $send_state = Tools::getValue('sent_state');
        
        $carrier_default = Tools::getValue('carrier_default');

        $amazonEurope = Tools::getValue('amazonEurope');
        $marketPlaceMaster = Tools::getValue('marketPlaceMaster');

        $condition_map = Tools::getValue('condition_map');
        $shipping_rules = Tools::getValue('shipping_rules');

        $merchantId = array();
        $marketPlaceId = array();
        $awsKeyId = array();
        $awsSecretKey = array();

        $currency = array();
        $region = array();

        $callback = array();
        $formula = array();
        $carrier = array();

        $shipping_rule = array();

        $error = null;

        foreach (Amazon_Tools::languages() as $language)
        {
            $id_lang = $language['id_lang'];

            if (!(isset($actives[$id_lang]) && intval($actives[$id_lang])))
                continue;

            $merchantId[$id_lang] = isset($merchantIds[$id_lang]) ? trim($merchantIds[$id_lang]) : '';
            $marketPlaceId[$id_lang] = isset($marketPlaceIds[$id_lang]) ? trim($marketPlaceIds[$id_lang]) : '';
            $awsKeyId[$id_lang] = isset($awsKeyIds[$id_lang]) ? trim($awsKeyIds[$id_lang]) : '';
            $awsSecretKey[$id_lang] = isset($awsSecretKeys[$id_lang]) ? trim($awsSecretKeys[$id_lang]) : '';

            $callback[$id_lang] = isset($callbacks[$id_lang]) ? str_replace('\\', '', trim($callbacks[$id_lang])) : '';

            $formula[$id_lang] = isset($formulas[$id_lang]) ? trim($formulas[$id_lang]) : '';
            $carrier[$id_lang] = isset($carriers[$id_lang]) ? $carriers[$id_lang] : '';

            $currency[$id_lang] = isset($currencies[$id_lang]) ? $currencies[$id_lang] : '';
            $region[$id_lang] = isset($regions[$id_lang]) ? $regions[$id_lang] : '';

            $shipping_rule[$id_lang] = isset($shipping_rules[$id_lang]) ? $shipping_rules[$id_lang] : '';
            $tokenEurope = 1;

            if (!empty($merchantId[$id_lang]))
            {
                if (!(isset($amazonEurope) && intval($amazonEurope)))
                {
                    if (empty($awsKeyId[$id_lang]) && $id_lang == $language['id_lang'])
                        $error .= $this->l('You must fill your Amazon Web Service ID') . ' (' . $language['name'] . ')' . '<br /><br />';
                    if (empty($awsSecretKey[$id_lang]))
                        $error .= $this->l('You must fill your Amazon Secret Key') . ' (' . $language['name'] . ')' . '<br /><br />';

                    $tokenEurope = 1;
                }

                if (empty($marketPlaceId[$id_lang]) && $id_lang == $language['id_lang'])
                    $error .= $this->l('You must fill your MarketPlace ID') . ' (' . $language['name'] . ')' . '<br /><br />';

                if (empty($region[$id_lang]))
                    $error .= $this->l('Region must be selected') . ' (' . $language['name'] . ')' . '<br /><br />';
                if (empty($currency[$id_lang]))
                    $error .= $this->l('Currency must be selected') . ' (' . $language['name'] . ')' . '<br /><br />';

                if (empty($callback[$id_lang]))
                    $error .= $this->l('PHP CallBack must be set') . ' (' . $language['name'] . ')' . '<br /><br />';

                // Validate CallBack
                //
              $test_callback = str_replace('@', '1', $callback[$id_lang]);
                $test_callback = str_replace('\\', '', $test_callback);

                if (@eval($test_callback) === false)
                    $error .= $this->l('PHP CallBack is wrong, that will cause module malfunction !') . ' (' . $language['name'] . ')' . '<br /><br />';

                if (empty($formula[$id_lang]))
                    $error .= $this->l('Formula must be set') . ' (' . $language['name'] . ')' . '<br /><br />';

                if (!$carrier[$id_lang])
                    $error .= $this->l('You must choose a Carrier') . ' (' . $language['name'] . ')' . '<br /><br />';

                if (!$amazon_carriers[$id_lang])
                    $error .= $this->l('You must choose an Amazon Carrier') . ' (' . $language['name'] . ')' . '<br /><br />';

                if ($this->strategies)
                    if (isset($shipping_rule[$id_lang]) && !empty($shipping_rule[$id_lang]))
                    {
                        preg_match_all('/([0-9\. ]*,[0-9\. ]*;)/', $shipping_rule[$id_lang], $results);

                        if (!count($results[0]))
                            $error .= $this->l('The shipping rules seems to be wrong...') . ' (' . $language['name'] . ')' . '<br /><br />';
                    }
                    
            }
        }

        if (!isset($categories) || empty($categories))
            $error .= $this->l('Categories Tab must be configured !') . '<br />';

        if (!isset($order_state) || !intval($order_state))
            $error .= $this->l('Incoming order status must be set in the parameters tab !') . '<br />';

        if (!isset($send_state) || !intval($send_state))
            $error .= $this->l('Sent order status must be set in the parameters tab !') . '<br />';

        if (!isset($condition_map) || empty($condition_map['New']))
            $error .= $this->l('The condition map must be filled') . '<br />';


        if (isset($amazonEurope) && intval($amazonEurope) && isset($marketPlaceMaster) && empty($marketPlaceMaster))
            $error .= $this->l('Amazon Europe is set, you must define a Master Platform !') . '<br />';

        if (!empty($error))
            $this->_postErrors[] = $error;
        
        if ( unserialize(base64_decode(Configuration::get('AMAZON_DEBUG'))) )
        {
            $this->_html .= sprintf('<div class="conf confirm">Memory Peak: %.02f MB - Post Count: %s</div>', memory_get_peak_usage() / 1024 / 1024, count($_POST, COUNT_RECURSIVE)) ;  
        }            
    }
    
    
    private function _postProcess()
    {
        require_once(dirname(__FILE__) . '/classes/amazon.tools.class.php');

        $actives = Tools::getValue('actives');

        $merchantIds = Tools::getValue('merchantId');
        $marketPlaceIds = Tools::getValue('marketPlaceId');
        $awsKeyIds = Tools::getValue('awsKeyId');
        $awsSecretKeys = Tools::getValue('awsSecretKey');

        $currencies = Tools::getValue('marketPlaceCurrency');
        $regions = Tools::getValue('marketPlaceRegion');

        $formulas = Tools::getValue('formula');
        $outofstocks = Tools::getValue('outofstock');
        $callbacks = Tools::getValue('pcallback');
        $carriers = Tools::getValue('carrier');
        $amazon_carrier = Tools::getValue('amazon_carrier');
        $synch_fields = Tools::getValue('synch_field');
        $use_asins = Tools::getValue('use_asin');

        $categories = Tools::getValue('categoryBox');

        $order_state = Tools::getValue('order_state');
        $send_state = Tools::getValue('sent_state');
        $preparation_state = Tools::getValue('preparation_state');

        $fba_order_state = Tools::getValue('fba_order_state');
        $fba_send_state = Tools::getValue('fba_sent_state');
        $fba_preparation_state = Tools::getValue('fba_preparation_state');
        
        $warehouse  = Tools::getValue('warehouse');
        $shop       = Tools::getValue('shop');
        
        $carrier_default = Tools::getValue('carrier_default');

        $amazonEurope = Tools::getValue('amazonEurope');
        $marketPlaceMaster = Tools::getValue('marketPlaceMaster');

        $debugMode = Tools::getValue('debug');
        $debugMode = intval($debugMode) ? true : false;

        $fba = Tools::getValue('fba');
        $fba = intval($fba) ? true : false;

        $specials = Tools::getValue('specials');
        $specials = intval($specials) ? true : false;

        $taxes = Tools::getValue('taxes');
        $taxes = intval($taxes) ? true : false;

        $delete_products = Tools::getValue('delete_products');
        $delete_products = intval($delete_products) ? true : false;

        $stock_only = Tools::getValue('stock_only');
        $stock_only = intval($stock_only) ? true : false;

        $payment_region = Tools::getValue('payment_region');
        $payment_region = intval($payment_region) ? true : false;        
        
        $description_field = Tools::getValue('description_field'); 
        
        $dummy = Tools::getValue('dummy'); 
        $dummy_product = Tools::getValue('dummy_product'); 
        
        $force_import = Tools::getValue('force_import');
        $force_import = intval($force_import) ? true : false;

        $condition_map = Tools::getValue('condition_map');
        $shipping_rules = Tools::getValue('shipping_rules');

        $account_type = Tools::getValue('account_type');
        $title_format = Tools::getValue('title_format');

        $override_stds = Tools::getValue('overrides_std');
        $override_exps = Tools::getValue('overrides_exp');

        $brute_force = Tools::getValue('brute_force');
        $mapping = Tools::getValue('mapping');
        $features_mapping = Tools::getValue('features_mapping');
        
        $bulk_mode = Tools::getValue('bulk_mode');
        $bulk_mode = intval($bulk_mode) ? true : false;        
                
        /*
         * Save Profiles 
         */
        $profiles = Tools::getValue('profiles') ;
        $profile2category = Tools::getValue('profile2category') ;
        
        $active = array();

        $merchantId = array();
        $marketPlaceId = array();
        $awsKeyId = array();
        $awsSecretKey = array();

        $currency = array();
        $region = array();

        $outofstock = array();
        $callback = array();
        $formula = array() ;
        
        $carrier = array();
        $synch_field = array();
        $use_asin = array();

        $shipping_rule = array();

        $override_exp = array();
        $override_std = array();

        $productsCronUrl = array();
        $ordersCronUrl = array();
        $statusesCronUrl = array() ;
        $amazonTokens = array();

        // For post treatments ....
        //
        foreach (Amazon_Tools::languages() as $language)
        {
            $id_lang = $language['id_lang'];

            if (!(isset($actives[$id_lang]) && intval($actives[$id_lang])))
                continue;

            $active[$id_lang] = isset($actives[$id_lang]) ? intval($actives[$id_lang]) : '';

            $merchantId[$id_lang] = isset($merchantIds[$id_lang]) ? trim($merchantIds[$id_lang]) : '';
            $marketPlaceId[$id_lang] = isset($marketPlaceIds[$id_lang]) ? trim($marketPlaceIds[$id_lang]) : '';
            $awsKeyId[$id_lang] = isset($awsKeyIds[$id_lang]) ? trim($awsKeyIds[$id_lang]) : '';
            $awsSecretKey[$id_lang] = isset($awsSecretKeys[$id_lang]) ? trim($awsSecretKeys[$id_lang]) : '';

            $currency[$id_lang] = isset($currencies[$id_lang]) ? $currencies[$id_lang] : '';
            $region[$id_lang] = isset($regions[$id_lang]) ? $regions[$id_lang] : '';

            $outofstock[$id_lang] = isset($outofstocks[$id_lang]) ? trim($outofstocks[$id_lang]) : '';
            $callback[$id_lang] = isset($callbacks[$id_lang]) ? str_replace('\\', '', trim($callbacks[$id_lang])) : '';

            $formula[$id_lang] = isset($formulas[$id_lang]) ? trim($formulas[$id_lang]) : '';

            $carrier[$id_lang] = isset($carriers[$id_lang]) ? $carriers[$id_lang] : '';
            $amazon_carrier[$id_lang] = isset($amazon_carrier[$id_lang]) ? $amazon_carrier[$id_lang] : '';

            $synch_field[$id_lang] = isset($synch_fields[$id_lang]) ? $synch_fields[$id_lang] : '';

            $use_asin[$id_lang] = isset($use_asins[$id_lang]) ? $use_asins[$id_lang] : '';

            $shipping_rule[$id_lang] = isset($shipping_rules[$id_lang]) ? $shipping_rules[$id_lang] : '';

            $override_std[$id_lang] = isset($override_stds[$id_lang]) ? $override_stds[$id_lang] : '';
            $override_exp[$id_lang] = isset($override_exps[$id_lang]) ? $override_exps[$id_lang] : '';

            // Cron Token
            //
            $token = md5($awsSecretKeys[$id_lang]);
            
            if ( isset($marketPlaceId[$id_lang]) && Amazon_Tools::isEuropeMarketplaceId( $marketPlaceId[$id_lang] ) && $marketPlaceMaster )
            {
                $region2id_lang = array_flip($regions);
                $europeIdLang = isset($region2id_lang[$marketPlaceMaster]) ? $region2id_lang[$marketPlaceMaster] : NULL;

                $token = md5($awsSecretKeys[$europeIdLang]);

                $productsCronUrl[$id_lang] = Amazon_Tools::getHttpHost(true, true) . __PS_BASE_URI__ . basename(_PS_MODULE_DIR_) . '/' . $this->name . '/functions/products.php?cron=1&action=update&lang=' . $region[$id_lang] . '&europe=' . $amazonEurope . '&cron_token=' . $token;
                $ordersCronUrl[$id_lang] = Amazon_Tools::getHttpHost(true, true) . __PS_BASE_URI__ . basename(_PS_MODULE_DIR_) . '/' . $this->name . '/functions/import.php?cron=1&lang=' . $region[$id_lang] . '&europe=' . $amazonEurope . '&cron_token=' . $token;
                
                if ( $marketPlaceMaster == Language::getIsoById($id_lang) )
                    $statusesCronUrl[$id_lang] = Amazon_Tools::getHttpHost(true, true) . __PS_BASE_URI__ . basename(_PS_MODULE_DIR_) . '/' . $this->name . '/functions/status.php?cron=1&lang=' . $language['iso_code'] . '&europe=' . $amazonEurope . '&cron_token=' . $token;
                else 
                    $statusesCronUrl[$id_lang] = 'N/A' ;
            }
            elseif ( isset($marketPlaceId[$id_lang]) && Amazon_Tools::isEuropeMarketplaceId( $marketPlaceId[$id_lang] ) && ! $marketPlaceMaster )
            {
                $productsCronUrl[$id_lang] = Amazon_Tools::getHttpHost(true, true) . __PS_BASE_URI__ . basename(_PS_MODULE_DIR_) . '/' . $this->name . '/functions/products.php?cron=1&action=update&lang=' . $region[$id_lang] . '&cron_token=' . $token;
                $ordersCronUrl[$id_lang] = Amazon_Tools::getHttpHost(true, true) . __PS_BASE_URI__ . basename(_PS_MODULE_DIR_) . '/' . $this->name . '/functions/import.php?cron=1&lang=' . $region[$id_lang] . '&cron_token=' . $token;
                $statusesCronUrl[$id_lang] = Amazon_Tools::getHttpHost(true, true) . __PS_BASE_URI__ . basename(_PS_MODULE_DIR_) . '/' . $this->name . '/functions/status.php?cron=1&lang=' . $language['iso_code'] . '&cron_token=' . $token;
            }
            elseif ( isset($marketPlaceId[$id_lang]) && ! Amazon_Tools::isEuropeMarketplaceId( $marketPlaceId[$id_lang] ) )
            {
                $productsCronUrl[$id_lang] = Amazon_Tools::getHttpHost(true, true) . __PS_BASE_URI__ . basename(_PS_MODULE_DIR_) . '/' . $this->name . '/functions/products.php?cron=1&action=update&lang=' . $language['iso_code'] . '&cron_token=' . $token;
                $ordersCronUrl[$id_lang] = Amazon_Tools::getHttpHost(true, true) . __PS_BASE_URI__ . basename(_PS_MODULE_DIR_) . '/' . $this->name . '/functions/import.php?cron=1&lang=' . $language['iso_code'] . '&cron_token=' . $token;
                $statusesCronUrl[$id_lang] = Amazon_Tools::getHttpHost(true, true) . __PS_BASE_URI__ . basename(_PS_MODULE_DIR_) . '/' . $this->name . '/functions/status.php?cron=1&lang=' . $language['iso_code'] . '&cron_token=' . $token;
            }
            else
            {
                $productsCronUrl[$id_lang] = 'N/A';
                $ordersCronUrl[$id_lang] = 'N/A';
                $statusesCronUrl[$id_lang] = 'N/A';
            }
            $amazonTokens[$id_lang] = $token;
        }

        self::configurationUpdateValue('AMAZON_ACTIVE', base64_encode(serialize($active)));
        self::configurationUpdateValue('AMAZON_MERCHANT_ID', base64_encode(serialize($merchantId)));
        self::configurationUpdateValue('AMAZON_MARKETPLACE_ID', base64_encode(serialize($marketPlaceId)));
        self::configurationUpdateValue('AMAZON_AWS_KEY_ID', base64_encode(serialize($awsKeyId)));
        self::configurationUpdateValue('AMAZON_SECRET_KEY', base64_encode(serialize($awsSecretKey)));

        self::configurationUpdateValue('AMAZON_CURRENCY', base64_encode(serialize($currency)));
        self::configurationUpdateValue('AMAZON_REGION', base64_encode(serialize($region)));

        self::configurationUpdateValue('AMAZON_OUT_OF_STOCK', base64_encode(serialize($outofstock)));
        self::configurationUpdateValue('AMAZON_PRICE_FORMULA', base64_encode(serialize($formula)));
        self::configurationUpdateValue('AMAZON_PRICE_CALLBACK', base64_encode(serialize($callback)));
        self::configurationUpdateValue('AMAZON_CARRIER', base64_encode(serialize($carrier)));
        self::configurationUpdateValue('AMAZON_AMAZON_CARRIER', base64_encode(serialize($amazon_carrier)));

        self::configurationUpdateValue('AMAZON_FIELD', base64_encode(serialize($synch_field)));
        self::configurationUpdateValue('AMAZON_USE_ASIN', base64_encode(serialize($use_asin)));

        self::configurationUpdateValue('AMAZON_CATEGORIES', base64_encode(serialize($categories)));
        self::configurationUpdateValue('AMAZON_PROFILES', base64_encode(serialize($profiles)));
        self::configurationUpdateValue('AMAZON_PROFILES_CATEGORIES', base64_encode(serialize($profile2category)));        

        self::configurationUpdateValue('AMAZON_ORDER_STATE', base64_encode(serialize($order_state)));
        self::configurationUpdateValue('AMAZON_PREPARATION_STATE', base64_encode(serialize($preparation_state)));
        self::configurationUpdateValue('AMAZON_SENT_STATE', base64_encode(serialize($send_state)));

        self::configurationUpdateValue('AMAZON_FBA_ORDER_STATE', (int)$fba_order_state);
        self::configurationUpdateValue('AMAZON_FBA_PREPARATION_STATE', (int)$fba_preparation_state);
        self::configurationUpdateValue('AMAZON_FBA_SENT_STATE', (int)$fba_send_state);
        
        self::configurationUpdateValue('AMAZON_WAREHOUSE', (int)$warehouse);
        self::configurationUpdateValue('AMAZON_SHOP', (int)$shop);
        
        self::configurationUpdateValue('AMAZON_CARRIER_DEFAULT', base64_encode(serialize($carrier_default)));

        self::configurationUpdateValue('AMAZON_EUROPE', base64_encode(serialize($amazonEurope)));
        self::configurationUpdateValue('AMAZON_MASTER', base64_encode(serialize($marketPlaceMaster)));

        self::configurationUpdateValue('AMAZON_DEBUG', base64_encode(serialize($debugMode)));

        self::configurationUpdateValue('AMAZON_FBA', $fba);
        self::configurationUpdateValue('AMAZON_SPECIALS', base64_encode(serialize($specials)));
        self::configurationUpdateValue('AMAZON_TAXES', base64_encode(serialize($taxes)));

        self::configurationUpdateValue('AMAZON_CONDITION_MAP', base64_encode(serialize($condition_map)));

        self::configurationUpdateValue('AMAZON_SHIPPING_RULES', base64_encode(serialize($shipping_rule)));

        self::configurationUpdateValue('AMAZON_ACCOUNT_TYPE', base64_encode(serialize($account_type)));
        self::configurationUpdateValue('AMAZON_TITLE_FORMAT', base64_encode(serialize($title_format)));

        self::configurationUpdateValue('AMAZON_SHIPPING_OVERRIDES_STD', base64_encode(serialize($override_std)));
        self::configurationUpdateValue('AMAZON_SHIPPING_OVERRIDES_EXP', base64_encode(serialize($override_exp)));

        self::configurationUpdateValue('AMAZON_CRON_PRODUCTS', base64_encode(serialize($productsCronUrl)));
        self::configurationUpdateValue('AMAZON_CRON_ORDERS', base64_encode(serialize($ordersCronUrl)));
        self::configurationUpdateValue('AMAZON_CRON_STATUSES', base64_encode(serialize($statusesCronUrl)));        
        self::configurationUpdateValue('AMAZON_CRON_TOKEN', base64_encode(serialize($amazonTokens)));

        self::configurationUpdateValue('AMAZON_DELETE_PRODUCTS', base64_encode(serialize($delete_products)));
        self::configurationUpdateValue('AMAZON_STOCK_ONLY', base64_encode(serialize($stock_only)));
        self::configurationUpdateValue('AMAZON_BULK_MODE', $bulk_mode);
        self::configurationUpdateValue('AMAZON_FORCE_IMPORT', base64_encode(serialize($force_import)));
        self::configurationUpdateValue('AMAZON_PAYMENT_REGION', $payment_region);

        self::configurationUpdateValue('AMAZON_BRUTE_FORCE', base64_encode(serialize($brute_force)));

        self::configurationUpdateValue('AMAZON_DESCRIPTION_FIELD', $description_field);

        self::configurationUpdateValue('AMAZON_DUMMY', (int)$dummy);
        self::configurationUpdateValue('AMAZON_DUMMY_PRODUCT', $dummy_product);

        self::configurationUpdateValue('AMAZON_ATTRIBUTES_MAPPING_L', base64_encode(serialize($mapping['prestashop'])));
        self::configurationUpdateValue('AMAZON_ATTRIBUTES_MAPPING_R', base64_encode(serialize($mapping['amazon']))); 

        self::configurationUpdateValue('AMAZON_FEATURES_MAPPING_L', base64_encode(serialize($features_mapping['prestashop'])));
        self::configurationUpdateValue('AMAZON_FEATURES_MAPPING_R', base64_encode(serialize($features_mapping['amazon'])));         
        
        if ( isset($profiles) && count($profiles) )
        {
            $this->_saveProfiles($profiles) ;
        }
        
        // Tables Updates
        //
        if (!$this->_addMarketPlaceTables())
            $this->_postErrors[] = 'install tables failed';

        if (!$this->_addMarketPlaceField())
            $this->_postErrors[] = 'install marketplace fields failed';

        $this->_hookSetup(self::Add) ;
        
        if (!$this->_postErrors)
            $this->_html .= '<div class="conf confirm">' . $this->l('Configuration updated') . '</div>';
    }
    
    private function _saveProfiles($profiles) 
    {
        require_once(_PS_MODULE_DIR_ . 'amazon/validate/Node.php'); 
        require_once(_PS_MODULE_DIR_ . 'amazon/validate/XmlDataType.php'); 
        require_once(_PS_MODULE_DIR_ . 'amazon/validate/XmlRestriction.php'); 
        require_once(_PS_MODULE_DIR_ . 'amazon/validate/AmazonXSD.php'); //gets code for Amazon XML Schemas
        require_once(_PS_MODULE_DIR_ . 'amazon/validate/AmazonValidator.php'); 
        require_once(_PS_MODULE_DIR_ . 'amazon/validate/Tools.php'); 
        
        $profiles['parameters'] = array() ;
        $profiles['attributes'] = array() ;
        
        if ( $profiles['name'] )
            foreach($profiles['name'] as $id => $profile)
            {
                if ( ! isset($profiles['name'][$id]) || empty($profiles['name'][$id]) ) continue ;
                if ( ! isset($profiles['universe'][$id]) || empty($profiles['universe'][$id]) ) continue ;
                #if ( ! isset($profiles['product_type'][$id]) || empty($profiles['product_type'][$id]) ) continue ;

                $category = $profiles['universe'][$id] ;

                # Here is saved the configuration
                try
                {
                    $productFactory = new AmazonXSD($category.'.xsd');
                    $productInstance = $productFactory->getInstance();
                    $xsdStructure = array();

                    $referenceElement = $profiles['product_type'][$id] ? $profiles['product_type'][$id] : null ;
                
                    if($category!="CE" || $category != "Consumers Electronics"):
                            foreach( array( 'ProductType', 'ClothingType', 'VariationData', 
                                            'Parentage', 'VariationTheme', 'Color', 'ColorMap', 
                                            'Size', 'SizeMap', 'ColorName', 'SizeName') as $searchedElement ):
                            if ( ($path = AmazonXSD_Tools::searchPath($productInstance, $searchedElement, $referenceElement)) ):                              
                                $profiles['parameters'][$id][$searchedElement] = $path ; 
                            endif;
                            endforeach;
                    else:
                        foreach( array( 'ProductType') as $searchedElement ):
                            if ( ($path = AmazonXSD_Tools::searchPath($productInstance, $searchedElement, $referenceElement)) ):                              
                                $profiles['parameters'][$id][$searchedElement] = $path ; 
                            endif;
                            endforeach;
                    endif;
                    // Add to the path the mandatory fields 
                    //
                    if ( isset($profiles['extra'][$profile]['field']) && $profiles['extra'][$profile]['field'] )
                        foreach($profiles['extra'][$profile]['field'] as $field => $value)
                        {
                            $path = AmazonXSD_Tools::searchPath($productInstance, $field, $referenceElement) ;

                            // Modified in products.php :
                                // 2013-03-16
                                // Skipping null values

                            /*
                            if ( isset($profiles['extra'][$profile]['attributes'][$field]))
                                    foreach($profiles['extra'][$profile]['attributes'][$field] as $attr => $values)
                                            if ( ! $values )     unset($profiles['extra'][$profile]['attributes'][$field]) ;
                            */
                            if ( $path )
                                $profiles['parameters'][$id][$field] = $path ;
                        }  
                    // Add path for specifics variants (eg: Jewelry) - Added: 2013-03-18
                    //   
                    if ( isset($profiles['extra'][$profile]['field']['variant']) && isset($profiles['extra'][$profile]['variant']) )
                    {
                       foreach($profiles['extra'][$profile]['variant'][ $profiles['extra'][$profile]['field']['variant'] ] as $tagName => $value) 
                       {
                           $path = AmazonXSD_Tools::searchPath($productInstance, $tagName, $referenceElement) ;
                           
                           if ( $path )
                                $profiles['parameters'][$id][$tagName] = $path ;                           
                       }
                    }
                        
                    $profiles['category'][$id] = $category ;
                }
                catch(Exception $e)
                {
                    $this->_postErrors[] = $this->l('Amazon XSD Exception :') . $e->getMessage() ;
                }            
            }

        if ( $profiles && is_array($profiles) && count($profiles) )
        {    
            self::configurationUpdateValue('AMAZON_PROFILES', base64_encode(serialize($profiles))) ;
        } 
    }
    
    // New function (2013-03) to handle the configuration content
    //
    private function _loadSettings()
    {
        $this->config['order_state']        = unserialize(base64_decode(Configuration::get('AMAZON_ORDER_STATE')));
        $this->config['preparation_state']  = unserialize(base64_decode(Configuration::get('AMAZON_PREPARATION_STATE')));
        $this->config['send_state']         = unserialize(base64_decode(Configuration::get('AMAZON_SENT_STATE')));

        // FBA Settings
        $this->config['fba_order_state']        = Configuration::get('AMAZON_FBA_ORDER_STATE') ;
        $this->config['fba_preparation_state']  = Configuration::get('AMAZON_FBA_PREPARATION_STATE') ;
        $this->config['fba_send_state']         = Configuration::get('AMAZON_FBA_SENT_STATE') ;        
        
        // PS 1.5 - Warehouse for Advanced stock management
        $this->config['warehouse']              = Configuration::get('AMAZON_WAREHOUSE') ;       

        // Shop
        $this->config['shop']               = Configuration::get('AMAZON_SHOP') ;    
       
        $this->config['dummy']              = Configuration::get('AMAZON_DUMMY') ;
        $this->config['dummy_product']      = Configuration::get('AMAZON_DUMMY_PRODUCT') ;
        $this->config['description_field']  = Configuration::get('AMAZON_DESCRIPTION_FIELD') ;
        $this->config['FBA']                = Configuration::get('AMAZON_FBA') ;
        $this->config['bulk_mode']          = Configuration::get('AMAZON_BULK_MODE') ;
        
        // Hidden Settings
        $this->config['hidden_settings']    = Configuration::get('AMAZON_HIDDEN_SETTINGS') ;
        $this->config['payment_region']     = Configuration::get('AMAZON_PAYMENT_REGION') ;
    }
    public function getContent()
    {
        $this->_html .= '<h2>' . $this->displayName . '</h2>';

        if (Tools::isSubmit('submit'))
        {
            $this->_postValidation();

            if (!sizeof($this->_postErrors))
                $this->_postProcess();
            else
            {
                $this->_postProcess();
                foreach ($this->_postErrors AS $err)
                {
                    $this->_html .= '<div class="alert error">' . $err . '</div>';
                }
            }
        }
        $this->_displayForm();

        return $this->_html;
    }

    private function _displayForm()
    {
        global $cookie;

        require_once(dirname(__FILE__) . '/classes/amazon.product.class.php');
        
        $this->_loadSettings() ;
       
        // Menu Tabs
        //
        $this->_html .= $this->_js();
    
        if ( version_compare(_PS_VERSION_,'1.5','>=') )
            $this->_html .= '<style type="text/css">hr { height:1px;border-bottom: 1px solid silver }</style>' ;

        $default_lang = strtolower(Language::getIsoById(Configuration::get('PS_LANG_DEFAULT'))) ;
    
        if ( $default_lang == 'fr' )
        {
            $documentation = $this->url . 'documentation/documentation.pdf' ;
            $faq = $this->url . 'documentation/faq_fr.pdf' ;
        }
        else
        {
            $documentation = $this->url . 'documentation/documentation-en.pdf' ;
            $faq = $this->url . 'documentation/faq_en.pdf' ;
        }
    
        $this->_html .= '

        <div style="text-align:right">
        <img src="' . $this->images . 'amazon.png" alt="' . $this->l('Amazon Market Place') . '" />
        </div>
            <fieldset>
                <legend><img src="../modules/amazon/images/a16.gif" alt="" class="middle" />' . $this->l('Amazon Market Place') . '</legend>

        <label>' . $this->l('Amazon Market Place') . ' v' . $this->version . '</label>
        <div class="margin-form">
        <p>' . $this->description . ' </p>
        <p>' . $this->l('The following features are provided with this module :') . '</p>
        <p>&nbsp;&nbsp;- ' . $this->l('Retrieve Orders from the Market Place by Web Service') . '</p>
        <p>&nbsp;&nbsp;- ' . $this->l('Update Orders Status in the Market Place by Web Service') . '</p>
        <p>&nbsp;&nbsp;- ' . $this->l('Update & Create Products in the Market Place') . '</p>
        </div>
      </fieldset>
      <br />';
      
        $this->_tabs();

        $this->_content();

        if ( unserialize(base64_decode(Configuration::get('AMAZON_DEBUG'))) )
        {
            $this->_html .= sprintf('<div class="conf confirm">Memory Peak: %.02f MB</div>', memory_get_peak_usage() / 1024 / 1024) ;  
        }  

    }

  

    //
    // JS For Tabs
    //
    private function _js()
    {
        $jsModule = $this->url . 'js/amazon.js';

        $html = '';
        $html .= '<script type="text/javascript" src="' . $jsModule . '?path=' . $this->url . '"></script>';

        return($html);
    }

    // Tabs
    //
    private function _tabs()
    {
        $selected_tab = $this->_selected_tab();

        $this->_html .= '
            <div style="clear:both"></div>
            <ul id="menuTab">';
        $i = 0;

        foreach (Amazon_Tools::languages() as $language)
        {
            $this->_html .= '<li id="menu-' . $language['iso_code'] . '" class="menuTabButton ' . ($selected_tab == $language['iso_code'] ? 'selected' : '') . '"><span>&nbsp;<img src="' . $this->images . 'geo_flags/' . $language['iso_code'] . '.gif" alt="' . $language['name'] . '" />&nbsp;' . preg_replace('/ .*/', '', $language['name']) . '</span>  </li>';
            $i++;
        }

        // General Parameters Tab
        //
        $this->_html .= '<li id="menu-parameters" class="menuTabButton ' . ($selected_tab == 'parameters' ? 'selected' : '') . '"><span>&nbsp;<img src="' . $this->images . 'cog.gif" alt="' . $this->l('Parameters') . '" />&nbsp;' . $this->l('Parameters') . '</span>  </li>';

        // Categories Tab
        //
        $this->_html .= '<li id="menu-categories" class="menuTabButton ' . ($selected_tab == 'categories' ? 'selected' : '') . '"><span>&nbsp;<img src="' . $this->images . 'tab-categories.gif" alt="' . $this->l('Categories') . '" />&nbsp;' . $this->l('Categories') . '</span>  </li>';

        // Profiles Tab
        //
        $this->_html .= '<li id="menu-profiles" class="menuTabButton ' . ($selected_tab == 'profiles' ? 'selected' : '') . '"><span>&nbsp;<img src="' . $this->images . 'profiles.png" alt="' . $this->l('Profiles') . '" />&nbsp;' . $this->l('Profiles') . '</span>  </li>';

        // Mapping Tabs
        //
        $this->_html .= '<li id="menu-mapping" class="menuTabButton ' . ($selected_tab == 'mapping' ? 'selected' : '') . '"><span>&nbsp;<img src="' . $this->images . 'mapping.png" alt="' . $this->l('Mappings') . '" />&nbsp;' . $this->l('Mappings') . '</span>  </li>';
        

        $this->_html .= '
          </ul>
    ';
    }

    private function _selected_tab()
    {
        global $cookie;
        return(($selected_tab = Tools::getValue('selected_tab')) ? $selected_tab : ($cookie->id_lang ? strtolower(Language::getIsoById($cookie->id_lang)) : strtolower(Language::getIsoById(Configuration::get('PS_LANG_DEFAULT')))));
    }

    //
    // Form validation button
    //
    private function _validate()
    {
        $this->_html .= '
     <div class="margin-form">
        <br />
          <input type="submit" name="submit" style="float:right;margin:10px 50px 20px 0" value="' . $this->l('Save the Configuration') . '" class="button" />
        <br />
     </div>
    ';
    }

    // Tabs content
    //
  private function _content()
    {
        $selected_carrier_tab = $this->_selected_tab();

        // Langue Active
        //
        $actives = unserialize(base64_decode(Configuration::get('AMAZON_ACTIVE')));

        // Acc s API
        //
        $merchantIds = unserialize(base64_decode(Configuration::get('AMAZON_MERCHANT_ID')));
        $marketPlaceIds = unserialize(base64_decode(Configuration::get('AMAZON_MARKETPLACE_ID')));
        $awsKeyIds = unserialize(base64_decode(Configuration::get('AMAZON_AWS_KEY_ID')));
        $awsSecretKeys = unserialize(base64_decode(Configuration::get('AMAZON_SECRET_KEY')));

        // Field for Synch
        //
        $amazonFields = unserialize(base64_decode(Configuration::get('AMAZON_FIELD')));

        $nb = '<span style="color:red;">&nbsp;*</span>';

        $this->_html .= '
        <form action="' . $_SERVER['REQUEST_URI'] . '" method="post">
        <input type="hidden" name="selected_tab" value="' . $selected_carrier_tab . '" />
        <input type="hidden" id="check_url" value="' . $this->url . 'functions/check.php" />
        <input type="hidden" id="check_msg_region" value="' . $this->l('You must select a platform before') . '" />
        <input type="hidden" id="check_msg_currency" value="' . $this->l('You must select a currency before') . '" />
        <div style="clear:both"></div>
        <fieldset>';

        $this->_html .= '
        <div id="tabList">';

        foreach (Amazon_Tools::languages() as $language)
        {
            $id_lang = $language['id_lang'];

            $this->_html .= '
                 <div id="menudiv-' . $language['iso_code'] . '"  class="tabItem ' . ($selected_carrier_tab == $language['iso_code'] ? 'selected' : '') . '">
                 <input type="hidden" name="id_lang" id="lang-' . $id_lang . '" value="' . $language['iso_code'] . '" />
                    <br />';

            $active = isset($actives[$id_lang]) ? intval($actives[$id_lang]) : '';

            $merchantId = isset($merchantIds[$id_lang]) ? trim($merchantIds[$id_lang]) : '';
            $marketPlaceId = isset($marketPlaceIds[$id_lang]) ? trim($marketPlaceIds[$id_lang]) : '';
            $awsKeyId = isset($awsKeyIds[$id_lang]) ? trim($awsKeyIds[$id_lang]) : '';
            $awsSecretKey = isset($awsSecretKeys[$id_lang]) ? trim($awsSecretKeys[$id_lang]) : '';

            $carriers = Carrier::getCarriers($id_lang);

            // Stock
            //
              $outOfStocks = unserialize(base64_decode(Configuration::get('AMAZON_OUT_OF_STOCK')));

            // Price Formula and Callback
            //
              $formulas = unserialize(base64_decode(Configuration::get('AMAZON_PRICE_FORMULA')));
            $callbacks = unserialize(base64_decode(Configuration::get('AMAZON_PRICE_CALLBACK')));

            // Carriers
            //
              $selected_carriers = unserialize(base64_decode(Configuration::get('AMAZON_CARRIER')));

            $amazon_carriers = unserialize(base64_decode(Configuration::get('AMAZON_AMAZON_CARRIER')));

            $outOfStock = isset($outOfStocks[$id_lang]) ? $outOfStocks[$id_lang] : '';
            $formula = isset($formulas[$id_lang]) ? $formulas[$id_lang] : '';
            $callback = isset($callbacks[$id_lang]) ? $callbacks[$id_lang] : '';
            $selected_carrier = isset($selected_carriers[$id_lang]) ? $selected_carriers[$id_lang] : '';
            $amazon_carrier = isset($amazon_carriers[$id_lang]) ? $amazon_carriers[$id_lang] : '';
            $amazonField = isset($amazonFields[$id_lang]) ? $amazonFields[$id_lang] : '';


            // Defaults Marketplace Settings
            //
              if (empty($marketPlaceId))
            {
                switch ($language['iso_code'])
                {
                    case 'ca' : // Canada
                        $marketPlaceId = 'A2EUQ1WTGCTBG2' ;
                        break ;
                    case 'en' : // US
                        $marketPlaceId = 'ATVPDKIKX0DER';
                        break;
                    case 'fr' : // France
                        $marketPlaceId = 'A13V1IB3VIYZZH';
                        break;
                    case 'es' : // Spain
                        $marketPlaceId = 'A1RKKUPIHCS9HS';
                        break;              
                    case 'de' : // Germany
                        $marketPlaceId = 'A1PA6795UKMFR9';
                        break;
                    case 'it' : // Italy
                        $marketPlaceId = 'APJ6JRA9NG5V4';
                        break;
                    case 'uk' : // UK
                    case 'gb' : // UK
                        $marketPlaceId = 'A1F83G8C2ARO7P';
                        break;
                    case 'jp' : // Japan
                        $marketPlaceId = 'A1VC38T7YXB528' ;
                        break ;
                        
                }
            }
            // API Settings
            //
              $this->_apicodes($language, $active, $merchantId, $marketPlaceId, $awsKeyId, $awsSecretKey);

            // Locales
            //
              $region = unserialize(base64_decode(Configuration::get('AMAZON_REGION')));
            $currency = unserialize(base64_decode(Configuration::get('AMAZON_CURRENCY')));

            // For Amazon Trader Module
            //
              $shipping_rules = unserialize(base64_decode(Configuration::get('AMAZON_SHIPPING_RULES')));
            $shipping_rule = isset($shipping_rules[$id_lang]) ? $shipping_rules[$id_lang] : '';

            // Shipping Overrides
            //
              $selected_carrier_override_stds = unserialize(base64_decode(Configuration::get('AMAZON_SHIPPING_OVERRIDES_STD')));
            $selected_carrier_override_std = isset($selected_carrier_override_stds[$id_lang]) ? $selected_carrier_override_stds[$id_lang] : '';

            $selected_carrier_override_exps = unserialize(base64_decode(Configuration::get('AMAZON_SHIPPING_OVERRIDES_EXP')));
            $selected_carrier_override_exp = isset($selected_carrier_override_exps[$id_lang]) ? $selected_carrier_override_exps[$id_lang] : '';

            $productsCronUrls = unserialize(base64_decode(Configuration::get('AMAZON_CRON_PRODUCTS')));
            $productsCronUrl = isset($productsCronUrls[$id_lang]) ? $productsCronUrls[$id_lang] : '';

            $ordersCronUrls = unserialize(base64_decode(Configuration::get('AMAZON_CRON_ORDERS')));
            $ordersCronUrl = isset($ordersCronUrls[$id_lang]) ? $ordersCronUrls[$id_lang] : '';

            $statusesCronUrls = unserialize(base64_decode(Configuration::get('AMAZON_CRON_STATUSES')));
            $statusesCronUrls = isset($statusesCronUrls[$id_lang]) ? $statusesCronUrls[$id_lang] : '';            
            
            $asinHasPrioritys = unserialize(base64_decode(Configuration::get('AMAZON_USE_ASIN')));
            $asinHasPriority = isset($asinHasPrioritys[$id_lang]) ? $asinHasPrioritys[$id_lang] : false;

            $this->_locales($language, $currency, $region);


            $carriers_default = unserialize(base64_decode(Configuration::get('AMAZON_CARRIER_DEFAULT')));
            $carrier_default[$id_lang] = isset($carriers_default[$id_lang]) ? $carriers_default[$id_lang] : false;

            
            // General Settings for this Platform
            //
            $this->_settings($language, $carriers, $amazon_carrier, $carrier_default, $outOfStock, $formula, $callback, $selected_carrier, $amazonField, $asinHasPriority, $shipping_rule, $selected_carrier_override_std, $selected_carrier_override_exp, $productsCronUrl, $ordersCronUrl, $statusesCronUrls);

            // Validate Button
            //
            $this->_validate();

            $this->_html .= '</div>'; // fin lang div
        }

        $this->_html .= '</div>'; // fin tabs div

        $amazonEurope = unserialize(base64_decode(Configuration::get('AMAZON_EUROPE')));
        $marketPlaceMaster = unserialize(base64_decode(Configuration::get('AMAZON_MASTER')));

        $defaultField = unserialize(base64_decode(Configuration::get('AMAZON_FIELD')));

        $debugMode = unserialize(base64_decode(Configuration::get('AMAZON_DEBUG')));
        $debugMode = intval($debugMode) ? true : false;

        $specials = unserialize(base64_decode(Configuration::get('AMAZON_SPECIALS')));
        $specials = intval($specials) ? true : false;

        $delete_products = unserialize(base64_decode(Configuration::get('AMAZON_DELETE_PRODUCTS')));
        $delete_products = intval($delete_products) ? true : false;

        $stock_only = unserialize(base64_decode(Configuration::get('AMAZON_STOCK_ONLY')));
        $stock_only = intval($stock_only) ? true : false;

        $force_import = unserialize(base64_decode(Configuration::get('AMAZON_FORCE_IMPORT')));
        $force_import = intval($force_import) ? true : false;

        $taxconf = Configuration::get('AMAZON_TAXES');

        if ($taxconf == null)
            $taxes = true;
        else
            $taxes = unserialize(base64_decode($taxconf));
        $taxes = intval($taxes) ? true : false;

        $conditionMap = unserialize(base64_decode(Configuration::get('AMAZON_CONDITION_MAP')));

        $account_type = unserialize(base64_decode(Configuration::get('AMAZON_ACCOUNT_TYPE')));
        
        if (!$account_type)
            $account_type = self::AccounTypeIndividual ;

        $title_format = unserialize(base64_decode(Configuration::get('AMAZON_TITLE_FORMAT')));
        if (!$title_format)
            $title_format = self::FormatTitle ;

        $this->_parameters($language, $amazonEurope, $marketPlaceMaster, $debugMode, $specials, $taxes, $conditionMap, $account_type, $delete_products, $force_import, $stock_only, $title_format);

        // Categories Tab
        //
        $default_categories = unserialize(base64_decode(Configuration::get('AMAZON_CATEGORIES')));
        $brute_force = unserialize(base64_decode(Configuration::get('AMAZON_BRUTE_FORCE')));
        $default_profiles2categories = unserialize(base64_decode(Configuration::get('AMAZON_PROFILES_CATEGORIES')));
        
        $this->_categories($default_categories, $default_profiles2categories, $brute_force);
        
        // Profiles
        //
        $profiles = @unserialize(base64_decode(Configuration::get('AMAZON_PROFILES')));
        
        $this->_profiles($profiles);

        // Mappings
        //
        $mapping_left = unserialize(base64_decode(Configuration::get('AMAZON_ATTRIBUTES_MAPPING_L')));
        $mapping_right = unserialize(base64_decode(Configuration::get('AMAZON_ATTRIBUTES_MAPPING_R')));

        $features_mapping_left = unserialize(base64_decode(Configuration::get('AMAZON_FEATURES_MAPPING_L')));
        $features_mapping_right = unserialize(base64_decode(Configuration::get('AMAZON_FEATURES_MAPPING_R')));
        
        $this->_mapping($mapping_left, $mapping_right, $features_mapping_left, $features_mapping_right, $actives);


        $this->_html .= '
            </fieldset>';

        $this->_html .= '
          <div class="margin-form">
          <p>' . $nb . '&nbsp;: ' . $this->l('These informations are provided by The Amazon Market Place please go to the following url to subscribe to these services') . ' : <a href="https://sellercentral.amazon.com" />https://sellercentral.amazon.com</a>
          </p>
          </form>
          </div>

      ';
    }

    private function _apicodes($language, $active, $merchantId, $marketPlaceId, $awsKeyId, $awsSecretKey)
    {
        $id_lang = $language['id_lang'];

        $nb = '<span style="color:red;">&nbsp;*</span>';

        $europe = unserialize(base64_decode(Configuration::get('AMAZON_EUROPE')));
        $master = unserialize(base64_decode(Configuration::get('AMAZON_MASTER')));
        $master_id_lang = 0;
        $marketPlaceRegion = unserialize(base64_decode(Configuration::get('AMAZON_REGION')));
        $masterPlatform = 0;

        if ($europe)
        {
            if ($marketPlaceRegion)
                foreach ($marketPlaceRegion as $language_id => $region)
                    if ($id_lang == $language_id && $master == $region)
                        $masterPlatform = 1;
        }

        if ($europe && !$masterPlatform && (Amazon_Tools::isEurope($language['iso_code']) || $marketPlaceId == 'A1F83G8C2ARO7P'))
        {
            $display = 'display:none;';
            $disabled = 'disabled';
        }
        else
        {
            $display = '';
            $disabled = '';
        }

        // Defaults Marketplace Settings
        //
        if (empty($marketPlaceId))
        {
            switch ($id_lang)
            {

                case '1' : // US
                    $marketPlaceId = 'ATVPDKIKX0DER';
                    break;
                case '2' : // France
                    $marketPlaceId = 'A13V1IB3VIYZZH';
                    break;
                case '3' : // Spain
                    $marketPlaceId = 'A1RKKUPIHCS9HS';
                    break;
                case '4' : // Germany
                    $marketPlaceId = 'A1PA6795UKMFR9';
                    break;
                case '5' : // Italy
                    $marketPlaceId = 'APJ6JRA9NG5V4';
                    break;
                case '6' : // UK
                    $marketPlaceId = 'A1F83G8C2ARO7P';
                    break;
            }
        }

        $this->_html .= '
      <div>
          <label style="color:grey;">' . $this->l('API Settings') . '</label>
          <div class="margin-form">
          <input type="checkbox" name="actives[' . $id_lang . ']" style="position:relative;top:+2px;" id="active-' . $language['iso_code'] . '" value="1" ' . ($active ? 'checked="checked"' : '') . ' /><span style="font-size:1.2em;color:black;">&nbsp;' . $this->l('Active') . '</span><br />
          </div>

          <label>' . $this->l('Country/Language') . '</label>
          <div class="margin-form">
          <span>&nbsp;<img src="' . $this->images . 'geo_flags/' . $language['iso_code'] . '.gif" alt="' . $language['name'] . '" />' . $language['name'] . '</span>
          </div>';

        $this->_html .= '
      <div style="' . $display . '">
        <label>' . $this->l('Merchant ID') . '</label>
        <div class="margin-form">
        <input type="text" name="merchantId[' . $id_lang . ']" style="width:300px;" value="' . $merchantId . '" />' . $nb . '
        <input type="hidden" name="marketPlaceLang[' . $id_lang . ']" value="' . $id_lang . '" ' . $disabled . ' />' . '
        </div>
      </div>';

        $this->_html .= '
      <label>' . $this->l('Market Place Id') . '</label>
      <div class="margin-form">
      <input type="text" name="marketPlaceId[' . $id_lang . ']" style="width:300px;" value="' . $marketPlaceId . '" />' . $nb . '
      </div>';

        $this->_html .= '
      <div style="' . $display . '">
          <label>' . $this->l('AWS Key Id') . '</label>
          <div class="margin-form">
          <input type="text" name="awsKeyId[' . $id_lang . ']" style="width:300px;" value="' . $awsKeyId . '" ' . $disabled . ' />' . $nb . '
          </div>
          <label>' . $this->l('AWS Secret Key') . '</label>
          <div class="margin-form">
          <input type="password" name="awsSecretKey[' . $id_lang . ']" style="width:300px;" value="' . $awsSecretKey . '" ' . $disabled . ' />' . $nb . '
          <p><strong>' . $this->l('MWS URL for Keypairs :') . '</strong> <a href="https://sellercentral.amazon.' . Amazon_Tools::idToDomain($id_lang) . '/gp/mws/index.html" target="_blank">https://sellercentral.amazon.' . Amazon_Tools::idToDomain($id_lang) . '/gp/mws/index.html</a></p>
          </div>

          <label>' . $this->l('API Check') . '</label>
          <div class="margin-form">
          <input type="button" class="button" id="check-' . $id_lang . '" value="' . $this->l('Check Connectivity') . '" />
          <img src="' . $this->images . 'small-loader.gif" alt="" class="check-loader" style="display:none" /><br /><br />
          <div class="server-response" id="server-response-' . $id_lang . '">&nbsp;</div>
          </div>

      </div>

      ';

        $this->_html .= '
          <hr class="amz-separator" />';


        $this->_html .= '
        </div>';
    }

    private function _settings($language, $carriers, $amazon_carrier, $carrier_default, $outOfStock, $formula, $callback, $selected_carriers, $defaultField, $asinHasPriority, $shipping_rule, $selected_override_std, $selected_override_exp, $productsCronUrl, $ordersCronUrl, $statusesCronUrls)
    {
        $id_lang = $language['id_lang'];

        // Fill with sample/default datas
        //
        if (empty($callback))   
        {
            if ($id_lang == 2)
                $callback = 'number_format(round(@,1), 2, ",",  "");';
            else
                $callback = 'number_format(round(@,1), 2, ".",  "");';
        }

        if (empty($outOfStock))
            $outOfStock = '0';
        if (empty($formula))
            $formula = '@';


        $this->_html .= '
        <label style="color:grey;">' . $this->l('General Settings') . '</label><br /><br />
        <label>' . $this->l('Out of Stock') . '</label>
        <div class="margin-form">
        <input type="text" name="outofstock[' . $id_lang . ']" value="' . $outOfStock . '" />
        <p>' . $this->l('Minimum of quantity in stock to export the product') . '</p>
        </div>
        <label>' . $this->l('Price Formula') . '</label>
        <div class="margin-form">
        <textarea name="formula[' . $id_lang . ']" rows="2" cols="80" />' . $formula . '</textarea>
        <p>' . $this->l('Formula to be applied on all the exported products prices (multiply, divide, addition, subtraction, percentages)') . '</p>
        <p>' . $this->l('Use the @ symbol as price reference (eg: @ + 10% mean you\'ll add 10% to the initial price)') . '</p>
        </div>

        <label>' . $this->l('Price CallBack') . '</label>
        <div class="margin-form">
        <textarea name="pcallback[' . $id_lang . ']" id="pcallback-' . $id_lang . '" class="ecallback-disabled" readonly="readonly" rows="2" cols="80" />' . $callback . '</textarea><input type="button" class="button bcallback" id="bcallback-' . $id_lang . '" value="' . $this->l('Edit Callback') . '" />
        <input type="hidden" id="callback-edit-warning" value="' . $this->l('Warning ! A wrong edition of that field may cause a malfunction in the module !') . '" />
        <p>' . $this->l('PHP Code to be applied to the price (for rounding, formating etc...)') . '</p>
        <p>' . $this->l('Use the @ symbol as price reference (eg: round(@, 2) mean you\'ll round to 2 decimals...)') . '</p>
        </div>';

        // Champ Utilisé pour la Synchronisation : EAN - UPC..
        //
      if (empty($defaultField))
            $defaultField = 'ean13';


        $this->_html .= '
          <label>' . $this->l('Synchronization Field') . '</label>
          <div class="margin-form">
          <select name="synch_field[' . $id_lang . ']" style="width:500px;">
            <option value="" disabled="disabled" />Choose one of the following</option>
            <option value="ean13" ' . ($defaultField == 'ean13' ? 'selected="selected"' : '') . '>EAN13 (Europe)</option>
            <option value="upc" ' . ($defaultField == 'upc' ? 'selected="selected"' : '') . '>UPC (United States)</option>
            <option value="both" ' . ($defaultField == 'both' ? 'selected="selected"' : '') . '>Both (EAN13 then UPC)</option>
            <option value="reference" ' . ($defaultField == 'reference' ? 'selected="selected"' : '') . '>SKU</option>
          </select>
          <p>' . $this->l('Choose the field which will be used for dealing with Amazon') . '</p>
          </div>
          ';


        if ($asinHasPriority)
            $checked = 'checked="checked" ';
        else
            $checked = '';

        // Use ASIN as Synch. Field
        //
      $this->_html .= '
          <label>' . $this->l('ASIN has the Priority') . '</label>
          <div class="margin-form">
          <input type="checkbox" name="use_asin[' . $id_lang . ']" ' . $checked . ' value="1" />&nbsp;<span style="position:relative;top:+2px">' . $this->l('Yes') . '</span>
          <p>' . $this->l('Use the ASIN field as synchronization field in priority if filled. This parameter could override the Synchronization Field.') . '</p>
          </div>
          ';

        $this->_html .= '
          <hr class="amz-separator" />';

        // Associated Carrier / Prestashop Side
        //

    $this->_html .= '
        <label style="color:grey">' . $this->l('Shipping') . '</label><br /><br />
        <input type="hidden" id="id-lang-' . $language['iso_code'] . '" value="' . $id_lang . '" />' ;
            

        // Default Carrier
        //
        $this->_html .= '
          <label>' . $this->l('Amazon Carrier') . '</label><br /><br />            
          <div class="margin-form">' ;
       
        $this->_html  .= '<select style="width:250px" name="carrier_default[' . $id_lang . ']">' ;
        
        foreach($this->carrier_codes as $carrier)
        {
            if ( $carrier == $carrier_default[$id_lang] )
                $selected = 'selected="selected"' ;
            else 
                $selected = '' ;
            $this->_html  .= '<option value="' . $carrier . '" ' . $selected . ' >' . $carrier . '</option>' . "\n" ;
        } 
        $this->_html  .= '</select>
            <p>' . $this->l('Select the default carrier which will be sent to Amazon on statuses changes') . '</p>
            </div>' ;        
        


    $this->_html .= '
        <label>' . $this->l('Shipping Methods') . '</label>
        <div class="margin-form">';

        for ($index = 0; $index < count($amazon_carrier); $index++)
        {
            $this->_html .= '
          <div id="carrier-group-' . $id_lang . '-' . $index . '" >

          <select name="carrier[' . $id_lang . '][]" style="width:250px;">
            <option disabled="disabled">' . $this->l('Choose an appropriate carrier for Amazon Orders') . '</option>';

            foreach ($carriers as $carrier)
            {
                if (isset($selected_carriers) && isset($selected_carriers[$index]) && intval($selected_carriers[$index] == $carrier['id_carrier']))
                    $selected = intval($selected_carriers[$index]);
                else
                    $selected = false;

                $this->_html .= '<option value="' . intval($carrier['id_carrier']) . '" ' . (intval($carrier['id_carrier']) == $selected ? 'selected="selected"' : '') . '>' . $carrier['name'] . '</option>';
            }
            $this->_html .= '</select>';

            $this->_html .= '
            <span style="position:relative;top:-8px;">&nbsp;&nbsp;
            <img src="' . $this->images . 'list-next.gif" alt="" />
            &nbsp;&nbsp;
          </span>';

            // Associated Carrier / Amazon Side
            //
   	$this->_html .= '
          <select name="amazon_carrier[' . $id_lang . '][]" style="width:250px;">
            <option disabled="disabled">' . $this->l('Choose the associated carrier on Amazon') . '</option>';

            $amazon_shipping_methods = array_merge($this->shipping_overrides_std, $this->shipping_overrides_exp);

            foreach ($amazon_shipping_methods as $carrier)
            {
                $selected = (isset($amazon_carrier[$index]) && md5($carrier) == $amazon_carrier[$index] ? 'selected="selected"' : '');

                $this->_html .= '<option value="' . md5($carrier) . '" ' . $selected . '>' . $carrier . '</option>';
            }
            $displayDel = $index == 0 ? 'style="display:none"' : '';
            $displayAdd = $index > 0 ? 'style="display:none"' : '';

            $this->_html .= '</select>&nbsp;&nbsp;
              <img src="' . $this->images . 'add.png" class="addnewcarrier"  rel="' . $index . '"  alt="' . $this->l('Add a new carrier') . '" ' . $displayAdd . ' />
              <img src="' . $this->images . 'delete.gif" class="removecarrier"  rel="' . $index . '"  alt="' . $this->l('Add a new carrier') . '" ' . $displayDel . ' />
          <br />
          </div><!-- div carrier group -->';
        }
        $this->_html .= '
        <div id="new-carriers-' . $id_lang . '"></div>';


        $this->_html .= '
        <p>' . $this->l('Associated carrier, usefull to display your preferate carrier on the order page and on the invoice') . '<br />
        </div>';

        // Shipping Overrides
        //
    $this->_html .= '
        <label style="color:grey">' . $this->l('Shipping Overrides') . '</label>
        <div class="margin-form">
        <br />
        </div>
        <label style="clear:left;">' . $this->l('Standard') . '</label>
        <div class="margin-form">

        <select name="overrides_std[' . $id_lang . ']" style="width:500px;">
          <option disabled="disabled">' . $this->l('Choose one of the following') . '</option>';

        foreach ($this->shipping_overrides_std as $override)
        {
            $this->_html .= '<option value="' . $override . '" ' . ($override == $selected_override_std ? 'selected="selected"' : '') . '>' . $override . '</option>';
        }
        $this->_html .= '</select><br />';

        $this->_html .= '
        </div>';

        $this->_html .= '
        <label>' . $this->l('Express') . '</label>
        <div class="margin-form">

        <select name="overrides_exp[' . $id_lang . ']" style="width:500px;">
          <option disabled="disabled">' . $this->l('Choose one of the following') . '</option>';

        foreach ($this->shipping_overrides_exp as $override)
        {
            $this->_html .= '<option value="' . $override . '" ' . ($override == $selected_override_exp ? 'selected="selected"' : '') . '>' . $override . '</option>';
        }
        $this->_html .= '</select><br />';


        $this->_html .= '
        <p>' . $this->l('Shipping overrides to be used when selected in product sheet') . '<br />'
                . $this->l('Please refer to the documentation to choose the appropriate value') . '<br /></p>
        </div>';

        // Amazon Trader Module
        //
    if ($this->strategies)
        {
            // AMAZON_SHIPPING_RULES
            $this->_html .= '
            <br />
            <label>' . $this->l('Shipping Rules') . '</label>
            <div class="margin-form">
            <textarea name="shipping_rules[' . $id_lang . ']" rows="2" cols="80" />' . $shipping_rule . '</textarea>
            <p>' . $this->l('Used by the trader module to calculate the total price: product price + shipping price') . '<br />
                ' . $this->l('List of values separated by comma and semi columns: product price,shipping price;') . '<br />
                ' . $this->l('Example: 100,5;200,10;300,20 means the shipping price will be 5 for a product price up to 100 etc...') . '</p>
            </div>';
        }

        if ($productsCronUrl && $ordersCronUrl)
        {
            $this->_html .= '
                    <hr class="amz-separator" /><br />
                <label>' . $this->l('Cron URLs') . '</label>
                <div class="margin-form">
                <input type="text" style="background-color:#EFEFEF;width:600px;" value="' . $productsCronUrl . '" disabled />
                <p>' . $this->l('URL to synchronize products to be used to configure your crontab.') . '</p>' ;

            if ( $this->config['bulk_mode'] )
                $this->_html .= '
                    <input type="text" style="background-color:#EFEFEF;width:600px;" value="' . $statusesCronUrls . '" disabled />
                    <p>' . $this->l('URL to send statuses to be used to configure your crontab.') . '</p>' ;

            $this->_html .= '            
                <input type="text" style="background-color:#EFEFEF;width:600px;" value="' . $ordersCronUrl . '" disabled />
                <p>' . $this->l('URL to import orders to be used to configure your crontab.') . '<br />                    
                <span style="color:brown;font-weight:bold">' .
                            $this->l('Be carefull ! Importing orders by cron can skips somes orders (eg: out of stock), you must check also manually') . '</span></p>
                </div>
                    ';
        }
    }

    private function _locales($language, $mpCurrency, $mpRegion)
    {
        $id_lang = $language['id_lang'];

        $currencies = Currency::getCurrencies();

        $nb = '<span style="color:red;">&nbsp;*</span>';

        $this->_html .= '
      <div>
          <label style="color:grey;">' . $this->l('Locales') . '</label><br /><br />

          <label>' . $this->l('Platform') . '</label>
          <div class="margin-form">

          <select name="marketPlaceRegion[' . $id_lang . ']" style="width:280px">
            <option>' . $this->l('Choose the platform for this region') . '</option>';

        foreach ($this->_platforms as $iso_code => $platform)
        {
            if ($iso_code == (isset($mpRegion[$id_lang]) ? $mpRegion[$id_lang] : 'none'))
                $selected = 'selected="selected"';
            else
                $selected = '';

            $this->_html .= '<option value="' . $iso_code . '" ' . $selected . '>' . $platform . '</option>';
        }
        $this->_html .= '</select>' . $nb . '


          </div>
          <label>' . $this->l('Currency') . '</label>
          <div class="margin-form">

          <select name="marketPlaceCurrency[' . $id_lang . ']" style="width:280px">
            <option>' . $this->l('Choose the currency for this region') . '</option>';

        foreach ($currencies as $currency)
        {
            if ($currency['iso_code'] == (isset($mpCurrency[$id_lang]) ? $mpCurrency[$id_lang] : 'none'))
                $selected = 'selected="selected"';
            else
                $selected = '';

            $this->_html .= '<option value="' . strtoupper($currency['iso_code']) . '" ' . $selected . '>' . $currency['name'] . '</option>';
        }
        $this->_html .= '</select>' . $nb . '

          </div>
          <hr class="amz-separator" />';

        $this->_html .= '
        </div>';
    }

    private function _parameters($language, $mpAmazonEurope, $mpMasterPlatform, $debug, $specials, $taxes, $conditionMap, $account_type, $delete_products, $force_import, $stock_only, $title_format)
    {
        global $cookie;

        $id_lang = $cookie->id_lang;

        $selected_tab = $this->_selected_tab();

        $nb = '<span style="color:red;">&nbsp;*</span>';

        $this->_html .= '
        <div id="menudiv-parameters"  class="tabItem ' . ($selected_tab == 'parameters' ? 'selected' : '') . '">
      <br />';

        $this->_html .= '
          <label style="color:grey;">' . $this->l('Features') . '</label><br /><br />';

      $FBA = $this->config['FBA'] ; 
              
      // Amazon FBA
      //
      $this->_html .= '
      <label>' . $this->l('Active FBA Support') . '</label>
      <div class="margin-form">
      <input type="checkbox" name="fba" id="fba" value="1" ' . ($FBA ? 'checked="checked"' : '') . ' />&nbsp;<span style="color:black;font-size:12px;">&nbsp;' . $this->l('Yes') . '</span><br />
      <input type="hidden" id="text_fba" value="' . $this->l('Please save the configuration to display the FBA options') . '" />
      <p>' . $this->l('Add Fulfilled By Amazon (FBA) support to the module. Ask your Amazon\'s sells support for more informations about it') . '</p>
      </div>';        
      
      $this->_html .= '
            <hr class="amz-separator" />
            ';
      
      $this->_html .= '
          <label style="color:grey;">' . $this->l('General Settings') . '</label><span class="config-type">[ + ] ' . $this->l('Advanced Settings') . '</span><span class="config-type" style="display:none">[ - ] ' . $this->l('Quick Settings') . '</span><br /><br />';
        
        // Export Specials
        //
      $this->_html .= '
      <label>' . $this->l('Discount/Specials') . '</label>
      <div class="margin-form">
      <input type="checkbox" name="specials" value="1" ' . ($specials ? 'checked="checked"' : '') . ' />&nbsp;<span style="color:black;font-size:12px;">&nbsp;' . $this->l('Yes') . '</span><br />
      <p>' . $this->l('Export specials prices if is sets Yes. If unsets the discounted prices will be ignorates') . '</p>
      </div>';


        // Export Products with Taxes
        //
      $this->_html .= '
      <label>' . $this->l('Taxes') . '</label>
      <div class="margin-form">
      <input type="checkbox" name="taxes" value="1" ' . ($taxes ? 'checked="checked"' : '') . ' />&nbsp;<span style="color:black;font-size:12px;">&nbsp;' . $this->l('Yes') . '</span><br />
      <p>' . $this->l('Add taxes to products and calculate order\'s taxes if sets to yes') . '</p>
      </div>
      ';

        // Individuals Accounts or Amazon Global Account
        //
      $this->_html .= '
      <label>' . $this->l('Account Type') . '</label>
      <div class="margin-form">
      <input type="radio" name="account_type" value="1" ' . ($account_type == 1 ? 'checked="checked"' : '') . ' />&nbsp;<span style="color:black;font-size:12px;">&nbsp;' . $this->l('Global') . '</span>
      <input type="radio" name="account_type" value="2" ' . ($account_type == 2 ? 'checked="checked"' : '') . ' />&nbsp;<span style="color:black;font-size:12px;">&nbsp;' . $this->l('Individual') . '</span>
      <p>' . $this->l('Use individual or global account method (default is global)') . '<br />
         ' . $this->l('The individual account create one account per customer') . '</p>
      </div>
      ';
        
      // Title Format
      //
      $this->_html .= '
      <label>' . $this->l('Title Format') . '</label>
      <div class="margin-form">
      <input type="radio" name="title_format" value="' . self::FormatTitle . '" ' . ($title_format == self::FormatTitle ? 'checked="checked"' : '') . ' />&nbsp;<span style="color:black;font-size:12px;">&nbsp;' . $this->l('Standard Title, Attributes') . '</span>&nbsp;&nbsp;&nbsp;
      <input type="radio" name="title_format" value="' . self::FormatManufacturerTitle . '" ' . ($title_format == self::FormatManufacturerTitle ? 'checked="checked"' : '') . ' />&nbsp;<span style="color:black;font-size:12px;">&nbsp;' . $this->l('Manufacturer, Title, Attributes') . '</span>&nbsp;&nbsp;&nbsp;
      <input type="radio" name="title_format" value="' . self::FormatManufacturerTitleReference . '" ' . ($title_format == self::FormatManufacturerTitleReference ? 'checked="checked"' : '') . ' />&nbsp;<span style="color:black;font-size:12px;">&nbsp;' . $this->l('Manufacturer, Title, Reference, Attributes') . '</span>
      <p>' . $this->l('Type of product name, Amazon recommend to format the title like Manufacturer, Title, Attributes') . '<br />
         ' . $this->l('Please choose the first choice if your products titles are already formated for Amazon') . '</p>
      </div>
      ';        

      // Advanced Configuration
      //
      $this->_html .= '<div class="advanced-settings" style="display:none">' ;

        // Delete Products from Amazon
        //
      $this->_html .= '
      <label>' . $this->l('Delete Products') . '</label>
      <div class="margin-form">
      <input type="checkbox" name="delete_products" value="1" ' . ($delete_products ? 'checked="checked"' : '') . ' />&nbsp;<span class="yesno">&nbsp;' . $this->l('Yes') . '</span>
      <p>' . $this->l('Delete the products on Amazon when they are Out of Stock') . '</p>
      </div>
      ';

        // Force Import even the product is out of stock
        //
        $this->_html .= '
        <label>'.$this->l('Force Import') . '</label>
        <div class="margin-form">
        <input type="checkbox" name="force_import" value="1" ' . ($force_import ? 'checked="checked"' : '') . ' />&nbsp;<span class="yesno">&nbsp;' . $this->l('Yes') . '</span>
        <p>' . $this->l('Force importing the order even the product is out of stock') . '<br /></p>
        </div>
        ' ;
        
        // Exports stock only
        //
      $this->_html .= '
      <label>' . $this->l('Stock Only') . '</label>
      <div class="margin-form">
      <input type="checkbox" name="stock_only" value="1" ' . ($stock_only ? 'checked="checked"' : '') . ' />&nbsp;<span class="yesno">&nbsp;' . $this->l('Yes') . '</span>
      <p>' . $this->l('Synchronise only quantities, do not synchronise prices') . '<br />'
                . '</p>
      </div>
      ';

      
      /*
       * Hidden Settings
       */
      if ( $this->config['hidden_settings'] )
      {    
            // Exports stock only
            //
            $this->_html .= '
            <label>' . $this->l('Payment Region') . '</label>
            <div class="margin-form">
            <input type="checkbox" name="payment_region" value="1" ' . ($this->config['payment_region'] ? 'checked="checked"' : '') . ' />&nbsp;<span class="yesno">&nbsp;' . $this->l('Yes') . '</span>
            <p>' . $this->l('Add Region (FR, UK, US...) to the payment method title') . '<br />'
                        . '</p>
            </div>
            ';             
      }         
      // Description Field, Short or Long
      //
      $this->_html .= '
      <label>' . $this->l('Description Field') . '</label>
      <div class="margin-form">
      <input type="radio" name="description_field" value="' . self::FieldDescriptionLong . '" ' . ($this->config['description_field'] == self::FieldDescriptionLong ? 'checked="checked"' : '') . ' />&nbsp;<span style="color:black;font-size:12px;">&nbsp;' . $this->l('Description') . '</span>&nbsp;&nbsp;&nbsp;
      <input type="radio" name="description_field" value="' . self::FieldDescriptionShort . '" ' . ($this->config['description_field'] == self::FieldDescriptionShort ? 'checked="checked"' : '') . ' />&nbsp;<span style="color:black;font-size:12px;">&nbsp;' . $this->l('Short Description') . '</span>&nbsp;&nbsp;&nbsp;
      <p>' . $this->l('Description field to send to Amazon, short or long') . '</p>
      </div>
      ';

      // Import unknown products as a dummy product
      //
      if ( ! $this->config['dummy'] )
        $dummy_style='display:none;' ;
      else
        $dummy_style='' ;  
      
      $this->_html .= '
      <label>' . $this->l('Dummy Product') . '</label>
      <div class="margin-form">
      <input type="checkbox" name="dummy" id="dummy" value="1" ' . ($this->config['dummy'] ? 'checked="checked"' : '') . ' />&nbsp;<span class="yesno">&nbsp;' . $this->l('Yes') . '</span>
      <p>' . $this->l('Import unknown products as a dummy/fake product.') . '</p>
        <div id="dummy-product" style="' . $dummy_style . '">
        <span class="dummy-name">' . $this->l('Product SKU') . ':&nbsp;<input name="dummy_product" value="' . $this->config['dummy_product'] . '" /></span>
        <p>' . $this->l('SKU/Reference from your database which will be used as dummy product.') . '</p>
        </div>
      </div>
      ';

      // Debug Mode
      //
      $this->_html .= '
      <label>' . $this->l('Debug Mode') . '</label>
      <div class="margin-form">
      <input type="checkbox" name="debug" value="1" ' . ($debug ? 'checked="checked"' : '') . ' />&nbsp;<span style="color:black;font-size:12px;position:relative;top:-2px;">' . $this->l('Active') . '</span><br />
      <p>' . $this->l('Debug mode. Enable traces for debugging and developpment purpose.') . '
      <br /><b' . ($debug ? ' style="color:red" ' : '') . '>' . $this->l('In exploitation this option must not be active !') . ' </b></p>
      </div>' ;
      
      $this->_html .= '</div><!-- Advanced Settings -->' ;
      
        $this->_html .= '
       <hr class="amz-separator" />
      ';

        /*
         * NORMAL ORDERS
         */
        
        //
        // Order Statuses - Incoming Order
        //
        $order_state = $this->config['order_state'] ;
        
      $this->_html .= '
          <label>' . $this->l('Orders Statuses') . '</label>
          <div class="margin-form">

          <select name="order_state" style="width:500px;">
            <option>' . $this->l('Choose a default incoming order status for Amazon') . '</option>';

        $orderStates = OrderState::getOrderStates($id_lang);

        foreach ($orderStates as $orderState)
        {
            if (intval($orderState['id_order_state']) == $order_state)
                $selected = 'selected="selected"';
            else
                $selected = '';

            $this->_html .= '<option value="' . intval($orderState['id_order_state']) . '" ' . $selected . '>' . $orderState['name'] . '</option>';
        }
        $this->_html .= '</select>
                         <p>' . $this->l('Choose the default order state for new incoming orders') . '</p>
            </div>';

        /* FOR FUTURE USE - Or for specific usage
        //
        // Order Statuses - Preparation In Progress
        //
        $preparation_state = $this->config['preparation_state'] ;
         
      $this->_html .= '
          <div class="margin-form">

          <select name="preparation_state" style="width:500px;">
            <option>' . $this->l('Choose a default order status for preparation in progress state') . '</option>';

        foreach ($orderStates as $orderState)
        {
            if (intval($orderState['id_order_state']) == $preparation_state)
                $selected = 'selected="selected"';
            else
                $selected = '';

            $this->_html .= '<option value="' . intval($orderState['id_order_state']) . '" ' . $selected . '>' . $orderState['name'] . '</option>';
        }
        $this->_html .= '</select>
                         <p>' . $this->l('Choose a default order status for preparation in progress state') . '</p>
            </div>' ;
        */
        
        //
        // Order Statuses - Sent
        //
        $sent_state  = $this->config['send_state'] ;
        
      $this->_html .= '
          <div class="margin-form">

          <select name="sent_state" style="width:500px;">
            <option>' . $this->l('Choose a default sent order status for Amazon') . '</option>';

        foreach ($orderStates as $orderState)
        {
            if (intval($orderState['id_order_state']) == $sent_state)
                $selected = 'selected="selected"';
            else
                $selected = '';

            $this->_html .= '<option value="' . intval($orderState['id_order_state']) . '" ' . $selected . '>' . $orderState['name'] . '</option>';
        }
        $this->_html .= '</select>
                         <p>' . $this->l('Choose the default order state for sent orders') . '</p>
            </div>' ;

        if ( $FBA )
        {
            /*
            * FBA ORDERS
            */

            //
            // Order Statuses - Incoming Order
            //
            $fba_order_state = $this->config['fba_order_state'] ;

            // Default
            if ( ! $fba_order_state ) $fba_order_state = $order_state ;        

        $this->_html .= '
            <label>' . $this->l('Orders Statuses') . ' <br/><span style="color:green">(FBA)</span>' . '</label>
            <div class="margin-form">

            <select name="fba_order_state" style="width:500px;">
                <option>' . $this->l('Choose a default incoming order status for Amazon') . '</option>';

            $orderStates = OrderState::getOrderStates($id_lang);

            foreach ($orderStates as $orderState)
            {
                if (intval($orderState['id_order_state']) == $fba_order_state)
                    $selected = 'selected="selected"';
                else
                    $selected = '';

                $this->_html .= '<option value="' . intval($orderState['id_order_state']) . '" ' . $selected . '>' . $orderState['name'] . '</option>';
            }
            $this->_html .= '</select>
                            <p>' . $this->l('Choose the default order state for new incoming orders') . ' (FBA)</p>
                </div>';

            /* FOR FUTURE USE - Or for specific usage
            //
            // Order Statuses - Preparation In Progress
            //
            $fba_preparation_state = $this->config['fba_preparation_state'] ;

            // Default
            if ( ! $fba_preparation_state ) $fba_preparation_state = $preparation_state ; 

        $this->_html .= '
            <div class="margin-form">

            <select name="fba_preparation_state" style="width:500px;">
                <option>' . $this->l('Choose a default order status for preparation in progress state') . '</option>';

            foreach ($orderStates as $orderState)
            {
                if (intval($orderState['id_order_state']) == $fba_preparation_state)
                    $selected = 'selected="selected"';
                else
                    $selected = '';

                $this->_html .= '<option value="' . intval($orderState['id_order_state']) . '" ' . $selected . '>' . $orderState['name'] . '</option>';
            }
            $this->_html .= '</select>
                            <p>' . $this->l('Choose a default order status for preparation in progress state') . ' (FBA)</p>
                </div>' ;
            */

            //
            // Order Statuses - Sent
            //
            $fba_sent_state  = $this->config['fba_send_state'] ;

            // Default
            if ( ! $fba_sent_state ) $fba_sent_state = $sent_state ;

        $this->_html .= '
            <div class="margin-form">

            <select name="fba_sent_state" style="width:500px;">
                <option>' . $this->l('Choose a default sent order status for Amazon') . '</option>';

            foreach ($orderStates as $orderState)
            {
                if (intval($orderState['id_order_state']) == $fba_sent_state)
                    $selected = 'selected="selected"';
                else
                    $selected = '';

                $this->_html .= '<option value="' . intval($orderState['id_order_state']) . '" ' . $selected . '>' . $orderState['name'] . '</option>';
            }
            $this->_html .= '</select>
                            <p>' . $this->l('Choose the default order state for sent orders') . ' (FBA)</p>
                </div>' ;
        }
        
        $this->_html .= '<div class="advanced-settings" style="display:none">' ;
        
        // Bulk Mode Update
        //
        $bulk_mode = $this->config['bulk_mode'] ;        
        
        $this->_html .= '
            <label>' . $this->l('Bulk Mode') . '</label>
            <div class="margin-form">
            <input type="checkbox" name="bulk_mode" value="1" ' . ($bulk_mode ? 'checked="checked"' : '') . ' />&nbsp;<span class="yesno">&nbsp;' . $this->l('Yes') . '</span>
            <p>' . $this->l('Please check it for bulk mode update through a Cron Job') . '<br />'
                 . $this->l('This is allow to send all the orders states updates in a same time to Amazon') . 
                        '</p>
            </div>
            ';
        $this->_html .= '</div> <!-- Advanced Settings -->' ;
        
        $this->_html .= '
            <hr class="amz-separator" />';

        // Shop Configuration
        //
        if ( version_compare(_PS_VERSION_,'1.5','>=') )
        {
            $current_id_shop = (int)$this->config['shop'] ;
        
            $this->_html .= '<label>' . $this->l('Shop') . '</label>' ;
            $this->_html .= '
                <div class="margin-form">

                <select name="shop" style="width:500px;">
                    <option>' . $this->l('Choose') . '</option>';

                foreach (Shop::getShops() as $shop)
                {
                    if ( intval($shop['id_shop']) == $current_id_shop )
                        $selected = 'selected="selected"';
                    else
                        $selected = '';

                    $this->_html .= '<option value="' . intval($shop['id_shop']) . '" ' . $selected . '>' . $shop['name'] . '</option>';
                }
                $this->_html .= '</select>
                                <p>' . $this->l('Choose a shop linked to your Amazon account') . '</p>
                    </div>' ;
       }
       
        // Warehouse (PS 1.5 with Stock Management) 
        //
        if ( version_compare(_PS_VERSION_,'1.5','>=') && Configuration::get('PS_ADVANCED_STOCK_MANAGEMENT') )
        {
            $current_id_warehouse  = (int)$this->config['warehouse'] ;
        
            $this->_html .= '<label>' . $this->l('Warehouses') . '</label>' ;
            $this->_html .= '
                <div class="margin-form">

                <select name="warehouse" style="width:500px;">
                    <option>' . $this->l('Choose') . '</option>';

                foreach (Warehouse::getWarehouses(true) as $warehouse)
                {
                    if ( intval($warehouse['id_warehouse']) == $current_id_warehouse )
                        $selected = 'selected="selected"';
                    else
                        $selected = '';

                    $this->_html .= '<option value="' . intval($warehouse['id_warehouse']) . '" ' . $selected . '>' . $warehouse['name'] . '</option>';
                }
                $this->_html .= '</select>
                                <p>' . $this->l('Choose a warehouse for Amazon products pickup (for Advanced Stock Management)') . '</p>
                    </div>' ;
       }
       
       if ( version_compare(_PS_VERSION_,'1.5','>=') )
            $this->_html .= '
                <hr class="amz-separator" />';                
       
        // Products Condition/State
        //
      $sql = 'SHOW COLUMNS FROM `' . _DB_PREFIX_ . 'product` where Field = "condition"';
        $query = Db::getInstance()->ExecuteS($sql);

        if (is_array($query))
            $query = array_shift($query);

        if (isset($query['Field']) && $query['Field'] == 'condition')
        {
            // For i18n
            //
         $default_conditions = array($this->l('new'), $this->l('used'), $this->l('refurbished'));

            // Fetch columns names
            //
         preg_match_all("/'([\w ]*)'/", $query['Type'], $ps_conditions);


            $this->_html .= '
            <label>' . $this->l('Products Condition') . '</label>

            <div class="margin-form">';

            $i = 1;
            foreach ($this->_conditions as $condition)
            {
                $this->_html .= '
                  <input type="text readonly="true" style="width:200px;" readonly=true value="' . $condition . '">';

                $this->_html .= '
                        <span style="position:relative;top:-8px">&nbsp;&nbsp;
                        <img src="' . $this->images . 'list-next.gif" alt="" />
                        &nbsp;&nbsp;
                      </span>';

                $this->_html .= '
                   <select name="condition_map[' . $condition . ']" id="condition_map-' . $i++ . '" style="width:200px">
                      <option value=""></option>';
                foreach ($ps_conditions[1] as $ps_condition)
                {
                    if (isset($conditionMap[$condition]) && !empty($conditionMap[$condition]) && $conditionMap[$condition] == $ps_condition)
                        $selected = 'selected="selected"';
                    else
                        $selected = '';

                    $this->_html .= '<option value="' . $ps_condition . '" ' . $selected . '>' . ucfirst($this->l($ps_condition)) . '</option>';
                }

                $this->_html .= '
                    </select><br />';
            }
            $this->_html .= '
                <p>' . $this->l('Amazon conditions side / Prestashop conditions side, please associate the parameters wished') . '</p>';

            $this->_html .= '
              </div>
              <hr class="amz-separator" />';
        }
        else
        {
            // Prestashop 1.2
            $this->_html .= '
            <input type="hidden" name="condition_map[New]" value="new" />';
        }

        if ($mpAmazonEurope)
        {
            $checked = 'checked="checked"';
            $disabled = '';
            $class = 'master-enabled';
        }
        else
        {
            $checked = '';
            $disabled = 'disabled="disabled"';
            $class = 'master-disabled';
        }

        $this->_html .= '
          <!-- Amazon Europe -->
          <label style="color:grey">' . $this->l('Amazon Europe') . '</label><br /><br />

          <label>' . $this->l('Status') . '</label>
          <div class="margin-form">
          <input type="checkbox" name="amazonEurope" id="amazonEurope" value="1" ' . $checked . ' /><span style="font-size:1.2em;color:black;">&nbsp;&nbsp;' . $this->l('Active') . '</span>
          <p>' . $this->l('Enable Amazon Europe (Amazon Europe account required)') . '</p>
          </div>


          <label>' . $this->l('Master Platform') . '</label>
          <div class="margin-form">

          <select name="marketPlaceMaster" id="marketPlaceMaster" ' . $disabled . ' class="' . $class . '" style="width:280px">
            <option disabled="disabled">' . $this->l('Choose the platform for this region') . '</option>';

        foreach ($this->_platforms as $iso_code => $platform)
        {
            if ($iso_code == $mpMasterPlatform)
                $selected = 'selected="selected"';
            else
                $selected = '';

            $this->_html .= '<option value="' . $iso_code . '" ' . $selected . '>' . $platform . '</option>';
        }
        $this->_html .= '</select>' . $nb .
                '</div>
       <hr class="amz-separator" />';
     
      $this->_validate();

      $this->_html .= '
         </div>';
    }

    private function _categories($default_categories, $default_profiles2categories, $brute_force)
    {
        global $cookie;

        $categories = Category::getCategories(intval($cookie->id_lang), false);
        $index = array();
        $selected_tab = $this->_selected_tab();
        
        foreach($categories as $first1 => $categories_array)
                break ; 
        foreach($categories_array as $first2 => $categories_array2)
                break ;
   
        $html_categories = self::recurseCategoryForInclude($index, $categories, $categories[$first1][$first2], 1, null, $default_categories, $default_profiles2categories);

        $this->_html .= '
        <div id="menudiv-categories"  class="tabItem ' . ($selected_tab == 'categories' ? 'selected' : '') . '">
      <br />';

        $this->_html .= '
            <label>' . $this->l('Categories Settings') . '</label>
            <div class="margin-form">
            <p style="font-size:1.2em;">' . $this->l('Categories to export to amazon and optional price modificator, the selected categories will be used when exporting products and by the cron if it is used in you environment. The price modificator will override the existing one if sets') . '</p><br /><br />
              ';

        $this->_html .= '
              <table cellspacing="0" cellpadding="0" class="table">
          <tr>
            <th style="margin:0"><input type="checkbox" name="checkme" /></th>
            <th style="width: 400px">' . $this->l('Name') . '</th>
            <th>' . $this->l('Profile') . '</th>
          </tr>
          ' . $html_categories . '
        </table>

        ';
        $this->_html .= '
        </div>
        <hr class="amz-separator" />';

        if (intval($brute_force))
            $checked = ' checked="checked"';
        else
            $checked = '';

        $this->_html .= '
            <label>' . $this->l('Brute Force') . '</label>
            <div class="margin-form">
                <input type="checkbox" name="brute_force" value="1" ' . $checked . ' /><span style="font-size:1.2em;color:black;position:relative;top:+2px;">&nbsp;&nbsp;' . $this->l('Active forcing updates') . '</span>
                <p>' . $this->l('Force product update even it was not modified') . '<br />
                <span style="color:red;font-weight:bold;">' .
                $this->l('This feature is not recommended !') . '
                </span>
                </p>
            </div>';


        $this->_validate();

        $this->_html .= '
        </div>';
    }

    private function _profiles($profiles)
    {
        global $cookie;

        require_once(dirname(__FILE__) . '/classes/amazon.specificfield.class.php');
        
        $selected_tab = $this->_selected_tab();

        $this->_html .= '
        <div id="menudiv-profiles"  class="tabItem ' . ($selected_tab == 'profiles' ? 'selected' : '') . '">
          <br />';

       $id_lang = (int)Configuration::get('PS_LANG_DEFAULT') ;
       $url = 'https://sellercentral.amazon.' . Amazon_Tools::idToDomain($id_lang) . '/gp/help/help-popup.html?ie=UTF8&itemID=1641#tables' ;
       
       $this->_html .= '
                <label>' . $this->l('Profiles Configuration') . '</label>
                <div class="margin-form" class="profiles">
                <p style="font-size:1.2em;position:relative;top:-15px;">' . $this->l('Profiles are used for products creation mode. Please setup one profile per Amazon category set.') . ' ' .
               $this->l('The valid values are described in the Amazon file templates. You could find template at this URL:') . '<a href="' . $url . '" target="_blank">' . $url . '</a>' . 
               '</p>
                <div id="profile-add">
                    <span class="profile-add-img"><img src="' . $this->images . 'add.png" /></span>
                    <span class="profile-add">' . $this->l('Add a profile to the list') . '</span>        
                </div>
                <div class="cleaner"></div>
                <div class="error" id="ajax-error" style="display:none;margin-top:10px">test</div>
                </div>
                ' ;


       // Config Items 
       //
       $this->_html .= '<input type="hidden" id="xsd_path" value="' . str_replace('\\', '/', realpath( dirname(__FILE__) )) . '/xsd/" />' ;
       $this->_html .= '<input type="hidden" id="xsd_operations_url" value="' . $this->url . 'functions/xsd_operations.php?id_lang=' . $cookie->id_lang . '" />' ;
       $this->_html .= '<input type="hidden" id="xsd_ajax_error" value="' . $this->l('An unexpected server side error occurs') . '<br />' . $this->l('In most cases, this is a permission problem. Please apply write permission (777) to amazon/validate/xsd directory.') . '" />' ;
       
        
        // Only Used to Fetch the XSD Files ;
        //
        AmazonXSD::getCategories();
        
        
        // Known categories
        // https://catalog-mapper-fr.amazon.fr/catm/classifier/ProductClassifier.amzn
        // https://sellercentral.amazon.fr/gp/help/help-page.html/ref=pt_200956770_cont_scsearch?ie=UTF8&itemID=200956770
        //
        
        $amazon_universes['ClothingAccessories']    = 'Clothing Accessories';
        $amazon_universes['ProductClothing']        = 'Product Clothing';
        $amazon_universes['Miscellaneous']          = 'Miscellaneous';
        $amazon_universes['CameraPhoto']            = 'Camera Photo';
        $amazon_universes['Home']                   = 'Home';
        $amazon_universes['Sports']                 = 'Sports';
        $amazon_universes['SportsMemorabilia']      = 'Sports Memorabilia';
        $amazon_universes['EntertainmentCollectibles'] = 'Entertainment Collectibles';
        $amazon_universes['HomeImprovement']        = 'Home Improvement';
        $amazon_universes['Tools']                  = 'Tools';
        $amazon_universes['FoodAndBeverages']       = 'Food And Beverages';
        $amazon_universes['Gourmet']                = 'Gourmet';
        $amazon_universes['Jewelry']                = 'Jewelry';
        $amazon_universes['Health']                 = 'Health';
        $amazon_universes['CE']                     = 'Consumers Electronics';
        $amazon_universes['Computers']              = 'Computers';
        $amazon_universes['SWVG']                   = 'Software and Video Games';
        $amazon_universes['Wireless']               = 'Wireless';
        $amazon_universes['Beauty']                 = 'Beauty';
        $amazon_universes['Office']                 = 'Office';
        $amazon_universes['MusicalInstruments']     = 'Musical Instruments';
        $amazon_universes['AutoAccessory']          = 'Auto Accessory';
        $amazon_universes['PetSupplies']            = 'Pet Supplies';
        $amazon_universes['ToysBaby']               = 'Toys and Baby';
        $amazon_universes['TiresAndWheels']         = 'Tires And Wheels';
        $amazon_universes['Music']                  = 'Music';
        $amazon_universes['Video']                  = 'Video';
        $amazon_universes['Lighting']               = 'Lighting';
        $amazon_universes['LargeAppliances']        = 'Large Appliances';
        $amazon_universes['Toys']                   = 'Toys';
        $amazon_universes['GiftCards']              = 'Gift Cards';
        $amazon_universes['LabSupplies']            = 'Lab Supplies';
        $amazon_universes['RawMaterials']           = 'Raw Materials';
        $amazon_universes['PowerTransmission']      = 'Power Transmission';
        $amazon_universes['Industrial']             = 'Industrial';
        $amazon_universes['Shoes']                  = 'Shoes';
        $amazon_universes['Motorcycles']            = 'Motorcycles';
        $amazon_universes['MechanicalFasteners']    = 'Mechanical Fasteners';
        $amazon_universes['FoodServiceAndJanSan']   = 'Food Service And Jan San';
        $amazon_universes['WineAndAlcohol']         = 'Wine And Alcohol';
        $amazon_universes['EUCompliance']           = 'EU Compliance';
        $amazon_universes['Books']                  = 'Books';
        
        // Form Template
        //
        $profiles['name'][65635] = null ;
        $profiles['category'][65635] = null ;
        $profiles['universe'][65635] = null ;
        $profiles['formula'][65635] = null ;
        $profiles['product_type'][65635] = null ;
        $profiles['combinations'][65535] = null ;
        $profiles['field_color'][65535] = null ;
        $profiles['field_size'][65535] = null ;
        $profiles['browsenode_1'][65535] = null ;
        
        $master = false ;       
        
        $this->_html .= '                
               <!-- Container to receive the profiles -->
               <div id="profile-container">
               
               </div>' ;
        
        $this->_html .= '
                <div id="profile-items">' ;
        
        // Profiles for Products Sheets Creation
        //
        foreach($profiles['name'] as $profile_id => $profile_name)
        {
            
            if ( $profile_name == NULL && ! $master )
            {
                 $profile_div = 'id="master-profile" style="display:none"' ;
                 $profile_id='' ;
                 $master = true ;
            }
            elseif ( empty($profile_name) )
                continue ;
            else $profile_div = '' ;
            
            $p_product_type = isset($profiles['product_type'][$profile_id]) ? $profiles['product_type'][$profile_id] : '' ;
            $p_name     = isset($profiles['name'][$profile_id]) ? $profiles['name'][$profile_id] : '' ;
            $p_universe = isset($profiles['universe'][$profile_id]) ? $profiles['universe'][$profile_id] : '' ;
            $p_formula  = isset($profiles['formula'][$profile_id]) ? $profiles['formula'][$profile_id] : '' ;
            $p_combinations = isset($profiles['combinations'][$profile_id]) ? $profiles['combinations'][$profile_id] : '' ;
            $p_field_size = isset($profiles['field_size'][$profile_id]) ? $profiles['field_size'][$profile_id] : '' ;
            $p_field_color = isset($profiles['field_color'][$profile_id]) ? $profiles['field_color'][$profile_id] : '' ;
            $p_extra = isset($profiles['extra'][$profile_name]) ? $profiles['extra'][$profile_name] : '' ;
            $p_exemption = isset($profiles['code_exemption'][$profile_id]) ? $profiles['code_exemption'][$profile_id] : '' ;
            
           /* 
            * Master Container (empty container used to create new profiles)
            */
            $this->_html .= '
                    <div ' . $profile_div .'>' ;

            // Profile Name
            $this->_html .= '                 
                        <label class="profile-obj-title" style="color:green">' . $this->l('Profile Name') . '</label>
                        <div class="margin-form">
                        <input type="text" name="profiles[name][]" style="width:200px" value="' . $p_name . '" />
                        <span class="profile-del-img"><img src="' . $this->images . 'delete.gif" /></span>
                        <span class="profile-del">' . $this->l('Remove this profile from the list') . '</span>                            
                        <p class="profile-help">' . $this->l('Please give a friendly name to remind this profile') . '
                        </div>
                        ';            
            
            $this->_html .= '
                    <label class="profile-obj-title">' . $this->l('Category Name') . '</label>
                    <div class="margin-form">
                    <select name="profiles[universe][]" class="profile-universe" style="width:250px" />
                    <option></option>' ;
                    foreach($amazon_universes as $key => $universe)
                        $this->_html .= '
                            <option value="' . $key . '" ' . ($p_universe == $key && ! $master ? 'selected="selected"' : '') . '>' . $universe . '</option>' ;
                    $this->_html .= '                               
                        </select>
                    <p class="profile-help">' . 
                        $this->l('Choose the main universe for this profile.') . '<br />' .
                        $this->l('Do not forget to click on the save button at the bottom right of the page !') . '</p>' .
                        '<span class="xsd-load" style="display:none;"><img src="' . $this->images . 'small-loader.gif" />&nbsp;&nbsp;<b>' . $this->l('Loading data from Amazon') . '</b></span>' .
                        '&nbsp;<span class="fetch-result"></span>
            <div class="cleaner"></div></div>' ;


            // Categories
            $this->_html .= '
                        <label class="profile-obj-title">' . $this->l('Product Type') . '</label>
                        <div class="margin-form" >
                        <select name="profiles[product_type][]" class="product_type" style="width:400px">' ;

            $this->_html .= '
                            <option value="' . $p_product_type . '" selected="selected">' . $p_product_type . '</option>' ;
            
            $this->_html .= '                 
                            </select>
                            &nbsp;&nbsp;<img src="' . $this->images . 'reload.gif" class="type_reload" rel="' . $this->images . 'green-loader.gif" />
                            <p class="profile-help"> ' . $this->l('Please select the main category for this profile') . '</p>
                            </div>
                            <!-- EO Category -->
                            <div class="cleaner"></div>' ;  

            // Mandatory Extra Fields
            //
            $this->_html .= '
                        <label class="profile-obj-title">' . $this->l('Specifics Fields') . '</label>' ;
            
            $this->_html .= '
                        <div class="margin-form" >' ;


            $this->_html .= '
                            <div class="mandatory_fields">'  ;

            $this->_html .= Amazon_SpecificField::displayFields($profile_name, $p_extra) ;
            
            $this->_html .= '                 
                    </div>' ;
            
            $this->_html .= '                 
                            <p class="profile-help"><span class="extra-required">*</span> ' . $this->l('Please fill the mandatory fields for this profile') . '</p>
                            </div><!-- EO Mandatory Fields -->
                            <div class="cleaner"></div>' ;  
            

            //
            // Size Field
            //
            $attributes_groups = AttributeGroup::getAttributesGroups((int) ($cookie->id_lang));

            $attributes = Attribute::getAttributes((int) ($cookie->id_lang), true);
            $attributeList = array();

            foreach ($attributes AS $k => $attribute)
                $attributeList[$attribute['id_attribute_group']][$attribute['id_attribute']] = $attribute['name'];

            // Exceptions
            //
            if ( $p_universe == 'Jewelry' )
                    $style='display:none;' ;
            else    $style='' ;

            // Fields Associations
            $this->_html .= '       
                <div id="associations" style="' . $style . '">
                        <label class="profile-obj-title" style="color:grey">' . $this->l('Association for') . '</label>  
                        <div class="margin-form">' . $this->l('Size') . ':&nbsp;
                        <select name="profiles[field_size][]" value="" >' ;
            $this->_html .= '
                            <option value="0">' . $this->l('Choose') . '</option>' . "\n";
            
                        if ($attributeList)
                            foreach ($attributeList AS $idgrp => $group)
                            {
                                if (!$idgrp)
                                    continue;

                                foreach ($attributes_groups as $attributes_group)
                                    if (isset($attributes_group['id_attribute_group']) && $attributes_group['id_attribute_group'] == $idgrp)
                                        break;

                                if ($idgrp == $p_field_size)
                                    $selected = 'selected="selected" ';
                                else
                                    $selected = '';
                                $this->_html .= '<option value="' . $idgrp . '" ' . $selected . '>' . $attributes_group['name'] . '</option>' . "\n";
                            }            

            //
            // Color Field 
            //                
            $this->_html .= '</select>&nbsp;&nbsp;&nbsp;' ;                            
            $this->_html .= 
                        $this->l('Color') . ':&nbsp;
                        <select name="profiles[field_color][]" value="" >' ;
            $this->_html .= '
                            <option value="0">' . $this->l('Choose') . '</option>' . "\n";

            if ($attributeList)
                foreach ($attributeList AS $idgrp => $group)
                {
                    if (!$idgrp)
                        continue;

                    foreach ($attributes_groups as $attributes_group)
                        if (isset($attributes_group['id_attribute_group']) && $attributes_group['id_attribute_group'] == $idgrp)
                            break;

                    if ($idgrp == $p_field_color)
                        $selected = 'selected="selected" ';
                    else
                        $selected = '';

                    $this->_html .= '<option value="' . $idgrp . '" ' . $selected . '>' . $attributes_group['name'] . '</option>' . "\n";
                }
            $this->_html .= '
                </select>
                ';
                            
            $this->_html .= '        
                        <p class="profile-help">' . $this->l('Please select the field which will be associated with color and size fields.') . '</p>
                        </div>
            </div><!-- associations -->' ;            
            
            // Only for certain customers
            //
            if ( $this->config['hidden_settings'] )
            {
                if ( $p_exemption ) 
                        $checked='checked' ;
                else    $checked='' ;
                
                $this->_html .= '
                    <label class="profile-obj-title">' . $this->l('Code Exemption') . '</label>
                    <div class="margin-form">
                        <input name="profiles[code_exemption][]" type="checkbox" value="1" ' . $checked . ' />&nbsp;&nbsp;' . $this->l('Use EAN/UPC exemption for this profile') ; 
                $this->_html .= '</div><br />' ;
            }
            
            // https://catalog-mapper-fr.amazon.fr/catm/classifier/ProductClassifier.amzn
            // https://sellercentral.amazon.fr/gp/help/help-page.html/ref=pt_200956770_cont_scsearch?ie=UTF8&itemID=200956770
            // Browse Node ID

            $this->_html .= '
                <label class="profile-obj-title">' . $this->l('Recommended Browse Node') . '</label>
                <div class="margin-form">' ;

            foreach (Amazon_Tools::languages() as $language)
            {
                if ( $language['iso_code'] == 'us' )    continue; // not needed for U.S.
                   
                $id_lang = $language['id_lang'] ;
                
                $p_browsenode = isset($profiles['browsenode_' . $id_lang][$profile_id]) ? $profiles['browsenode_' . $id_lang][$profile_id] : '' ;
                
                $this->_html .= '
                        <input type="text" name="profiles[browsenode_' . $id_lang . '][]" style="width:100px;margin:2px;" value="' . $p_browsenode . '" />
                            <img src="' . $this->images . 'geo_flags/' . $language['iso_code'] . '.gif" alt="' . $language['name'] . '" class="browse-lang-img" />
                            <span class="browse-lang-txt"> ' . $language['name'] .   '</span><br />' ;
            }
            
            
            $this->_html .= '
                        <p class="profile-help">' . $this->l('Amazon Browse Node ID') . '<br />' .
                        $this->l('You can use the product classifier to get browse node IDs') . '<br />' .
                        $this->l('This option is mandatory for Canada, Europe, Japan') . '<br />
                        <a href="' . Amazon_Tools::classifierURL($id_lang) . '" target="_blank" >' . Amazon_Tools::classifierURL($id_lang) . '</a>
                        </p></div>
                        ';           
                        
            // Price Formula
            $this->_html .= '                 
                        <label class="profile-obj-title">' . $this->l('Price Formula') . '</label>
                        <div class="margin-form">
                        <input type="text" name="profiles[formula][]" style="width:200px" value="' . $p_formula . '" />
                        <p class="profile-help">' .
                            $this->l('Apply a specific price formula for selected categories which will override the main setting (Default Price Formula)') . '<br />
                        ' . $this->l('This formula could be a price a value or math (multiply, divide, addition, subtraction, percentages)') . '<br />
                        ' . $this->l('Use the @ symbol as price reference (eg: @ + 10% mean you\'ll add 10% to the initial price)') . '<br />
                        ' . $this->l('If you specify nothing, the main setting will be applied.') . '</p></div>
                        ';

            $this->_html .= '  
                        <hr style="width:30%" />
                        </div>' ;
       
        }
        $this->_html .= '
                </div><!-- profile-items -->' ;
        
        $this->_validate();
        
        $this->_html .= '
        </div>';
        
        
    }

    // Mapping (Colors, Size ...)
    //
    private function _mapping($mapping_left, $mapping_right, $features_mapping_left, $features_mapping_right, $actives)
    {
        global $cookie;

        
        $selected_tab = $this->_selected_tab();

        $this->_html .= '
          <div id="menudiv-mapping"  class="tabItem ' . ($selected_tab == 'mapping' ? 'selected' : '') . '">' ;

        $this->_html .= '<h2>' . $this->l('Attributes Mapping') . '</h2>' ;
        
        $languages = Amazon_Tools::languages() ;
        
        /*
         * Attributes
         */
        foreach($languages as $language)
        {
            $id_lang = $language['id_lang'];

            if (!(isset($actives[$id_lang]) && intval($actives[$id_lang])))
                continue;

            $flag = '<img src="' . $this->images . 'geo_flags/' . $language['iso_code'] . '.gif" alt="' . $language['name'] . '" />' ;
            $lang = $language['name'] ;
            
            $this->_html .= '
                <label style="color:grey">' . $this->l('Attributes for') . '</label>
                <div class="margin-form"><span style="position:relative;top:+2px;font-size:1em">
                ' . $flag . '&nbsp;&nbsp;<b style="position:relative;top:+2px">'. $lang . '</b>
                </span></div>
                <div class="cleaner"></div><br />';            
            
            $attributes_groups = AttributeGroup::getAttributesGroups((int)$id_lang);

            $attributes = Attribute::getAttributes((int)$id_lang, true);
            $attributeList = array();

            foreach ($attributes AS $k => $attribute)
                $attributeList[$attribute['id_attribute_group']][$attribute['id_attribute']] = $attribute['name'];

            $previousgrp = 0;
            $index = 0;

            if ($attributeList)
                foreach ($attributeList AS $idgrp => $group)
                {
                    if ($idgrp != $previousgrp)
                        $index = 0;
                    $previousgrp = $idgrp;

                    $saved = array_merge(array(0 => false), isset($mapping_left[$id_lang][$idgrp]) ? $mapping_left[$id_lang][$idgrp] : array());

                    foreach ($attributes_groups as $attributes_group)
                        if (isset($attributes_group['id_attribute_group']) && $attributes_group['id_attribute_group'] == $idgrp)
                            break;

                    $this->_html .= '
                <label for="attribute-group-' . $id_lang . '-' . $idgrp . '">' . $attributes_group['name'] . '</label>
                <div class="margin-form">';
                    
                    $selected = 0 ;
                    
                    foreach ($saved as $key => $selected)
                    {
                        if (!$selected && $selected !== false)
                            continue;

                        $this->_html .= '
                    <div id="attribute-group-' . $id_lang . '-' . $idgrp . '-' . $index . '" type="hidden" name="mapping[group]['. $id_lang . '][' . $idgrp . ']" rel="' . $index . '" >
                    <select type="text" name="mapping[prestashop][' . $id_lang . '][' . $idgrp . '][' . $selected . ']" rel="' . $id_lang . '-' . $idgrp . '-' . $selected . '" ' . ($index == 0 ? ' disabled="disabled"' : '') . ' style="width:250px" />';

                        $this->_html .= "<option value='' ></option>\n";

                        if ($group)
                            foreach ($group AS $idattr => $attrname)
                            {
                                if ($selected == $idattr)
                                    $set = ' selected="selected"';
                                else
                                    $set = '';
                                    
                                $this->_html .= '<option value="' . $idattr . '"' . $set . ' > ' . addslashes(($attrname)) . "</option>\n";
                            }
                        $displayDel = $index == 0 ? 'display:none' : '';
                        $displayAdd = $index > 0 ? 'display:none' : '';

                        $this->_html .= '
                    </select>';

                        $this->_html .= '
                    <span style="position:relative;top:-8px;">&nbsp;&nbsp;<img src="' . $this->images . 'list-next.gif" alt="" />&nbsp;&nbsp;</span>';

                        $this->_html .= '
                    <input type="text" name="mapping[amazon][' . $id_lang . '][' . $idgrp . '][' . $selected . ']" value="' 
                                . (isset($mapping_right[$id_lang][$idgrp]) && isset($mapping_right[$id_lang][$idgrp][$selected]) ? $mapping_right[$id_lang][$idgrp][$selected] : '') . '" ' . ($index == 0 ? ' disabled="disabled"' : '') . ' style="position:relative;top:-3px;width:250px" />';

                        $this->_html .= '</select>&nbsp;&nbsp;
                    <img src="' . $this->images . 'add.png" class="addnewmapping" id="button-add-' . $id_lang . '-' . $idgrp . '-' . $index . '" alt="' . $this->l('Add a new mapping') . '" style="' . $displayAdd . '" />
                    <img src="' . $this->images . 'delete.gif" class="removemapping" id="button-del-' . $id_lang . '-' . $idgrp . '-' . $index . '" alt="' . $this->l('Remove mapping') . '" style="' . $displayDel . '" />';
                        $this->_html .= '
                    </div>';
                        $index++;
                    }
                    $this->_html .= '
                    <div id="new-mapping-' . $id_lang . '-' . $idgrp . '">
                    </div>
                    ';
                    $this->_html .= '
                </div><hr style="width:30%"/>';
                }
        }
        
        $this->_html .= '<h2>' . $this->l('Features Mapping') . '</h2>' ;

        /*
         * Features
         */
        foreach($languages as $language)
        {
            $id_lang = $language['id_lang'];

            if (!(isset($actives[$id_lang]) && intval($actives[$id_lang])))
                continue;

            $flag = '<img src="' . $this->images . 'geo_flags/' . $language['iso_code'] . '.gif" alt="' . $language['name'] . '" />' ;
            $lang = $language['name'] ;

            $this->_html .= '
                <label style="color:grey">' . $this->l('Features for') . '</label>
                <div class="margin-form"><span style="position:relative;top:+2px;font-size:1em">
                ' . $flag . '&nbsp;&nbsp;<b style="position:relative;top:+2px">'. $lang . '</b>
                </span></div>
                <div class="cleaner"></div><br />';

            $previous_id_feature = 0;
            $index = 0;
            $unique = array() ;
            
              foreach (Feature::getFeatures($id_lang) AS $key => $feature)
              {
                  $id_feature = $feature['id_feature'] ;

                  // Avoid Duplicates (There is duplicates on PS 1.5 due to multishop) 
                  // TODO : multishop compatibility
                  if ( isset($unique[$id_feature]) )    continue ;
                  $unique[$id_feature] = true ;
                  
                  if ($id_feature != $previous_id_feature)
                      $index = 0;
                  $previous_id_feature = $id_feature;

                  $featuresValues = FeatureValue::getFeatureValuesWithLang($id_lang, $id_feature) ;

                  $featuresValues = array_merge(array(0 => false), $featuresValues);

                  $this->_html .= '
              <label for="feature-group-' . $id_lang . '-' . $id_feature . '">' . $feature['name'] . '</label>
              <div class="margin-form">';

                  $selected = 0 ;

                  foreach ($featuresValues as $featureValue)
                  {
                      $id_feature_value = isset($featureValue['id_feature_value']) ? $featureValue['id_feature_value'] : 0 ;

                      if ( $featureValue !== false && (! isset($features_mapping_left[$id_lang][$id_feature][$id_feature_value]) || ! $features_mapping_left[$id_lang][$id_feature][$id_feature_value]) )
                          continue ;
                      
                      $this->_html .= '
                        <div id="feature-group-' . $id_lang . '-' . $id_feature . '-' . $index . '" type="hidden" name="feature_mapping[group]['. $id_lang . '][' . $id_feature . ']" rel="' . $index . '" >
                        <select type="text" name="features_mapping[prestashop][' . $id_lang . '][' . $id_feature . '][' . $id_feature_value . ']" rel="' . $id_lang . '-' . $id_feature . '-' . $id_feature_value . '" ' . ($index == 0 ? ' disabled="disabled"' : '') . ' style="width:250px" />';

                        foreach ($featuresValues as $featureItem)
                        {
                            $id_feature_value_item = $featureItem['id_feature_value'] ;
                            
                            if ( $featureValue !== false && isset($features_mapping_left[$id_lang][$id_feature][$id_feature_value_item]) && isset($features_mapping_left[$id_lang][$id_feature][$id_feature_value_item]) && $id_feature_value == $id_feature_value_item )
                                $set = ' selected="selected"';
                            else
                                $set = '';

                            $this->_html .= '<option value="' . $id_feature_value_item . '"' . $set . ' > ' . addslashes(($featureItem['value'])) . "</option>\n";
                        }

                      $displayDel = $index == 0 ? 'display:none' : '';
                      $displayAdd = $index > 0 ? 'display:none' : '';

                      $this->_html .= '
                  </select>';

                      $this->_html .= '
                  <span style="position:relative;top:-8px;">&nbsp;&nbsp;<img src="' . $this->images . 'list-next.gif" alt="" />&nbsp;&nbsp;</span>';

                      $this->_html .= '
                  <input type="text" name="features_mapping[amazon][' . $id_lang . '][' . $id_feature . '][' . $id_feature_value . ']" value="'
                              . ($featureValue !== false && isset($features_mapping_right[$id_lang][$id_feature]) && isset($features_mapping_right[$id_lang][$id_feature][$id_feature_value]) ? $features_mapping_right[$id_lang][$id_feature][$id_feature_value] : '') . '" ' . ($index == 0 ? ' disabled="disabled"' : '') . ' style="position:relative;top:-3px;width:250px" />';

                      $this->_html .= '</select>&nbsp;&nbsp;
                  <img src="' . $this->images . 'add.png" class="addnew-feature-mapping" id="button-feature-add-' . $id_lang . '-' . $id_feature . '-' . $index . '" alt="' . $this->l('Add a new mapping') . '" style="' . $displayAdd . '" />
                  <img src="' . $this->images . 'delete.gif" class="remove-feature-mapping" id="button-feature-del-' . $id_lang . '-' . $id_feature . '-' . $index . '" alt="' . $this->l('Remove mapping') . '" style="' . $displayDel . '" />';
                      $this->_html .= '
                  </div>';
                      $index++;
                  }
                  $this->_html .= '
                  <div id="new-feature-mapping-' . $id_lang . '-' . $id_feature . '">
                  </div>
                  ';
                  $this->_html .= '
              </div><hr style="width:30%"/>';
              }
      }
        
        $this->_validate();
        
        $this->_html .= '
          </div><!-- mapping -->';
    }
    // Display category tree
    //
    public function recurseCategoryForInclude($indexedCategories, $categories, $current, $id_category = 1, $id_category_default = NULL, $default_categories = array(), $default_profiles = array())
    {
        global $done;
        static $irow;
        global $chtml;
        $chtml = isset($chtml) ? $chtml : null;

        if (is_array($default_categories) && in_array($id_category, $default_categories))
            $checked = ' checked="checked"';
        else
            $checked = '';

        if (!isset($done[$current['infos']['id_parent']]))
            $done[$current['infos']['id_parent']] = 0;
        $done[$current['infos']['id_parent']] += 1;

        $todo = sizeof($categories[$current['infos']['id_parent']]);
        $doneC = $done[$current['infos']['id_parent']];

        $level = $current['infos']['level_depth'] + 1;
        $img = $level == 1 ? 'lv1.gif' : 'lv' . $level . '_' . ($todo == $doneC ? 'f' : 'b') . '.gif';

        $saved_profiles = @unserialize(base64_decode(Configuration::get('AMAZON_PROFILES')));
        
        $select = '
            <select name="profile2category[' . $id_category . ']" style="width:180px;margin-right:10px;" />
             <option value="">' . $this->l('Please choose a profile') . '</option>' ;    

        if ( $saved_profiles['name'] )
            foreach($saved_profiles['name'] as $profile_id => $profile_name)
            {
                if ( $profile_name == NULL )    continue ;

                if ( isset($default_profiles[$id_category]) && $default_profiles[$id_category] == $profile_name )
                    $selected = 'selected="selected"' ;
                else
                    $selected = '' ;

                $select .= '
                    <option value="' . $profile_name . '" ' . $selected . '"/>' . $profile_name . '</option>' ;

            }
            $select .= '
            </select>' ;

        $chtml .= '
            <tr class="cat-line' . ($irow++ % 2 ? ' alt_row' : '') . '">
            <td>
                <input type="checkbox" name="categoryBox[]" class="category' . ($id_category_default == $id_category ? ' id_category_default' : '') . '" id="category_' . $id_category . '" value="' . $id_category . '"' . $checked . ' />
            </td>
            <td style="cursor:pointer">
                <img src="' . $this->images . $img . '" alt="" /> &nbsp;<label for="category_' . $id_category . '" class="t">' . stripslashes($current['infos']['name']) . '</label>
            </td>
            <td align="right">
                ' . $select . '
            </td>
            </tr>';

        if (isset($categories[$id_category]))
        {
            foreach ($categories[$id_category] AS $key => $row)
                if ($key != 'infos')
                    self::recurseCategoryForInclude($indexedCategories, $categories, $categories[$id_category][$key], $key, $id_category_default, $default_categories, $default_profiles);
        }

        return($chtml);
    }

    //
    // Gestion des relations avec la MarketPlace sur la commande
    //
    public function hookDisplayAdminOrder($params)
    {
        global $cookie;

        require_once(dirname(__FILE__) . '/classes/amazon.order.class.php');
        require_once(dirname(__FILE__) . '/classes/amazon.tools.class.php');

        if ( version_compare(_PS_VERSION_,'1.5','<') )
        {
            $this->_html .= '<style type="text/css">h2 { max-width:400px; }</style>';  
        }        
        
        // jQuery
        //
        $jsFile = dirname(__FILE__) . '/js/adminorder.js';

        $img = $this->images . 'a-small.gif';

        $amazonOrder = new Amazon_Order($params['id_order']);

        if ( $amazonOrder->module != 'Amazon' )
            return(false);

        if ( version_compare(_PS_VERSION_,'1.5','<') )
            $style = 'style="margin-top:10px;width:400px;"';
        else
            $style = 'style="margin-top:10px;"';

        $channel = isset($amazonOrder->marketPlaceChannel) && $amazonOrder->marketPlaceChannel == 'AFN' ? $this->l('Fullfilled By Amazon') : '' ;

        if ($channel)
            $channel_text = '<p> ' . $this->l('Fullfillment') . ' : <span style="color:red;font-weight:bold">' . $channel . '</span></p>' ;
        else
            $channel_text = '';

        $region = Amazon_Tools::idToDomain($amazonOrder->id_lang);

        $amazonPlatform = '(amazon.' . $region . ')&nbsp;&nbsp;<img src="' . $this->images . 'geo_flags/' . $region . '.gif" alt="' . $region . '" style="position:relative;top:-2px;"/>';

        $this->_html .= '
        
        <fieldset ' . $style . '><div>' ;
        $this->_html .= '
        <input type="hidden" id="amazon_url" value="' . Amazon_Tools::SellerCentralURL($amazonOrder->id_lang, $amazonOrder->marketPlaceOrderId) . '" />
        <legend><img src="' . $img . '" alt="' . $this->l('Amazon MarketPlace') . '">' . $this->l('Amazon MarketPlace') . ' ' . $amazonPlatform . '</legend>
          <br />  
          <p>' . $this->l('Amazon Order ID') . ' : <b>' . $amazonOrder->marketPlaceOrderId . '</b></p>' . $channel_text . '<br />
          <input type="button" class="button" id="amazon_go" value="' . $this->l('Go to Amazon Seller Central'). '" />
          ';

        // jQuery Functions
        //
        $js = file_get_contents($jsFile);

        $this->_html .= '<script type="text/javascript">' . $js . '</script>';

      
        $this->_html .= '</fieldset>';

      return($this->_html);
    }

    
    // Hook Update Order - Try to send an email to the customer with the amazon temporary address
    //
    public function hookUpdateOrderStatus($params)
    {
        $bulk_mode = Configuration::get('AMAZON_BULK_MODE') ;

        // Bulk Mode, we don't update orders statuses
        //
        if ( intval($bulk_mode) )   return ;
        
        $pass = true;

        require_once(_PS_MODULE_DIR_ . $this->name . '/classes/amazon.order.class.php');
        require_once(_PS_MODULE_DIR_ . $this->name . '/classes/amazon.orderhistory.class.php');
        require_once(_PS_MODULE_DIR_ . $this->name . '/classes/amazon.tools.class.php');

        $id_order = intval($params['id_order']);

        if (!($order = new Amazon_Order($id_order)))
            return(false);

        $id_lang = $order->id_lang;

        // Not an amazon order
        //
        if (strtolower($order->module) != strtolower($this->name))
            return;

        // Config
        //
        $sentstate = unserialize(base64_decode(Configuration::get('AMAZON_SENT_STATE')));
        
        $carrier = new Carrier($order->id_carrier);

        // Default Carrier selected in the module configuration
        //
        $carriers_default = unserialize(base64_decode(Configuration::get('AMAZON_CARRIER_DEFAULT')));
        $carrier_default = isset($carriers_default[$id_lang]) ? $carriers_default[$id_lang] : false;
        
        // Matching Order Status
        //
        if ($params['newOrderStatus']->id != ( isset($sentstate) ? $sentstate : 0))
            return(false);

        $address = new Address($order->id_address_delivery);
        $trackingNumber = null ;
        
        if (isset($order->shipping_number) && !empty($order->shipping_number))
            $trackingNumber = $order->shipping_number;
        elseif ( ($shipping_number = Tools::getValue('shipping_number')) && !empty($shipping_number) )
            $trackingNumber = $shipping_number ;
        
        /*
          -----------------------------------------------
          /!\ Surtout ne pas envoyer un mail au client !
          -----------------------------------------------

          Objet : Notification: Votre Compte Vendeur Amazon.fr

          Cher Vendeur,

          Nous vous écrivons car vous avez peut-être envoyé des confirmations d’achat et/ou des notifications d’expédition aux acheteurs après avoir confirmé la « Facturation à l'expédition ».
          Sachez que nous envoyons une notification d'expédition à l'acheteur dès que vous nous confirmez l'expédition de la commande à Amazon. Nous reprenons toutes les informations concernant l'expédition que vous avez entrées et affichons ces informations dans le compte client Amazon de l'acheteur. Nous ne souhaitons pas que les acheteurs reçoivent plusieurs notifications pour une expédition, il est donc important que cette étape soit laissée à Amazon.
          Pour obtenir des informations sur cette règle de communauté, veuillez faire une recherche sur « Facturation à l'expédition »  à partir de la page d'Aide.
          À défaut d'exécuter cette requête, votre privilège de vendeur pourrait être révoqué.
          Nous apprécions votre collaboration et vous remercions de vendre sur Amazon.fr.

          Cordialement,

          Performance Vendeur
          Amazon.fr
        */
        
        // Init
        //
        $debugMode = (unserialize(base64_decode(Configuration::get('AMAZON_DEBUG'))) ? true : false);

        $amazon = Amazon_Tools::selectPlatform($id_lang, $debugMode);

        if (!$amazonApi = new Service($amazon['auth'], $amazon['params'], $amazon['platforms'], $debugMode))
        {
            echo $this->l('Unable to login') ;
            return;
        }

        // Amazon Throtlling Management
        // 
        $amazonApi->setTimerReadHandler('Configuration', 'get', 'AMAZON_API_TIMER');
        $amazonApi->setTimerWriteHandler('Configuration', 'updateValue', 'AMAZON_API_TIMER');
        // Drop in this context
        $amazonApi->setTimerAction(Service::DROP_THROTLLED_QUERIES);

        // Set to sent on Amazon
        //
        $pass = $amazonApi->confirmOrder($order->marketPlaceOrderId, $carrier_default, NULL, $trackingNumber) && $pass;

        return($pass);
    }

    // Hook for the optional module :
    // Market Place Strategies - Strategies on the products price
    // displayed on the product tab
    //
    public function hookbackOfficeHeader($params)
    {
        return($this->hookDisplayBackOfficeHeader($params)) ;
    }

    public function hookDisplayBackOfficeHeader($params)
    {
                $html = '';

        $controller = strtolower(Tools::getValue('controller'));

        // Patch for 1.4 admin submenu
        //
        if ( version_compare(_PS_VERSION_,'1.4','>=') && version_compare(_PS_VERSION_,'1.5', '<') )
            $html .= '<script type="text/javascript" src="' . $this->url . 'js/v14x_adminpatch.js"></script>';

        // Tested on PS 1.5.017
        // Case : http://forge.prestashop.com/browse/PSCFV-4059?page=com.atlassian.streams.streams-jira-plugin%3Aactivity-stream-issue-tab#issue-tabs
        //
        if ( version_compare(_PS_VERSION_,'1.5.0.17','=') )
            if ( $controller == 'productsamazon' || $controller == 'ordersamazon' )
            {
                $html .= '
                <link type="text/css" rel="stylesheet" href="' . _PS_JS_DIR_ . 'jquery/ui/themes/base/jquery.ui.datepicker.css" />
                <link type="text/css" rel="stylesheet" href="' . _PS_JS_DIR_ . 'jquery/ui/themes/base/jquery.ui.theme.css" />
                <script type="text/javascript" src="' . _PS_JS_DIR_ . 'jquery/ui/jquery.ui.core.min.js"></script>
                <script type="text/javascript" src="' . _PS_JS_DIR_ . 'jquery/ui/jquery.ui.datepicker.min.js"></script>';
            }

        // jQuery Scripts for Product Sheet
        //
        $jsBid = $this->url . 'js/product_bid.js';
        $jsOptions = $this->url . 'js/product_options.js';
        $request = $_SERVER['REQUEST_URI'];

        if ( version_compare(_PS_VERSION_,'1.5','<') && (stristr($request, 'tab=AdminCatalog') && Tools::getValue('id_product')) && (stristr($request, '&updateproduct') || stristr($request, '&addproduct')))
        {
            if ($this->strategies)
                $html .= '<script type="text/javascript" src="' . $jsBid . '?path=' . $this->url . '"></script>';

            $html .= '<script type="text/javascript" src="' . $jsOptions . '?path=' . $this->url . '"></script>';
        }

        if ( version_compare(_PS_VERSION_,'1.5','>=') && $controller == 'adminproducts' && Tools::getValue('id_product'))
        {
            $html .= '<script type="text/javascript" src="' . $jsOptions . '?path=' . $this->url . '"></script>';
        }

        if ( version_compare(_PS_VERSION_,'1.4', '<') )
            print($html);
        else
            return($html);
    }
    public function hookUpdateCarrier($params)
    {
        $carriers = unserialize(base64_decode(Configuration::get('AMAZON_CARRIER')));

        foreach ($carriers as $id_lang => $ps_carriers)
            foreach ($ps_carriers as $index => $carrier)
            {
                if ($carriers[$id_lang][$index] == $params['id_carrier'])
                    $carriers[$id_lang][$index] = $params['carrier']->id;
            }
        self::configurationUpdateValue('AMAZON_CARRIER', base64_encode(serialize($carriers)));
    }

    // DON'T WORK ON PS 1.5017 ! 
    public function hookActionAttributeGroupSave($params)
    {
    }  

    // DON'T WORK ON PS 1.5017 ! 
    public function hookActionAttributeGroupDelete($params)
    {
    }  
    
    // Ne fonctionne pas - AH SI ! Uniquement quand on supprime le produit !
    public function hookActionProductAttributeDelete($params)
    {
        if ( isset($params['product']->id) )
            $id_product = $params['product']->id ;
        elseif ( isset($params['id_product']) )
            $id_product = $params['id_product'] ;
        elseif ( isset($params['product']) )
            $id_product = $params['product']['id_product'] ; 
        else return(false) ;
        
        return( Amazon_Product::marketplaceActionRemoveAllCombinations(self::Remove, $id_product) ) ;
    }        
        
    // Fonctionnent 
    public function hookActionProductAdd($params)
    {
        if ( isset($params['product']->id) )
            $id_product = $params['product']->id ;
        elseif ( isset($params['id_product']) )
            $id_product = $params['id_product'] ;
        elseif ( isset($params['product']) )
            $id_product = $params['product']['id_product'] ; 
        else return(false) ;

        return( Amazon_Product::marketplaceActionSet(self::Add, $id_product) ) ;
    }    
    
    public function hookActionProductDelete($params)
    {
        if ( isset($params['product']->id) )
            $id_product = $params['product']->id ;
        elseif ( isset($params['id_product']) )
            $id_product = $params['id_product'] ;
        elseif ( isset($params['product']) )
            $id_product = $params['product']['id_product'] ; 
        else return(false) ;
       
        if ( ! isset($params['product']->reference) ) return(false) ;
        
        return( Amazon_Product::marketplaceActionSet(self::Remove, $id_product, null, $params['product']->reference) ) ;        
    }    

    public function hookActionProductSave($params)
    {
        if ( isset($params['product']->id) )
            $id_product = $params['product']->id ;
        elseif ( isset($params['id_product']) )
            $id_product = $params['id_product'] ;
        elseif ( isset($params['product']) )
            $id_product = $params['product']['id_product'] ; 
        else return(false) ;
        
        return( Amazon_Product::marketplaceActionSet(self::Update, $id_product) ) ; 
    }

    public function hookActionUpdateQuantity($params)
    {
        if ( isset($params['product']->id) )
            $id_product = $params['product']->id ;
        elseif ( isset($params['id_product']) )
            $id_product = $params['id_product'] ;
        elseif ( isset($params['product']) )
            $id_product = $params['product']['id_product'] ; 
        else return(false) ;

        $id_product_attribute = isset($params['id_product_attribute']) ? $params['id_product_attribute'] : null ;
        
        return( Amazon_Product::marketplaceActionSet(self::Update, $id_product, $id_product_attribute) ) ; 
    }
    
    public function hookActionProductUpdate($params)
    {
        if ( isset($params['product']->id) )
            $id_product = $params['product']->id ;
        elseif ( isset($params['id_product']) )
            $id_product = $params['id_product'] ;
        elseif ( isset($params['product']) )
            $id_product = $params['product']['id_product'] ; 
        else return(false) ;
        
        return( Amazon_Product::marketplaceActionSet(self::Update, $id_product) ) ; 
    }   

    public function hookActionProductAttributeUpdate($params)
    {
        if ( ! isset($params['id_product_attribute']) ) return(false) ;
        
        return( Amazon_Product::marketplaceActionUpdateCombination($params['id_product_attribute']) ) ;
    }  
    
    /* HOOKS FOR BACKWARD COMPATIBILITY - PRESTASHOP 1.3 and 1.4 */
    
    public function hookUpdateQuantity($params)
    {
        return( $this->hookActionUpdateQuantity($params) ) ;
    }
    
    public function hookUpdateProduct($params)
    {
        return( $this->hookActionProductUpdate($params) ) ;
    }    
    
    public function hookUpdateProductAttribute($params)
    {
        return( $this->hookActionProductAttributeUpdate($params) ) ;
    }    
   
    public function hookDeleteProduct($params)
    {
        return( $this->hookActionProductDelete($params) ) ;
    }
    public function hookAddProduct($params)
    {
        return( $this->hookActionProductAdd($params) ) ;
    }

    public function hookActionCarrierUpdate($params)
    {
        return( $this->hookUpdateCarrier($params) ) ;
    } 
    
    public function hookAdminOrder($params)
    {
        return( $this->hookDisplayAdminOrder($params) ) ;
    } 
    
    
    
    //
    // HOOKs SETUP for all Prestashop releases
    //
    private function _hookSetup($action) 
    {
       if ( version_compare(_PS_VERSION_, '1.5', '<') )
       {
           $expectedHooks = 
                array('addproduct', 'deleteProduct', 'updateProductAttribute', 'updateQuantity', 'updateproduct', 'updateCarrier', 'adminOrder', 'backOfficeHeader', 'updateOrderStatus') ;
       }
       else
       {
           $expectedHooks = 
                array('displayAdminOrder', 'displayBackOfficeHeader', 'actionCarrierUpdate', 'actionUpdateQuantity', 'actionProductUpdate', 'actionProductAttributeDelete', 'actionProductSave', 'actionProductDelete', 'actionAttributeGroupDelete', 'actionProductAdd', 'actionAttributeGroupSave') ;
       }
       $pass = true ;

       if ( $action == Amazon::Add )
        foreach($expectedHooks as $expectedHook)
            if ( ! $this->isRegisteredInHook($expectedHook) )
                if ( ! $this->registerHook($expectedHook) )
                    $this->_postErrors[] = $this->l('Unable to Register Hook') . ':' . $expectedHook && $pass = false ;

       if ( $action == Amazon::Remove )
        foreach($expectedHooks as $expectedHook)
            if ( $this->isRegisteredInHook($expectedHook) )
                if ( ! $this->unregisterHook($expectedHook) )
                    $this->_postErrors[] = $this->l('Unable to Unregister Hook') . ':' . $expectedHook && $pass = false ;
                
       return($pass) ;
    }      
    
    // MarketPlace Strategies - Optionnal Module
    //
    private function _addMarketPlaceTables()
    {
        $pass = true;

        // Check if exists
        //
      $tables = array();
        $query = Db::getInstance()->ExecuteS('show tables');
        foreach ($query as $rows)
            foreach ($rows as $table)
                $tables[$table] = 1;

        if (isset($tables[_DB_PREFIX_ . 'marketplace_strategies']))
        {
            $pass = true;
        }
        else
        {
            $sql =
                    'CREATE TABLE  `' . _DB_PREFIX_ . 'marketplace_strategies` (
                `id` int(11) NOT NULL AUTO_INCREMENT,
                `id_product` int(11) NOT NULL,
                `id_lang` int(11) NOT NULL,
                `minimum_price` float NOT NULL,
                `actual_price` float NOT NULL,
                `target_price` float NOT NULL,
                `gap` float NOT NULL,
                PRIMARY KEY (`id`),
                KEY `id_product` (`id_product`),
                KEY `id_product_lang` (`id_product`,`id_lang`)
              ) ;';

            if (!Db::getInstance()->Execute($sql))
                $pass = false;
        }

        if ( ! isset($tables[_DB_PREFIX_ . 'marketplace_product_action']) )
        {
            $sql = '
                    CREATE TABLE IF NOT EXISTS `' . _DB_PREFIX_ . 'marketplace_product_action` (
                    `id_product` int(11) NOT NULL,
                    `id_product_attribute` int(11) DEFAULT NULL,
                    `id_lang` int(11) NOT NULL,
                    `sku` varchar(64) DEFAULT NULL,
                    `marketplace` varchar(12) NOT NULL,
                    `action` char(1) NOT NULL,
                    `date_add` datetime DEFAULT NULL,
                    `date_upd` datetime DEFAULT NULL,
                    UNIQUE KEY `id_product` (`id_product`,`id_lang`,`marketplace`,`action`),
                    KEY `id_lang` (`id_lang`,`marketplace`)
                    ) ;' ; 

            if (!Db::getInstance()->Execute($sql))
                $pass = false;
        }        
        
       
        if (isset($tables[_DB_PREFIX_ . 'marketplace_product_option']))
        {
            $pass = true;
            $sqls = array();

            $fields = array();

            // Amazon Update - Add new fields
            //
            $query = Db::getInstance()->ExecuteS('show columns from `' . _DB_PREFIX_ . 'marketplace_product_option`');
            foreach ($query as $row)
                $fields[$row['Field']] = 1;

            if (!isset($fields['nopexport']))
                $sqls[] = 'ALTER TABLE  `' . _DB_PREFIX_ . 'marketplace_product_option` ADD  `nopexport` TINYINT NULL DEFAULT NULL AFTER `force`';
            if (!isset($fields['noqexport']))
                $sqls[] = 'ALTER TABLE  `' . _DB_PREFIX_ . 'marketplace_product_option` ADD  `noqexport` TINYINT NULL DEFAULT NULL AFTER `nopexport`';
            if (!isset($fields['latency']))
                $sqls[] = 'ALTER TABLE  `' . _DB_PREFIX_ . 'marketplace_product_option` ADD  `latency` TINYINT NULL DEFAULT NULL AFTER `noqexport`';
            if (!isset($fields['disable']))
                $sqls[] = 'ALTER TABLE  `' . _DB_PREFIX_ . 'marketplace_product_option` ADD  `disable` TINYINT NULL DEFAULT NULL AFTER `latency`';
            if (!isset($fields['price']))
                $sqls[] = 'ALTER TABLE  `' . _DB_PREFIX_ . 'marketplace_product_option` ADD  `price` FLOAT NULL DEFAULT NULL AFTER `disable`';
            if (!isset($fields['asin1']))
                $sqls[] = 'ALTER TABLE  `' . _DB_PREFIX_ . 'marketplace_product_option` ADD  `asin1` VARCHAR(16) NULL DEFAULT NULL AFTER `price`';
            if (!isset($fields['asin2']))
                $sqls[] = 'ALTER TABLE  `' . _DB_PREFIX_ . 'marketplace_product_option` ADD  `asin2` VARCHAR(16) NULL DEFAULT NULL AFTER `asin1`';
            if (!isset($fields['asin3']))
                $sqls[] = 'ALTER TABLE  `' . _DB_PREFIX_ . 'marketplace_product_option` ADD  `asin3` VARCHAR(16) NULL DEFAULT NULL AFTER `asin2`';
            if (!isset($fields['shipping']))
                $sqls[] = 'ALTER TABLE  `' . _DB_PREFIX_ . 'marketplace_product_option` ADD  `shipping` FLOAT NULL DEFAULT NULL AFTER `asin3`';
            if (!isset($fields['shipping_type']))
                $sqls[] = 'ALTER TABLE  `' . _DB_PREFIX_ . 'marketplace_product_option` ADD  `shipping_type` FLOAT NULL DEFAULT NULL AFTER `shipping`';
            if (!isset($fields['fba']))
                $sqls[] = 'ALTER TABLE  `' . _DB_PREFIX_ . 'marketplace_product_option` ADD  `fba` TINYINT NULL DEFAULT NULL AFTER `noqexport`';
            
            // For Next updates - for old module installations - the scheme has changed
            //
            if (isset($fields['latency']))
                $sqls[] = 'ALTER TABLE  `' . _DB_PREFIX_ . 'marketplace_product_option` CHANGE  `latency`  `latency` TINYINT NULL DEFAULT NULL';
            if (isset($fields['nopexport']))
                $sqls[] = 'ALTER TABLE  `' . _DB_PREFIX_ . 'marketplace_product_option` CHANGE  `nopexport`  `nopexport` TINYINT NULL DEFAULT NULL';
            if (isset($fields['noqexport']))
                $sqls[] = 'ALTER TABLE  `' . _DB_PREFIX_ . 'marketplace_product_option` CHANGE  `noqexport`  `noqexport` TINYINT NULL DEFAULT NULL';
            if (isset($fields['price']))
                $sqls[] = 'ALTER TABLE  `' . _DB_PREFIX_ . 'marketplace_product_option` CHANGE  `price`  `price` FLOAT NULL DEFAULT NULL';
            if (isset($fields['asin1']))
                $sqls[] = 'ALTER TABLE  `' . _DB_PREFIX_ . 'marketplace_product_option` CHANGE  `asin1`  `asin1` VARCHAR(16) NULL DEFAULT NULL';
            if (isset($fields['asin2']))
                $sqls[] = 'ALTER TABLE  `' . _DB_PREFIX_ . 'marketplace_product_option` CHANGE  `asin2`  `asin2` VARCHAR(16) NULL DEFAULT NULL';
            if (isset($fields['asin3']))
                $sqls[] = 'ALTER TABLE  `' . _DB_PREFIX_ . 'marketplace_product_option` CHANGE  `asin3`  `asin3` VARCHAR(16) NULL DEFAULT NULL';
            if (isset($fields['disable']))
                $sqls[] = 'ALTER TABLE  `' . _DB_PREFIX_ . 'marketplace_product_option` CHANGE  `disable`  `disable` TINYINT NULL DEFAULT NULL';
            if (isset($fields['force']))
                $sqls[] = 'ALTER TABLE  `' . _DB_PREFIX_ . 'marketplace_product_option` CHANGE  `force`  `force` TINYINT NULL DEFAULT NULL';
            if (isset($fields['text']))
                $sqls[] = 'ALTER TABLE  `' . _DB_PREFIX_ . 'marketplace_product_option` CHANGE  `text`  `text` VARCHAR(128) NULL DEFAULT NULL';

            
            // Added on 2012/11/26
            //
            if (!isset($fields['id_product_attribute']))
            {
                $sqls[] = 'ALTER TABLE  `' . _DB_PREFIX_ . 'marketplace_product_option` ADD  `id_product_attribute` INT NULL DEFAULT NULL AFTER `id_lang`';
            
                $sqls[] = 'ALTER TABLE  `' . _DB_PREFIX_ . 'marketplace_product_option` 
                           ADD UNIQUE  `id_product_lang_attribute` (  `id_product` ,  `id_lang` ,  `id_product_attribute` )' ;
            }

            foreach ($sqls as $sql)
                $pass = Db::getInstance()->Execute($sql) && $pass;
        }
        else
        {

            $sql = 'CREATE TABLE  `' . _DB_PREFIX_ . 'marketplace_product_option` (
                  `id_product` INT NOT NULL ,
                  `id_lang` INT NOT NULL ,
                  `force` TINYINT NULL DEFAULT NULL,
                  `nopexport` TINYINT NULL DEFAULT NULL,
                  `noqexport` TINYINT NULL DEFAULT NULL,
                  `fba` TINYINT NULL DEFAULT NULL,
                  `latency` TINYINT NULL DEFAULT NULL,
                  `disable` TINYINT NULL DEFAULT NULL,
                  `price` FLOAT NULL DEFAULT NULL,
                  `asin1` VARCHAR(16) NULL DEFAULT NULL,
                  `asin2` VARCHAR(16) NULL DEFAULT NULL,
                  `asin3` VARCHAR(16) NULL DEFAULT NULL,
                  `text` VARCHAR(128) NULL DEFAULT NULL,
                  `shipping` FLOAT NULL DEFAULT NULL,
                  `shipping_type` TINYINT NULL DEFAULT NULL,
                   UNIQUE KEY `id_product` (`id_product`,`id_lang`)
                  ) ;';


            if (!Db::getInstance()->Execute($sql))
                $pass = false;
        }

        return($pass);
    }

    private function _removeMarketPlaceTables()
    {
        $pass = true;
        //return(true);
        // Check if exists
        //
      $tables = array();
        $query = Db::getInstance()->ExecuteS('show tables');
        foreach ($query as $rows)
            foreach ($rows as $table)
                $tables[$table] = 1;

        if (isset($tables[_DB_PREFIX_ . 'marketplace_product_option']))
        {
            $sql = 'DROP TABLE  `' . _DB_PREFIX_ . 'marketplace_product_option` ; ';

            if (!Db::getInstance()->Execute($sql))
                $pass = false;
        }

        if (isset($tables[_DB_PREFIX_ . 'marketplace_strategies`']))
        {
            $sql = 'DROP TABLE  `' . _DB_PREFIX_ . 'marketplace_strategies` ; ';

            if (!Db::getInstance()->Execute($sql))
                $pass = false;
        }
        return($pass);
    }

    // Add MarketPlace OrderID in the order table
    //
    private function _addMarketPlaceField()
    {
        $pass = true;

        // Adding Marketplace fields - order
        //
        $fields = array();
        $query = Db::getInstance()->ExecuteS('show columns from `' . _DB_PREFIX_ . 'orders`');
        foreach ($query as $row)
            $fields[$row['Field']] = 1;

        if (!isset($fields['mp_order_id']))
        {
            if (!Db::getInstance()->Execute('ALTER TABLE  `' . _DB_PREFIX_ . 'orders` ADD  `mp_order_id` VARCHAR( 24 ) NULL, ADD INDEX (`mp_order_id` )'))
                $pass = false;
        }

        // Adding Marketplace fields - status
        //
        if (!isset($fields['mp_status']))
        {
            if (!Db::getInstance()->Execute('ALTER TABLE  `' . _DB_PREFIX_ . 'orders` ADD  `mp_status` VARCHAR( 24 ) NULL'))
                $pass = false;
        }

        // Adding Marketplace fields - channel
        //
        if (!isset($fields['mp_channel']))
        {
            if (!Db::getInstance()->Execute('ALTER TABLE  `' . _DB_PREFIX_ . 'orders` ADD  `mp_channel` VARCHAR( 16 ) NULL'))
                $pass = false;
        }


        // For Updates : Set All Order to checked to avoid to send many orders statuses to Amazon
        //
        require_once(dirname(__FILE__) . '/classes/amazon.order.class.php');
        
        $fields = array();
        $query = Db::getInstance()->getRow('SELECT count(`id_order`) as `count` FROM `' . _DB_PREFIX_ . 'orders` WHERE `mp_status` = ' . Amazon_Order::Checked . ' AND `module` = "Amazon"');
        
        if ( isset($query['count']) && $query['count'] == 0 )
        {
            Db::getInstance()->Execute('UPDATE `' . _DB_PREFIX_ . 'orders` SET `mp_status` =  ' . Amazon_Order::Checked . '  WHERE `module` = "Amazon"' );    
        }
        return($pass);
    }

    private function _removeMarketPlaceField()
    {
        $pass = true;
        //return(true);
        // Adding Marketplace fields - order
        //
        $fields = array();
        $query = Db::getInstance()->ExecuteS('show columns from `' . _DB_PREFIX_ . 'orders`');
        foreach ($query as $row)
            $fields[$row['Field']] = 1;

        $sql = 'ALTER TABLE  `' . _DB_PREFIX_ . 'orders`
              DROP `mp_order_id` ;';

        if ( isset($fields['mp_order_id']) )
            if (!Db::getInstance()->Execute($sql))
                $pass = false;

        $sql = 'ALTER TABLE  `' . _DB_PREFIX_ . 'orders`
              DROP `mp_status` ;';

        if ( isset($fields['`mp_status`']) )
            if (!Db::getInstance()->Execute($sql))
                $pass = false;

        $sql = 'ALTER TABLE  `' . _DB_PREFIX_ . 'orders`
              DROP `mp_channel` ;';
        
        if ( isset($fields['`mp_channel']) )
            if (!Db::getInstance()->Execute($sql))
                $pass = false;

        
        return($pass);
    }

    // Add a customer / it will hold the market place orders
    //

    private function _createCustomer()
    {
        $pass = true;
        $existingCustomer = true;

        // Fakemail
        //
      $var = explode('@', Configuration::get('PS_SHOP_EMAIL'));

        while ($existingCustomer)
        {
            $email = 'no-reply-' . rand(10000, 10000000) . '@' . $var[1];

            $customer = new Customer();
            $customer->firstname = 'Amazon';
            $customer->lastname = 'Amazon Market Place';
            $customer->email = $email;
            $customer->newsletter = false;
            $customer->optin = false;
            $customer->passwd = md5(rand(1111111111, 9999999999));
            $customer->active = true;
            $customer->date_add = date('Y-m-d H:i:s');
            $customer->date_upd = $customer->date_add;

            if (Customer::customerExists($customer->email))
                continue;

            $pass = $customer->add();
            $existingCustomer = false;
        }

        self::configurationUpdateValue('AMAZON_CUSTOMER_ID', $customer->id);

        return($pass);
    }

    private function _deleteCustomer()
    {
        $customer = new Customer(Configuration::get('AMAZON_CUSTOMER_ID'));

        if (Customer::customerExists($customer->email))
            return( $customer->delete() );
        else
            return(true);
    }

    private function installModuleTab($tabClass, $tabName, $idTabParent)
    {
        $pass = true;
        $tabNameLang = array();

        @copy(_PS_MODULE_DIR_ . $this->name . '/images/a16.gif', _PS_IMG_DIR_ . 't/' . $tabClass . '.gif');

        foreach (Language::getLanguages() as $language)
            $tabNameLang[$language['id_lang']] = $tabName;

        $tab = new Tab();
        $tab->name = $tabNameLang;
        $tab->class_name = $tabClass;
        $tab->module = $this->name;
        $tab->id_parent = (int) $idTabParent;

        // For Prestashop 1.2
        //
        if ( version_compare(_PS_VERSION_, '1.3', '<') )    
            $pass = $tab->add();
        else
            $pass = $tab->save();

        return($pass);
    }

    private function uninstallModuleTab($tabClass)
    {
        $pass = true;
        @unlink(_PS_IMG_DIR_ . 't/' . $tabClass . '.gif');
        $idTab = Tab::getIdFromClassName($tabClass);
        if ($idTab != 0)
        {
            $tab = new Tab($idTab);
            $pass = $tab->delete();
        }
        return($pass);
    }

    
    // Compatibilty for front office functions
    //
    public static function configurationGet($param)
    {
        if ( version_compare(_PS_VERSION_,'1.5','>=') )
            return Configuration::getGlobalValue($param) ;
        else
            return Configuration::get($param) ;
    }
    public static function configurationUpdateValue($param, $value)
    {
        if ( version_compare(_PS_VERSION_,'1.5','>=') )
            return Configuration::updateGlobalValue($param, $value) ;
        else
            return Configuration::updateValue($param, $value) ;
    }      
}

?>