<?php


  class Amazon_Product extends Product
  {
          public function __construct($id_product = NULL, $full = false, $id_lang = NULL, $reference = 'reference')
          {

              // get combination first
              $sql = 'SELECT `id_product` FROM `'._DB_PREFIX_.'product_attribute` p where `' . $reference . '` = "' . $id_product . '" ;' ;

              $rq = Db::getInstance()->ExecuteS($sql);

              if ( ! isset($rq[0]) || ! $rq[0]['id_product'] )
              {
                $sql = 'SELECT `id_product` FROM `'._DB_PREFIX_.'product` p where `' . $reference . '` = "' . $id_product . '" ;' ;

                $rq = Db::getInstance()->ExecuteS($sql);

                if ( ! isset($rq[0]) || ! $rq[0]['id_product'] )
                    return false ;


              }

              return( parent::__construct($rq[0]['id_product'], $full, $id_lang) ) ;
          }

          static public	function getProductById($id_product)
          {
              $sql = 'SELECT `reference` FROM `'._DB_PREFIX_.'product` p where id_product = "' . $id_product . '" ;' ;

                $rq = Db::getInstance()->ExecuteS($sql);

                 return( $rq[0]['reference'] ) ;
          }

          // Options produits (actif, stock etc..)
          //
          static public	function getProductOptions($id_product, $id_lang)
          {
              $sql = 'SELECT * FROM `'._DB_PREFIX_.'marketplace_product_option` p where id_product = "' . $id_product . '" and id_lang = "' . $id_lang . '" ;' ;

              $rq = Db::getInstance()->ExecuteS($sql);

              if ( $rq )
                return( array_shift($rq) ) ;
              else
                return( array('force' => 0, 'nopexport' => 0, 'noqexport' => 0, 'fba' => 0, 'latency' => 0, 'disable' => 0, 'price' => '', 'asin1' => '', 'asin2' => '', 'asin3' => '', 'text' => '', 'shipping' => '', 'shipping_type' => '') ) ;
          }
          static public	function setProductOptions($id_product, $id_lang, $options)
          {
              //
              // NB: Shipping : We don't cast to float the shipping value: this value could be 0 or > 0 or NULL !
              //
              $sql = 'REPLACE INTO `'._DB_PREFIX_.'marketplace_product_option`
                      (`id_product`, `id_lang`, `force`, `nopexport`, `noqexport`, `fba`, `latency`, `price`, `asin1`, `asin2`, `asin3`, `text`, `disable`, `shipping`, `shipping_type`) values(' .
                      pSQL($id_product)                 . ', ' .
                      pSQL($id_lang)                    . ', ' .
                      intval($options['force'])         . ', ' .
                      intval($options['nopexport'])     . ', ' .
                      intval($options['noqexport'])     . ', ' .
                      intval($options['fba'])           . ', ' .
                      intval($options['latency'])       . ', ' .
                      floatval($options['price'])       . ', "' .
                      pSQL($options['asin1'])           . '", "' .
                      pSQL($options['asin2'])           . '", "' .
                      pSQL($options['asin3'])           . '", "' .
                      pSQL($options['text'])            . '", ' .
                      intval($options['disable'])       . ', ' .
                      (is_numeric($options['shipping']) ? $options['shipping'] : 'NULL')    . ', ' .
                      intval($options['shipping_type']) . '); ' ;

              $rq = Db::getInstance()->Execute($sql);

              self::marketplaceActionSet(Amazon::Update, $id_product) ;

              return( $rq ) ;
          }


          static public	function setProductASIN($id_product, $id_lang, $asins)
          {
              $pass = true ;

              if ( ! is_array($asins) ) $asins = array(0 => $asins) ;

              for($i = 0 ; $i < count($asins) && $i < 3 ; $i++)
              {
                if ( ! isset($asins[$i]) || ! empty($asin[$i]) )   continue ;

                $sql = 'SELECT `id_product` FROM `'._DB_PREFIX_.'marketplace_product_option` WHERE `id_product` =' . intval($id_product) . ' AND `id_lang`= ' . $id_lang ;

                if (  Db::getInstance()->getRow($sql) )
                {

                    $sql = 'UPDATE `'._DB_PREFIX_.'marketplace_product_option` set `asin' . ($i + 1) . '`="' . pSQL($asins[$i]) . '"' .
                           ' WHERE `id_product` = ' . intval($id_product) . ' AND `id_lang`= ' . $id_lang ;

                    if ( ! $rq = Db::getInstance()->Execute($sql) ) $pass = false && $pass ;
                }
                else
                {

                  $sql = 'REPLACE INTO `'._DB_PREFIX_.'marketplace_product_option`
                          (`id_product`, `id_lang`, `asin' . ($i + 1) . '`) values(' .
                          pSQL($id_product)                 . ', ' .
                          pSQL($id_lang)                    . ', "' .
                          pSQL($asins[$i]) . '") ;' ;

                  if ( ! $rq = Db::getInstance()->Execute($sql) ) $pass = false && $pass ;

                }
              }
              $pass = self::marketplaceActionSet(Amazon::Update, $id_product) && $pass ;

              if ( $pass )
                  return( $rq ) ;
              else return(false) ;

          }

          static public	function propagateProductOptionsText($id_product, $id_lang, $id_category, $option)
          {
              $pass = true ;

              $products = Db::getInstance()->ExecuteS('SELECT id_product from `'._DB_PREFIX_.'product` where id_category_default = ' . intval($id_category)) ;

              foreach($products as $product)
              {
                $sql = 'INSERT IGNORE `'._DB_PREFIX_.'marketplace_product_option`
                (`id_product`,`id_lang`,`text`)
                values ('. $product['id_product'] .', ' . intval($id_lang) . ', "' . pSQL($option['text']) . '")' ;

                if ( ! Db::getInstance()->Execute($sql) ) $pass = false ;

              }

              $sql = 'UPDATE `'._DB_PREFIX_.'marketplace_product_option` mpo, `'._DB_PREFIX_.'product` p SET
                    mpo.`text` = "' . pSQL($option['text']) . '"
                    WHERE p.id_product = mpo.id_product and p.id_category_default = ' . intval($id_category) . ' and id_lang = ' . intval($id_lang)  ;

              if ( ! Db::getInstance()->Execute($sql) ) $pass = $pass && false ;

              self::marketplaceActionSet(Amazon::Update, $id_product) ;

              return($pass) ;
          }

          static public	function propagateToShopProductOptionsText($id_product, $id_lang, $option)
          {
              $pass = true ;

              $products = Db::getInstance()->ExecuteS('SELECT id_product from `'._DB_PREFIX_.'product`') ;

              foreach($products as $product)
              {
                $sql = 'INSERT IGNORE `'._DB_PREFIX_.'marketplace_product_option`
                    (`id_product`,`id_lang`,`text`) values (
                    '. $product['id_product'] .', ' . intval($id_lang) . ', "' . pSQL($option['text']) . '")' ;

                if ( ! Db::getInstance()->Execute($sql) ) $pass = false ;
              }

              if ( ! Db::getInstance()->Execute($sql) ) $pass = false ;

              $sql = 'UPDATE `'._DB_PREFIX_.'marketplace_product_option` mpo, `'._DB_PREFIX_.'product` p SET
                    mpo.`text` = "' . pSQL($option['text']) . '"
                    WHERE p.id_product = mpo.id_product and id_lang = ' . intval($id_lang)  ;

              if ( ! Db::getInstance()->Execute($sql) ) $pass = $pass && false ;

              self::marketplaceActionSet(Amazon::Update, $id_product) ;

              return($pass) ;
          }

          static public	function propagateProductOptionsLatency($id_product, $id_lang, $id_category, $option)
          {
              $pass = true ;


              $products = Db::getInstance()->ExecuteS('SELECT id_product from `'._DB_PREFIX_.'product`') ;

              foreach($products as $product)
              {
                  $sql = 'INSERT IGNORE `'._DB_PREFIX_.'marketplace_product_option`
                    (`id_product`,`id_lang`,`latency`)
                    values (
                    '. $product['id_product'] .', ' . intval($id_lang) . ', ' . intval($option['latency']) . ')' ;

                  if ( ! Db::getInstance()->Execute($sql) ) $pass = false ;
              }

              if ( ! Db::getInstance()->Execute($sql) ) $pass = false ;

              $sql = 'UPDATE `'._DB_PREFIX_.'marketplace_product_option` mpo, `'._DB_PREFIX_.'product` p SET
                    mpo.`latency` = "' . intval($option['latency']) . '"
                    WHERE p.id_product = mpo.id_product and p.id_category_default = ' . intval($id_category) . ' and id_lang = ' . intval($id_lang)  ;

              if ( ! Db::getInstance()->Execute($sql) ) $pass = $pass && false ;

              self::marketplaceActionSet(Amazon::Update, $id_product) ;

              return($pass) ;
          }

          static public	function propagateToShopProductOptionsLatency($id_product, $id_lang, $option)
          {
              $pass = true ;

              $products = Db::getInstance()->ExecuteS('SELECT id_product from `'._DB_PREFIX_.'product`') ;

              foreach($products as $product)
              {
                  $sql = 'INSERT IGNORE `'._DB_PREFIX_.'marketplace_product_option`
                    (`id_product`,`id_lang`,`latency`)
                    values ('. $product['id_product'] .', ' . intval($id_lang) . ', ' . intval($option['latency']) . ') ;' ;

                  if ( ! Db::getInstance()->Execute($sql) ) $pass = false ;
              }


              if ( ! Db::getInstance()->Execute($sql) ) $pass = false ;

              $sql = 'UPDATE `'._DB_PREFIX_.'marketplace_product_option` mpo, `'._DB_PREFIX_.'product` p SET
                    mpo.`latency` = ' . pSQL($option['latency']) . '
                    WHERE p.id_product = mpo.id_product and id_lang = ' . intval($id_lang)  ;

              if ( ! Db::getInstance()->Execute($sql) ) $pass = $pass && false ;

              self::marketplaceActionSet(Amazon::Update, $id_product) ;

              return($pass) ;
          }



          static public	function propagateProductOptionsShipping($id_product, $id_lang, $id_category, $option)
          {
              $pass = true ;

              //
              // NB: We don't cast to float the shipping value: this value could be 0 or > 0 or NULL !
              //

              $products = Db::getInstance()->ExecuteS('SELECT id_product from `'._DB_PREFIX_.'product`') ;

              foreach($products as $product)
              {
                  $sql = 'INSERT IGNORE `'._DB_PREFIX_.'marketplace_product_option`
                    (`id_product`,`id_lang`,`shipping`,`shipping_type`)
                    values (
                    '. $product['id_product'] .', ' . intval($id_lang) . ', ' . (is_numeric($option['shipping']) ? $option['shipping'] : 'NULL') . ', ' . intval($option['shipping_type']) . ') ;' ;

                  if ( ! Db::getInstance()->Execute($sql) ) $pass = false ;
              }

              if ( ! Db::getInstance()->Execute($sql) ) $pass = false ;

              $sql = 'UPDATE `'._DB_PREFIX_.'marketplace_product_option` mpo, `'._DB_PREFIX_.'product` p SET
                    mpo.`shipping` = ' . (is_numeric($option['shipping']) ? $option['shipping'] : 'NULL') . ', mpo.`shipping_type` = ' . intval($option['shipping_type']) . '
                    WHERE p.id_product = mpo.id_product and p.id_category_default = ' . intval($id_category) . ' and id_lang = ' . intval($id_lang)  ;

              if ( ! Db::getInstance()->Execute($sql) ) $pass = $pass && false ;

              self::marketplaceActionSet(Amazon::Update, $id_product) ;

              return($pass) ;
          }

          static public	function propagateToShopProductOptionsShipping($id_product, $id_lang, $option)
          {
              $pass = true ;

              //
              // NB: We don't cast to float the shipping value: this value could be 0 or > 0 or NULL !
              //

              $products = Db::getInstance()->ExecuteS('SELECT id_product from `'._DB_PREFIX_.'product`') ;

              foreach($products as $product)
              {
                  $sql = 'INSERT IGNORE `'._DB_PREFIX_.'marketplace_product_option`
                    (`id_product`,`id_lang`,`shipping`,`shipping_type`)
                    values ('. $product['id_product'] .', ' . intval($id_lang) . ', ' . (is_numeric($option['shipping']) ? $option['shipping'] : 'NULL') . ', ' . intval($option['shipping_type']) . ') ;' ;

                  if ( ! Db::getInstance()->Execute($sql) ) $pass = false ;
              }


              if ( ! Db::getInstance()->Execute($sql) ) $pass = false ;

              $sql = 'UPDATE `'._DB_PREFIX_.'marketplace_product_option` mpo, `'._DB_PREFIX_.'product` p SET
                    mpo.`shipping` = ' . (is_numeric($option['shipping']) ? $option['shipping'] : 'NULL') . ', mpo.`shipping_type` = ' . intval($option['shipping_type']) . '
                    WHERE p.id_product = mpo.id_product and id_lang = ' . intval($id_lang)  ;

              if ( ! Db::getInstance()->Execute($sql) ) $pass = $pass && false ;

              self::marketplaceActionSet(Amazon::Update, $id_product) ;

              return($pass) ;
          }


          // Disable


          static public	function propagateProductOptionsDisable($id_product, $id_lang, $id_category, $option)
          {
              $pass = true ;


              $products = Db::getInstance()->ExecuteS('SELECT id_product from `'._DB_PREFIX_.'product`') ;

              foreach($products as $product)
              {
                  $sql = 'INSERT IGNORE `'._DB_PREFIX_.'marketplace_product_option`
                    (`id_product`,`id_lang`,`disable`)
                    values (
                    '. $product['id_product'] .', ' . intval($id_lang) . ', ' . intval($option['disable']) . ')' ;

                  if ( ! Db::getInstance()->Execute($sql) ) $pass = false ;
              }

              if ( ! Db::getInstance()->Execute($sql) ) $pass = false ;

              $sql = 'UPDATE `'._DB_PREFIX_.'marketplace_product_option` mpo, `'._DB_PREFIX_.'product` p SET
                    mpo.`disable` = ' . intval($option['disable']) . '
                    WHERE p.id_product = mpo.id_product and p.id_category_default = ' . intval($id_category) . ' and id_lang = ' . intval($id_lang)  ;

              if ( ! Db::getInstance()->Execute($sql) ) $pass = $pass && false ;

              self::marketplaceActionSet(Amazon::Update, $id_product) ;

              return($pass) ;
          }

          static public	function propagateToShopProductOptionsDisable($id_product, $id_lang, $option)
          {
              $pass = true ;

              $products = Db::getInstance()->ExecuteS('SELECT id_product from `'._DB_PREFIX_.'product`') ;

              foreach($products as $product)
              {
                  $sql = 'INSERT IGNORE `'._DB_PREFIX_.'marketplace_product_option`
                    (`id_product`,`id_lang`,`disable`)
                    values ('. $product['id_product'] .', ' . intval($id_lang) . ', ' . intval($option['disable']) . ') ;' ;

                  if ( ! Db::getInstance()->Execute($sql) ) $pass = false ;
              }


              if ( ! Db::getInstance()->Execute($sql) ) $pass = false ;

              $sql = 'UPDATE `'._DB_PREFIX_.'marketplace_product_option` mpo, `'._DB_PREFIX_.'product` p SET
                    mpo.`disable` = ' . pSQL($option['disable']) . '
                    WHERE p.id_product = mpo.id_product and id_lang = ' . intval($id_lang)  ;

              if ( ! Db::getInstance()->Execute($sql) ) $pass = $pass && false ;

              self::marketplaceActionSet(Amazon::Update, $id_product) ;

              return($pass) ;
          }

          static public	function propagateToManufacturerProductOptionsDisable($id_product, $id_lang, $id_manufacturer, $option)
          {
              $pass = true ;

              $products = Db::getInstance()->ExecuteS('SELECT id_product from `'._DB_PREFIX_.'product`') ;

              foreach($products as $product)
              {
                  $sql = 'INSERT IGNORE `'._DB_PREFIX_.'marketplace_product_option`
                    (`id_product`,`id_lang`)
                    values ('. $product['id_product'] .', ' . intval($id_lang) . ') ;' ;

                  if ( ! Db::getInstance()->Execute($sql) ) $pass = false ;
              }


              if ( ! Db::getInstance()->Execute($sql) ) $pass = false ;

              $sql = 'UPDATE `'._DB_PREFIX_.'marketplace_product_option` mpo, `'._DB_PREFIX_.'product` p, `'._DB_PREFIX_.'manufacturer` m SET
                    mpo.`disable` = ' . pSQL($option['disable']) . '
                    WHERE p.id_product = mpo.id_product AND p.id_manufacturer = m.id_manufacturer AND p.id_manufacturer = ' . intval($id_manufacturer) . ' AND id_lang = ' . intval($id_lang)  ;

              if ( ! Db::getInstance()->Execute($sql) ) $pass = $pass && false ;

              self::marketplaceActionSet(Amazon::Update, $id_product) ;

              return($pass) ;
          }

          // Force


          static public	function propagateProductOptionsForce($id_product, $id_lang, $id_category, $option)
          {
              $pass = true ;

              $products = Db::getInstance()->ExecuteS('SELECT id_product from `'._DB_PREFIX_.'product`') ;

              foreach($products as $product)
              {
                  $sql = 'INSERT IGNORE `'._DB_PREFIX_.'marketplace_product_option`
                    (`id_product`,`id_lang`,`force`)
                    values (
                    '. $product['id_product'] .', ' . intval($id_lang) . ', ' . intval($option['force']) . ')' ;

                  if ( ! Db::getInstance()->Execute($sql) ) $pass = false ;
              }

              if ( ! Db::getInstance()->Execute($sql) ) $pass = false ;

              $sql = 'UPDATE `'._DB_PREFIX_.'marketplace_product_option` mpo, `'._DB_PREFIX_.'product` p SET
                    mpo.`force` = ' . intval($option['force']) . '
                    WHERE p.id_product = mpo.id_product and p.id_category_default = ' . intval($id_category) . ' and id_lang = ' . intval($id_lang)  ;

              if ( ! Db::getInstance()->Execute($sql) ) $pass = $pass && false ;

              self::marketplaceActionSet(Amazon::Update, $id_product) ;

              return($pass) ;
          }

          static public	function propagateToShopProductOptionsForce($id_product, $id_lang, $option)
          {
              $pass = true ;

              $products = Db::getInstance()->ExecuteS('SELECT id_product from `'._DB_PREFIX_.'product`') ;

              foreach($products as $product)
              {
                  $sql = 'INSERT IGNORE `'._DB_PREFIX_.'marketplace_product_option`
                    (`id_product`,`id_lang`,`force`)
                    values ('. $product['id_product'] .', ' . intval($id_lang) . ', ' . intval($option['force']) . ') ;' ;

                  if ( ! Db::getInstance()->Execute($sql) ) $pass = false ;
              }


              if ( ! Db::getInstance()->Execute($sql) ) $pass = false ;

              $sql = 'UPDATE `'._DB_PREFIX_.'marketplace_product_option` mpo, `'._DB_PREFIX_.'product` p SET
                    mpo.`force` = ' . pSQL($option['force']) . '
                    WHERE p.id_product = mpo.id_product and id_lang = ' . intval($id_lang)  ;

              if ( ! Db::getInstance()->Execute($sql) ) $pass = $pass && false ;

              self::marketplaceActionSet(Amazon::Update, $id_product) ;

              return($pass) ;
          }

          static public	function propagateToManufacturerProductOptionsForce($id_product, $id_lang, $id_manufacturer, $option)
          {
              $pass = true ;

              $products = Db::getInstance()->ExecuteS('SELECT id_product from `'._DB_PREFIX_.'product`') ;

              foreach($products as $product)
              {
                  $sql = 'INSERT IGNORE `'._DB_PREFIX_.'marketplace_product_option`
                    (`id_product`,`id_lang`)
                    values ('. $product['id_product'] .', ' . intval($id_lang) . ') ;' ;

                  if ( ! Db::getInstance()->Execute($sql) ) $pass = false ;
              }


              if ( ! Db::getInstance()->Execute($sql) ) $pass = false ;

              $sql = 'UPDATE `'._DB_PREFIX_.'marketplace_product_option` mpo, `'._DB_PREFIX_.'product` p, `'._DB_PREFIX_.'manufacturer` m SET
                    mpo.`force` = ' . pSQL($option['force']) . '
                    WHERE p.id_product = mpo.id_product AND p.id_manufacturer = m.id_manufacturer AND p.id_manufacturer = ' . intval($id_manufacturer) . ' AND id_lang = ' . intval($id_lang)  ;

              if ( ! Db::getInstance()->Execute($sql) ) $pass = $pass && false ;

              self::marketplaceActionSet(Amazon::Update, $id_product) ;

              return($pass) ;
          }

          static public function getAllProducts($id_lang, $id_category = false, $only_active = false)
          {
                  $sql = 'SELECT p.id_product
                  FROM `'._DB_PREFIX_.'product` p ' .
                  ($id_category ? 'LEFT JOIN `'._DB_PREFIX_.'category_product` c ON (c.`id_product` = p.`id_product`)' : '').'
                  LEFT JOIN `'._DB_PREFIX_.'product_lang` pl ON (p.`id_product` = pl.`id_product`)
                  WHERE pl.`id_lang` = '.intval($id_lang).
                  ($id_category ? ' AND c.`id_category` = '.intval($id_category) : '').
                  ($only_active ? ' AND p.`active` = 1' : '').'
                  GROUP by p.id_product ORDER BY p.date_add desc ' ;

                  $rq = Db::getInstance()->ExecuteS($sql);

                  return ($rq);
          }


          static public function oldest()
          {
              $sql = '
                  SELECT MIN(date_add) as date_min FROM `'._DB_PREFIX_.'product`;' ;
              if ( ($rq = Db::getInstance()->ExecuteS($sql)) && is_array($rq) )
              {
                $result = array_shift($rq);
                return(str_replace('-', '/', $result['date_min'])) ;
              }
              else
                return(false) ;
          }

          
          static public function getEligibleProdctsForCreation($id_lang, $id_category, $only_active = false, $in_stock = false)
          {
                if (version_compare(_PS_VERSION_, '1.4', '<'))
                    $upc = false ;
                else
                    $upc = true ;
			  	
              $sql = '
                    SELECT p.`id_product`, pa.`id_product_attribute`, 
                    if ( p.`reference`, p.`reference`, pa.`reference` ) as SKU ,
                    if ( pa.`ean13`, pa.`ean13`, p.`ean13` ) as EAN ,
                    ' . ($upc ?  'if ( pa.`upc`, pa.`upc`, p.`upc`) as UPC,' : '') . '
                    po.`asin1`
                    FROM `'._DB_PREFIX_.'product` p
                    LEFT JOIN `'._DB_PREFIX_.'product_attribute` pa on (p.`id_product` = pa.`id_product`)
                    LEFT JOIN `'._DB_PREFIX_.'product_lang` pl on (p.`id_product` = pl.`id_product`)
                    LEFT JOIN `'._DB_PREFIX_.'marketplace_product_option` po on (p.`id_product` = po.`id_product` and pl.`id_lang` = po.`id_lang` and pa.`id_product_attribute` = po.`id_product_attribute`)
                    WHERE pl.`id_lang` = ' . intval($id_lang) . '
                    AND (p.`reference` != "" OR pa.`reference` != "") AND ((p.`ean13` > "" ' . ($upc ? 'OR p.`upc` > ""' : '') . ') OR (pa.`ean13` > "" ' . ($upc ? 'OR pa.`upc` > ""' : '') . ') )    
                    AND po.`asin1` IS NULL                    
                    GROUP by p.`id_product`, pa.`id_product_attribute`, pl.`id_lang`
                    HAVING SKU > ""' ;

                  $rq = Db::getInstance()->ExecuteS($sql);

                  return ($rq);
          }

          static public function marketplaceActionList($id_lang)
          {
              $sql = '
                SELECT `id_product`, `action`, `sku`, min(`date_add`) as date_start, max(`date_add`) as date_stop FROM `'._DB_PREFIX_.'marketplace_product_action` 
                    WHERE `marketplace` = "' . Amazon::marketplace . '" AND id_lang = ' . intval($id_lang) . '
                    AND (`date_upd` = "" OR `date_upd` = NULL OR `date_upd` IS NULL)
                    GROUP by `id_product`
                    ORDER by `date_add` ASC' ;

              if ( ! ($rq = Db::getInstance()->ExecuteS($sql)) ) return(false) ;
              
              return($rq) ;
          }          
          
          static public function marketplaceActionSet($action, $id_product, $id_product_attribute = null, $sku = null)
          {
              // In Marketplace Categories
              //
              if ( $id_product && ! self::marketplaceInCategories($id_product) )    return(false) ;

              // Get Actives Platforms
              //
              $actives = unserialize(base64_decode(Amazon::configurationGet('AMAZON_ACTIVE')));

              if ( ! is_array($actives) )
                  return(false) ;

              // On ne traite pas les attribute sur les updates !
              // 
              if ( $action == Amazon::Update )
                $id_product_attribute = null ;

              $pass = true ;
              
              foreach( array_keys($actives) as $id_lang )
              {    
                $sql = 'REPLACE INTO `'._DB_PREFIX_.'marketplace_product_action`
                        (`id_product`, `id_product_attribute`, `id_lang`, `sku`, `marketplace`, `action`, `date_add`, `date_upd`) values(' .
                        intval($id_product)               . ', ' .
                        (! $id_product_attribute ? 'NULL' : $id_product_attribute) . ', ' .
                        intval($id_lang)                  . ', "' .
                        pSQL($sku)                        . '", "' .
                        pSQL(Amazon::marketplace)         . '", "' .
                        pSQL($action)                     . '", "' . 
                        date('Y-m-d H:i:s')               . '", NULL) ' ;

                $rq = Db::getInstance()->Execute($sql) || $pass = true ;
              }

              return($pass);  
          }

          static public function marketplaceActionUpdateCombination($id_product_attribute)
          {
		  	  if (version_compare(_PS_VERSION_, '1.4', '<'))
			  	$upc = false ;
			  else
			  	$upc = true ;
			  			  
              $sql = '
                        SELECT id_product
                        FROM `'._DB_PREFIX_.'product_attribute` pa
                        WHERE pa.`id_product_attribute` = ' . intval($id_product_attribute) . ' AND pa.`reference` > "" AND (pa.`ean13` > "" ' . ($upc ? 'OR pa.`upc` > ""' : '') . ')
                        GROUP by pa.`id_product` ' ;
              
               if ( ! ($rq = Db::getInstance()->getRow($sql)) ) return(false) ;
              
               self::marketplaceActionSet(Amazon::Update, $rq['id_product']) || $pass = false ;

               return($pass);  
          }  
          static public function marketplaceActionRemoveAllCombinations($action, $id_product)
          {
		  	  if (version_compare(_PS_VERSION_, '1.4', '<'))
			  	$upc = false ;
			  else
			  	$upc = true ;
						  
              $sql = '
                        SELECT reference, id_product_attribute
                        FROM `'._DB_PREFIX_.'product_attribute` pa
                        WHERE pa.`id_product` = ' . intval($id_product) . ' AND pa.`reference` > "" AND (pa.`ean13` > "" ' . ($upc ? 'OR pa.`upc` > ""' : '') .')
                        GROUP by pa.`id_product`, pa.`id_product_attribute`, pa.`reference` ' ;

               if ( ! ($rq = Db::getInstance()->ExecuteS($sql)) ) return(false) ;
               
               foreach($rq as $combination)
                   self::marketplaceActionSet(Amazon::Remove, $id_product, $combination['id_product_attribute'], $combination['reference']) || $pass = false ;

               return($pass);  
          }          
          
          static public function marketplaceInCategories($id_product)
          {        
              // Categories Lookup
              //
              $categories = unserialize(base64_decode(Amazon::configurationGet('AMAZON_CATEGORIES'))) ;
              
              if ( ! $categories || ! count($categories) )
                  return(false) ;
              
              $list = implode(',', $categories) ;
              
              $sql = 
                'SELECT `id_product` FROM `'._DB_PREFIX_.'category_product` WHERE `id_product` = ' . intval($id_product) . ' AND `id_category` IN(' . $list . ')' ;
                         
              if ( ! $rq = Db::getInstance()->getRow($sql) ) 
                  return(false) ;
              
              return(true) ;
          }

          static public function marketplaceActionGetSku($id_product)
          {
		  	  if (version_compare(_PS_VERSION_, '1.4', '<'))
			  	$upc = false ;
			  else
			  	$upc = true ;

                $sql = '
                        SELECT `reference`
                        FROM `'._DB_PREFIX_.'product` p
                        WHERE p.`id_product` = ' . intval($id_product) . ' AND p.`reference` > "" AND (p.`ean13` > "" ' . ($upc ? 'OR p.`upc` > ""' : ''). ')' ;

                $rq = Db::getInstance()->getRow($sql) ; 

                if ( isset($rq['reference']) && ! empty($rq['reference']))
                    return($rq['reference']) ;
                
                return(false) ;
          }          
          static public function marketplaceActionGetCombinationSku($id_product)
          {
                $sql = '
                        SELECT reference, id_product_attribute
                        FROM `'._DB_PREFIX_.'product_attribute` pa
                        WHERE pa.`id_product` = ' . intval($id_product) . ' AND pa.`reference` > "" AND (pa.`ean13` > "" OR pa.`upc` > "")
                        GROUP by pa.`id_product`, pa.`id_product_attribute` ' ;
              
                $rq = Db::getInstance()->getRow($sql) ; 
                
                if ( isset($rq['reference']) && ! empty($rq['reference']))
                    return($rq['reference']) ;
                
                return(false) ;
          }
          static public function marketplaceGetAllProducts($id_lang, $only_active = false, $since = false)
          {
                // Categories Lookup
                //
                $categories = unserialize(base64_decode(Amazon::configurationGet('AMAZON_CATEGORIES'))) ;

                if ( ! $categories || ! count($categories) )
                    return(false) ;

                $list = implode(',', $categories) ;              
                
                if ( $since )
                    $dateRange = ' AND (p.`date_add` >= "' . pSQL($since) . '" OR p.`date_upd` >= "' . pSQL($since) . '") ' ;
                else
                    $dateRange = '' ;
                    
                $sql = 'SELECT p.id_product FROM `'._DB_PREFIX_.'product` p 
                        LEFT JOIN `'._DB_PREFIX_.'category_product` c ON (c.`id_product` = p.`id_product`)                    
                        LEFT JOIN `'._DB_PREFIX_.'product_lang` pl ON (p.`id_product` = pl.`id_product`)
                        WHERE pl.`id_lang` = '.intval($id_lang).
                        $dateRange .
                        ($only_active ? ' AND p.`active` = 1' : '').'
                        AND c.id_category IN (' . $list . ')
                        GROUP by p.id_product ORDER BY p.date_add desc ' ;

                $rq = Db::getInstance()->ExecuteS($sql);
#echo nl2br(print_r($rq,true)) ;die;
                return ($rq);
          }          
           
          static public function marketplaceCountProducts()
          {
 		  	  if (version_compare(_PS_VERSION_, '1.4', '<'))
				  	$upc = false ;
			  else
				  	$upc = true ;
					
                // Categories Lookup
                //
                $categories = unserialize(base64_decode(Amazon::configurationGet('AMAZON_CATEGORIES'))) ;

                if ( ! $categories || ! count($categories) )
                    return(false) ;

                $list = implode(',', $categories) ;    
                
                $sql = '
                        SELECT count(p.id_product) as products FROM `'._DB_PREFIX_.'product` p
                            LEFT JOIN `'._DB_PREFIX_.'category_product` c ON (c.`id_product` = p.`id_product`)
                            WHERE p.`active` = 1
                            AND p.`reference` > "" AND (p.`ean13` > "" ' . ($upc ? 'OR p.`upc` > ""' : '') . ')
                            AND c.id_category IN (' . $list . ')' ;

                 $rq1 = Db::getInstance()->ExecuteS($sql) ;

                 $sql = '
                        SELECT count(pa.id_product) as attributes FROM `'._DB_PREFIX_.'product_attribute` pa
                            LEFT JOIN `'._DB_PREFIX_.'category_product` c ON (c.`id_product` = pa.`id_product`)
                            WHERE 
                              pa.`reference` > "" AND (pa.`ean13` > "" ' . ($upc ?  'OR pa.`upc` > ""' : '') . ')
                              AND c.id_category IN (' . $list . ')
                            ' ;   
                
                 $rq2 = Db::getInstance()->ExecuteS($sql) ;                

                 if ( empty($rq1) or ! is_array($rq1) ) 
                 {
                     $rq1 = array() ;
                     $rq1[0] = array('products' => 0, 'attributes' => 0) ;
                 }
                 if ( empty($rq2) or ! is_array($rq2) ) 
                 {
                     $rq2 = array() ;
                     $rq2[0] = array('products' => 0, 'attributes' => 0) ;
                 }
                 
                 return( array_merge( array_shift($rq1), array_shift($rq2)) ) ;
          }        

          static public function marketplaceActionReset($id_lang)
          {
                 $sql = '
                        DELETE FROM `'._DB_PREFIX_.'marketplace_product_action` WHERE `id_lang`=' . intval($id_lang) ;
                 
                 return( Db::getInstance()->Execute($sql) ) ;
          }

          static public function marketplaceActionAcknowledgde($id_lang, $dateStart, $dateEnd, $dateAcknowledgde, $revert = false)
          {
                 // Revert ack on error   
                 if ( $revert ) $dateAcknowledgde = '' ;
                     
                 $sql = 'UPDATE `'._DB_PREFIX_.'marketplace_product_action` SET `date_upd`="' . pSQL($dateAcknowledgde) . '" WHERE `date_add` BETWEEN "' . pSQL($dateStart) . '" AND "' . pSQL($dateEnd) . '" AND `id_lang`=' . intval($id_lang) ;            
                 
                 return( Db::getInstance()->Execute($sql) ) ;
          }          

          // Only for PS < 1.5
          static public function updateProductQuantity($id_product, $id_product_attribute, $quantity)
          {
              $pass = true ;

              if ( $id_product_attribute )
              {
                  $sql = '
                      UPDATE `'._DB_PREFIX_.'product_attribute` set quantity = ' . intval($quantity) . ' where id_product=' . intval($id_product) . ' and id_product_attribute = ' . intval($id_product_attribute) ;

                  if ( ! $rq = Db::getInstance()->Execute($sql) )
                          $pass = $pass && false ;

                  $sql = '
                      UPDATE `'._DB_PREFIX_.'product` set quantity = ' . intval($quantity) . ' where id_product=' . intval($id_product) ;

                  if ( ! $rq = Db::getInstance()->Execute($sql) )
                      $pass = $pass && false ;
              }
              else
              {
                  $sql = '
                      UPDATE `'._DB_PREFIX_.'product` set quantity = "' . intval($quantity) . '" where id_product=' . intval($id_product) ;

                  if ( ! $rq = Db::getInstance()->Execute($sql) )
                      $pass = $pass && false ;
              }
              return($pass) ;
          }

          
}
?>