<?php


class Amazon_SpecificField extends Module
{
    private static $features = null ;    
    private static $attributes = null ;    
    
    static public function displayFields($profile_name, $extraFieldsArray)
    {
        if ( ! isset($extraFieldsArray['field']) || ! $extraFieldsArray['field'] )  return(null) ;

        // Load Features Once
        if ( self::$features === null )
        {
            $id_lang = Configuration::get('PS_LANG_DEFAULT') ;
            self::$features = Feature::getFeatures($id_lang) ;
        }         
        if ( self::$attributes === null )
        {
            $id_lang = $id_lang ? $id_lang : Configuration::get('PS_LANG_DEFAULT') ;
            self::$attributes = AttributeGroup::getAttributesGroups((int)$id_lang) ;
        }          
         
        $html = '' ;
        
        
        foreach($extraFieldsArray['field'] as $field => $value)
        {
            /*
             * Field is a variant : eg: Size-Color, Length
             */
            if ( $field == 'variant' )
            {   
                $html .= '<span class="extra-span"><b>Variant</b></span>' ;
                
                // Current Selected Variant
                $selected = $value ;
                
                // Choose Name
                $html .= '<select name="profiles[extra][' . $profile_name . '][field][variant]" class="variant" >
                        <option></option>' . "\n" ;                    

                foreach($extraFieldsArray['variant'] as $variant)
                {
                    $variant_name = preg_replace('/([A-Z])/', ' \1', implode(' / ', array_keys($variant))) ;
                    $variant_key  = implode('-', array_keys($variant)) ;

                    $html .= '
                            <option value="' . $variant_key . '" ' .  ($variant_key == $selected ? 'selected="selected"' : '') . '>' . $variant_name . '</option>' . "\n" ;
                }    
                $html .= '</select>' . "\n" ;                        
            
                $html .= '<table style="margin-left:30px;">' ;   
                // Variant Tables
                foreach($extraFieldsArray['variant'] as $variant)
                {
                    $variant_name = preg_replace('/([A-Z])/', ' \1', implode(' / ', array_keys($variant))) ;
                    $variant_key  = implode('-', array_keys($variant)) ;
               
                    foreach($variant as $name => $value)
                    {
                        if ( $variant_key !== $selected )
                                $style='display:none';
                        else    $style='' ;
                        
                        $sub_variant_name = preg_replace('/([A-Z])/', ' \1', $name) ;
                        
                        $html .= '<tr class="variant-items" rel="' . $variant_key . '" style="' . $style . ';">' ;
                        $html .= '<td style="text-align:right;padding-right:10px;width:110px;">' . $sub_variant_name .  '</td>' ;  
                        $html .= '<td>' ;
                        $html .= '<select name="profiles[extra][' . $profile_name . '][variant][' . $variant_key . '][' . $name . ']" style="width:150px;">
                                <option></option>' . "\n" ;

                        /*
                         * Attributes Groups: Color, Capacity ...
                         */
                        foreach(self::$attributes as $attribute)
                        {
                            
                            $html .= '
                                    <option value="' . $attribute['id_attribute_group'] . '" ' .  ($attribute['id_attribute_group'] === $value ? 'selected="selected"' : '') . '>' . $attribute['name'] . '</option>' . "\n" ;
                        }
                        $html .= '</select>' . "\n" ;
                        
                        /*
                         *  XML tag will have attributes eg: Length value="5" unit="centimeters"
                         */
                        
                        if ( isset($extraFieldsArray['values'][$variant_key][$name]) )
                        {
                            $selected_value = 0 ;

                            if ( isset($extraFieldsArray['attributes'][$variant_key][$name]['unitOfMeasure']) )
                            {    
                                $selected_value = $extraFieldsArray['attributes'][$variant_key][$name]['unitOfMeasure'] ;
                                $kind = 'unitOfMeasure' ;
                            }
                            // Else ... what ? another attributes possibles...

                            if ( isset($extraFieldsArray['values'][$variant_key][$name]) )
                            {
                                $html .= '<input type="hidden" class="extra-input" name="profiles[extra][' . $profile_name . '][values][' . $variant_key . '][' . $name . ']" value="' . $extraFieldsArray['values'][$variant_key][$name] . '" />';
                                $allowedValues = unserialize(base64_decode($extraFieldsArray['values'][$variant_key][$name])) ;

                                $select = '<select name="profiles[extra][' . $profile_name . '][attributes][' . $variant_key . '][' . $name . '][' . $kind . ']">';
                                $select .= '<option value="">' . 'Choose' . '</option>';
                                foreach ($allowedValues as $value)
                                {
                                    $select .= '<option value="' . $value . '" ' . ($selected_value === $value ? 'selected="selected"' : '') . '>' . $value . '</option>';
                                }
                                $select .= '</select>';
                                $html .= $select ;
                            }                            
                        }
                        
                        
                        $html .= '</td><td></td></tr>' ;
                    }
                }
                $html .= '</table>' ;
                
            }            
            elseif ( isset($extraFieldsArray['characteristic'][$field]) )
            {    
                $html .= sprintf('<span class="extra-span">%s&nbsp;</span>', preg_replace('/([A-Z])/', ' \1', $field)) ;
                $html .= '<input type="hidden" class="extra-input" name="profiles[extra][' . $profile_name . '][characteristic][' . $field . ']" value="1" />';

                $html .= '<select name="profiles[extra][' . $profile_name . '][field][' . $field . ']" >
                        <option></option>' . "\n" ;
                foreach(self::$features as $feature)
                {
                    if ( $feature['id_feature'] == $value )
                        $selected=' selected="selected"' ;
                    else
                        $selected='' ;

                    $html .= '
                            <option value="' . $feature['id_feature'] . '" ' .  $selected . '>' . $feature['name'] . '</option>' . "\n" ;
                }
                $html .= '</select>' . "\n" ;                                

            }
            elseif ( isset($extraFieldsArray['attributes'][$field]) )
            {
                $html .= '<span class="extra-span">' . preg_replace('/([A-Z])/', ' \1', $field)  . '&nbsp;</span>' ;
                $html .= '<input type="text" class="extra-input"  name="profiles[extra]['.$profile_name.'][field]['.$field.']" value="' . $value . '" />';
                $html .=  '&nbsp;&nbsp;' ;

                if ( isset($extraFieldsArray['attributes'][$field]) )
                {
                    // Selected Value
                    $selected_value = 0 ;
                    
                    if ( isset($extraFieldsArray['attributes'][$field]['unitOfMeasure']) )
                    {    
                        $selected_value = $extraFieldsArray['attributes'][$field]['unitOfMeasure'] ;
                        $kind = 'unitOfMeasure' ;
                    }
                    // Else ... what ?
                    
                    if ( isset($extraFieldsArray['values'][$field]) )
                    {
                        $html .= '<input type="hidden" class="extra-input" name="profiles[extra][' . $profile_name . '][values][' . $field . ']" value="' . $extraFieldsArray['values'][$field] . '" />';
                        $allowedValues = unserialize(base64_decode($extraFieldsArray['values'][$field])) ;
                        
                        $select = '<select name="profiles[extra][' . $profile_name . '][attributes][' . $field . '][' . $kind . ']">';
                        $select .= '<option value="">' . 'Choose' . '</option>';
                        foreach ($allowedValues as $value)
                        {
                            if ( $selected_value === $value )
                                    $selected='selected="selected"' ;
                            else    $selected='' ;
                            $select .= '<option value="' . $value . '" ' . $selected . '>' . $value . '</option>';
                        }
                        $select .= '</select>';
                        $html .= $select ;
                    }
                }
            }
            else
            {
                $html .= '<span class="extra-span">' . preg_replace('/([A-Z])/', ' \1', $field)  . '&nbsp;</span>' ;
                $html .= '<input type="text" class="extra-input"  name="profiles[extra]['.$profile_name.'][field]['.$field.']" value="' . $value . '" />';
            }            
            if ( isset($extraFieldsArray['required'][$field]) )
            {
                $html .= '<input type="hidden" class="extra-input" name="profiles[extra][' . $profile_name . '][required][' . $field . ']" value="1" />';
                $html .= '&nbsp;&nbsp;<span class="extra-required">*</span>';
            }
            $html .= '<br />' . "\n";
            
        }            
        return($html) ;
    }
}

?>