<?php


 class Amazon_Tools extends Tools
 {
     
    //  Check Access Tokens
    //
    static public function checkToken($token, $id_lang, $europe = false)
    {
      $id_lang_master = false;  
      $amazonTokens = unserialize(base64_decode(Amazon::configurationGet('AMAZON_CRON_TOKEN'))) ;
      $marketPlaceRegion = unserialize(base64_decode(Amazon::configurationGet('AMAZON_REGION'))) ;
      $marketPlaceMaster = unserialize(base64_decode(Amazon::configurationGet('AMAZON_MASTER'))) ;

      $marketPlaceRegion2Lang = array_flip($marketPlaceRegion) ;

      if ( $europe )
      {
          if ( isset($marketPlaceRegion2Lang[ $marketPlaceMaster ]) )
          $id_lang_master = $marketPlaceRegion2Lang[ $marketPlaceMaster ] ;

          if ( is_array($token) )
              if ( isset($token[$id_lang_master]) )
              $token = $token[$id_lang_master] ;

          if ( ! isset($amazonTokens[$id_lang_master]) || $token != $amazonTokens[$id_lang_master] )
              return(false) ;
      }
      else
      {
          if ( is_array($token) )
              $token = $token[$id_lang] ;

          if ( ! isset($amazonTokens[$id_lang]) || $token != $amazonTokens[$id_lang] )
              return(false) ;
      }
      return(true) ;
    }

    // Select platform or select platforms for Europe
    //
    static function selectPlatforms($id_lang, $debug = false)
    {
      $marketPlaceId = null ;
      
      // Amazon Europe overidding
      //
      $amazonEurope      = unserialize(base64_decode(Amazon::configurationGet('AMAZON_EUROPE'))) ;
      $marketPlaceMaster = unserialize(base64_decode(Amazon::configurationGet('AMAZON_MASTER'))) ;
      $marketPlaceRegion = unserialize(base64_decode(Amazon::configurationGet('AMAZON_REGION'))) ;

      // Amazon API keypairs
      //
      $merchantIds        = unserialize(base64_decode(Amazon::configurationGet('AMAZON_MERCHANT_ID'))) ;
      $marketPlaceIds     = unserialize(base64_decode(Amazon::configurationGet('AMAZON_MARKETPLACE_ID'))) ;
      $awsKeyIds          = unserialize(base64_decode(Amazon::configurationGet('AMAZON_AWS_KEY_ID'))) ;
      $awsSecretKeys      = unserialize(base64_decode(Amazon::configurationGet('AMAZON_SECRET_KEY'))) ;

      // Currencies
      //
      $currencies         = unserialize(base64_decode(Amazon::configurationGet('AMAZON_CURRENCY'))) ;


      // Platform list
      $platforms = array() ;

      // Amazon Marketplace Europe values
      //
      $europeanPlatforms = array('A13V1IB3VIYZZH', 'A1RKKUPIHCS9HS', 'A1PA6795UKMFR9', 'APJ6JRA9NG5V4', 'A1F83G8C2ARO7P') ;

      $marketPlaceRegion2Lang = array_flip($marketPlaceRegion) ;
      $marketPlaceMasterLangId = false ;

      if ( isset($marketPlaceRegion2Lang[$marketPlaceMaster]) )
          $marketPlaceMasterLangId = $marketPlaceRegion2Lang[$marketPlaceMaster] ;

      if ( $marketPlaceMasterLangId && $amazonEurope && in_array($marketPlaceIds[$id_lang], $europeanPlatforms) )
      {
        // auth
        $merchantId         = trim($merchantIds[$marketPlaceMasterLangId]) ;
        $awsKeyId           = trim($awsKeyIds[$marketPlaceMasterLangId]) ;
        $awsSecretKey       = trim($awsSecretKeys[$marketPlaceMasterLangId]) ;

        foreach($marketPlaceIds as $amazon_lang => $currentMarketPlaceId)
        {
            if ( $amazon_lang == $id_lang )
              $selected = $id_lang ;
            else
              $selected = '' ;

            if ( ! in_array($currentMarketPlaceId, $europeanPlatforms) )
              continue ;

            // UK Exception
            if ( $currentMarketPlaceId != 'A1F83G8C2ARO7P' )
              $platforms[] = $currentMarketPlaceId ;

            if ( isset($selected) && $selected == $id_lang )
                $marketPlaceId = trim($marketPlaceIds[$id_lang]) ;
        }

        // UK Exception
        if ( $marketPlaceId == 'A1F83G8C2ARO7P' )
          $platforms = array() ;

        // Clear Duplicates
        if ( $platforms )
        {
          foreach($platforms as $idx => $platform)
            if ( $platform == $marketPlaceId )
                unset($platforms[$idx]) ;
          $platforms = array_values($platforms) ;
        }

        // Return values
        $amzCurrency = array() ;
        $amzCurrency['Currency'] = $currencies[$id_lang] ;
        $amzCurrency['Country'] = $marketPlaceRegion[$id_lang] ;

        $auth = array(
             'MerchantID'     => $merchantId,
             'MarketplaceID'  => $marketPlaceId,
             'AWSAccessKeyID' => $awsKeyId,
             'SecretKey'      => $awsSecretKey
        ) ;
      }
      else
      {
        if ( ! isset($merchantIds[$id_lang]) || ! isset($marketPlaceIds[$id_lang]) || ! isset($awsKeyIds[$id_lang]) || ! isset($awsSecretKeys[$id_lang]) )  return(false) ;
        
        $merchantId         = trim($merchantIds[$id_lang]) ;
        $marketPlaceId      = trim($marketPlaceIds[$id_lang]) ;
        $awsKeyId           = trim($awsKeyIds[$id_lang]) ;
        $awsSecretKey       = trim($awsSecretKeys[$id_lang]) ;

        $auth = array(
             'MerchantID'     => $merchantId,
             'MarketplaceID'  => $marketPlaceId,
             'AWSAccessKeyID' => $awsKeyId,
             'SecretKey'      => $awsSecretKey
        ) ;
        $platforms = array() ;

        $amzCurrency = array() ;
        $amzCurrency['Currency'] = $currencies[$id_lang] ;
        $amzCurrency['Country'] = $marketPlaceRegion[$id_lang] ;
      }
      if ( isset($debug) && $debug )
      {
        echo nl2br(print_r($auth, true)) ;
        echo nl2br(print_r($platforms, true)) ;
        echo nl2br(print_r($amzCurrency, true)) ;
      }
      return( array('params' => $amzCurrency, 'auth' => $auth, 'platforms' => $platforms) ) ;
  }


  // Select only 1 platform
  //
  static function selectPlatform($id_lang, $debug = false)
  {
    // Amazon Europe overidding
    //
    $amazonEurope      = unserialize(base64_decode(Amazon::configurationGet('AMAZON_EUROPE'))) ;
    $marketPlaceMaster = unserialize(base64_decode(Amazon::configurationGet('AMAZON_MASTER'))) ;
    $marketPlaceRegion = unserialize(base64_decode(Amazon::configurationGet('AMAZON_REGION'))) ;

    // Amazon API keypairs
    //
    $merchantIds        = unserialize(base64_decode(Amazon::configurationGet('AMAZON_MERCHANT_ID'))) ;
    $marketPlaceIds     = unserialize(base64_decode(Amazon::configurationGet('AMAZON_MARKETPLACE_ID'))) ;
    $awsKeyIds          = unserialize(base64_decode(Amazon::configurationGet('AMAZON_AWS_KEY_ID'))) ;
    $awsSecretKeys      = unserialize(base64_decode(Amazon::configurationGet('AMAZON_SECRET_KEY'))) ;
    
    if ( ! isset($marketPlaceIds[$id_lang]) )   
        return(false) ;

    // Currencies
    //
    $currencies         = unserialize(base64_decode(Amazon::configurationGet('AMAZON_CURRENCY'))) ;


    // Platform list
    $platforms = array() ;

    // Amazon Marketplace Europe values
    //
    $europeanPlatforms = array('A13V1IB3VIYZZH', 'A1RKKUPIHCS9HS', 'A1PA6795UKMFR9', 'APJ6JRA9NG5V4', 'A1F83G8C2ARO7P') ;

    $marketPlaceRegion2Lang = array_flip($marketPlaceRegion) ;
    if ( isset($marketPlaceRegion2Lang[$marketPlaceMaster]) )
         $marketPlaceMasterLangId = $marketPlaceRegion2Lang[$marketPlaceMaster] ;
    else $marketPlaceMasterLangId = null ;
    
    if ( $amazonEurope && in_array($marketPlaceIds[$id_lang], $europeanPlatforms) )
    {
      // auth
      $merchantId         = trim($merchantIds[$marketPlaceMasterLangId]) ;
      $awsKeyId           = trim($awsKeyIds[$marketPlaceMasterLangId]) ;
      $awsSecretKey       = trim($awsSecretKeys[$marketPlaceMasterLangId]) ;

      foreach($marketPlaceIds as $amazon_lang => $currentMarketPlaceId)
      {
          if ( $amazon_lang == $id_lang )
            $selected = $id_lang ;
          else
            $selected = '' ;

          if ( ! in_array($currentMarketPlaceId, $europeanPlatforms) )
            continue ;

          if ( isset($selected) && $selected == $id_lang )
          {
              $marketPlaceId = trim($marketPlaceIds[$id_lang]) ;
              break ;
          }
      }


      // Return values
      $amzCurrency = array() ;
      $amzCurrency['Currency'] = $currencies[$id_lang] ;
      $amzCurrency['Country'] = $marketPlaceRegion[$id_lang] ;

      $auth = array(
           'MerchantID'     => $merchantId,
           'MarketplaceID'  => $marketPlaceId,
           'AWSAccessKeyID' => $awsKeyId,
           'SecretKey'      => $awsSecretKey
      ) ;
    }
    else
    {
      $merchantId         = trim($merchantIds[$id_lang]) ;
      $marketPlaceId      = trim($marketPlaceIds[$id_lang]) ;
      $awsKeyId           = trim($awsKeyIds[$id_lang]) ;
      $awsSecretKey       = trim($awsSecretKeys[$id_lang]) ;

      $auth = array(
           'MerchantID'     => $merchantId,
           'MarketplaceID'  => $marketPlaceId,
           'AWSAccessKeyID' => $awsKeyId,
           'SecretKey'      => $awsSecretKey
      ) ;
      $platforms = array() ;

      $amzCurrency = array() ;
      $amzCurrency['Currency'] = $currencies[$id_lang] ;
      $amzCurrency['Country'] = $marketPlaceRegion[$id_lang] ;
    }
    if ( isset($debug) && $debug )
    {
      echo nl2br(print_r($auth, true)) ;
      echo nl2br(print_r($platforms, true)) ;
      echo nl2br(print_r($amzCurrency, true)) ;
    }
    return( array('params' => $amzCurrency, 'auth' => $auth, 'platforms' => $platforms) ) ;
  }

    static public function hfilter($str)
    {
      $str = htmlspecialchars(strip_tags($str)) ;
      $str = preg_replace("/\\n/i", '<br>', $str);
      $str = preg_replace("/\\r/i", '<br>', $str);
      return($str)  ;
    }

    static public function Formula($price, $formula)
    {
        $formula = trim($formula) ;
        $formula = preg_replace("/\\n/i", '', $formula);
        $formula = preg_replace("/\\r/i", '', $formula);

        if ( preg_match('#([0-9\., ]*)%#', $formula, $result) )
        {
          $toPercent = $price * (floatval($result[1]) / 100) ;
          $formula = preg_replace('#([0-9\., ]*)%#', $toPercent, $formula) ;
        }
        $formula = str_replace('%', '', $formula) ;
        $equation = str_replace('@', $price ? $price : 0, $formula) ;


        $result = self::_matheval($equation);
        return($result);
    }
    
    static public function CallBack($price, $callback)
    {
        $callback = preg_replace("/\\n/i", '', $callback);
        $callback = preg_replace("/\\r/i", '', $callback);

        $code = str_replace('@', $price ? $price : 0, $callback) ;

        return( eval("return $code;") ) ;
    }

    static public function idToDomain($id_lang)
    {
        $marketPlaceRegion = unserialize(base64_decode(Amazon::configurationGet('AMAZON_REGION')));

        if ( ! isset($marketPlaceRegion[$id_lang]) )    return(false) ;

        switch( $marketPlaceRegion[$id_lang] )
        {
          case 'uk' :
            return('co.uk') ;
          case 'us' :
            return('com') ;
          default:
            return($marketPlaceRegion[$id_lang]) ;
        }
    }

    static public function SellerCentralURL($id_lang, $orderID)
    {
        if ( ! ($tld = self::idToDomain($id_lang)) )  return(false) ;
          
        return('https://sellercentral.amazon.' . $tld . '/gp/orders-v2/details?ie=UTF8&orderID=' . $orderID) ;
    }
    
    static public function goToProductPage($id_lang, $asin)
    {
        if ( ! ($tld = self::idToDomain($id_lang)) )  return(false) ;
        
        return('http://www.amazon.' . $tld . '/gp/product/' . $asin) ;
    }

    static public function classifierURL($id_lang)
    {
        return('https://catalog-mapper-eu.amazon.com/catm/classifier/ProductClassifier.amzn') ;
    }    


    // Return availables languages
    //
    public static function languages()
    {
        $languages = Language::getLanguages();
        $available_languages = array() ;

        foreach ($languages as $language)
        {
          // For active languages
          //
          if ( $language['active'] === false )  continue ;

          // Allow only available platforms
          //
          switch ( $language['iso_code'] )
          {
            case 'fr' :
            case 'de' :
            case 'us' :
            case 'en' :
            case 'it' :
            case 'es' :
            case 'ca' :
            case 'jp' :
            case 'be' :
                $pass = true ;
                break;
            default :
                $pass = false ;
                continue ;
          }
          if ( ! $pass ) continue ;

          $available_languages[] = $language ;
         }
         return($available_languages);
    }

    static public function isEurope($iso_code)
    {
        switch($iso_code)
        {
          case 'fr' :
          case 'de' :
          case 'be' :
          case 'it' :
          case 'es' :
                return(true);
          default :
                return(false) ;
        }
    }
    static public function isEuropeMarketplaceId($marketplaceID)
    {
        return( in_array($marketplaceID, array('A13V1IB3VIYZZH', 'A1RKKUPIHCS9HS', 'A1PA6795UKMFR9', 'APJ6JRA9NG5V4', 'A1F83G8C2ARO7P')) ) ;
    }
    
    static public function marketplaceIdToFullfillmentCenterId($marketplaceID)
    {
        switch($marketplaceID)
        {
            case 'A13V1IB3VIYZZH' :
            case 'A1RKKUPIHCS9HS' :
            case 'A1PA6795UKMFR9' :
            case 'APJ6JRA9NG5V4' :
            case 'A1F83G8C2ARO7P' : // Europe
                $fullfillmentCenterId = 'AMAZON_EU' ;
                break;
            case 'ATVPDKIKX0DER' : // US
                $fullfillmentCenterId = 'AMAZON_NA' ;
                break;
            case 'A2EUQ1WTGCTBG2' : // Canada
                $fullfillmentCenterId = '?' ;            
                break ;
            case 'A1VC38T7YXB528' : // Japan
                $fullfillmentCenterId = 'AMAZON_JP' ;
                break ;
            default : 
                $fullfillmentCenterId = '?' ;            
                break ;
        }
        return($fullfillmentCenterId) ;
    }
    
    static public function toCurrency($price, $to_currency = NULL)
	{
	   //$currency = Currency::getCurrent();

		$c_rate = (is_array($to_currency) ? $to_currency['conversion_rate'] : $to_currency->conversion_rate);

  	if ($to_currency)
				$price /= $c_rate;

		return $price;
	}
	static public function fromCurrency($price, $from_currency = NULL)
	{
	  //$currency = Currency::getCurrent();
			
		$c_rate = (is_array($from_currency) ? $from_currency['conversion_rate'] : $to_currency->conversion_rate);

  	if ($from_currency)
				$price *= $c_rate;

		return $price;
	}

    // Shipping Rates
    //
    static public function getShippingRate($price, $rules)
    {
      $table = preg_split("/[;,]/" , rtrim(str_replace(' ', '', $rules), ';'));
      $rate = $table[ count($table) - 1 ] ; // max as default

      for ($i = 0; $i < sizeof($table); $i+=2) {
  	  if ( floatval($price) < floatval($table[$i]))
        {
          $rate = $table[$i+1] ;
          break;;
        }
      }
      return($rate) ;
    }

    static public function strip_html($html)
    {
        $text = strip_tags($html, '<br>') ;
        $text = preg_replace('#<br\s{0,}/{0,}>#i', "\n", $text);
        $text = preg_replace('#[\n]+#i', "\n", $text);
        return($text) ;
    }    
//
// Code pomp� et adapt� du core prestashop
//

	/**
	 * Build a categories tree
	 *
	 * @param array $indexedCategories Array with categories where product is indexed (in order to check checkbox)
	 * @param array $categories Categories to list
	 * @param array $current Current category
	 * @param integer $id_category Current category id
	 */
	static public function recurseCategoryForInclude($indexedCategories, $categories, $current, $id_category = 1, $id_category_default = NULL, $default_categories = array())
	{
		global $done;
		static $irow;
		global $html ;
		$html = isset($html) ? $html : null ;

        $images = __PS_BASE_URI__ . basename(_PS_MODULE_DIR_) . '/amazon/images/' ;

	  if ( is_array($default_categories) && in_array($id_category, $default_categories) )
      $checked = ' checked="checked"' ;
    else 
      $checked = '' ;
     
		if (!isset($done[$current['infos']['id_parent']]))
			$done[$current['infos']['id_parent']] = 0;
		$done[$current['infos']['id_parent']] += 1;

		$todo = sizeof($categories[$current['infos']['id_parent']]);
		$doneC = $done[$current['infos']['id_parent']];

		$level = $current['infos']['level_depth'] + 1;
		$img = $level == 1 ? 'lv1.gif' : 'lv'.$level.'_'.($todo == $doneC ? 'f' : 'b').'.gif';

		$html .= '
		<tr class="'.($irow++ % 2 ? 'alt_row' : '').'">
			<td>
				<input type="checkbox" name="categoryBox[]" class="categoryBox'.($id_category_default == $id_category ? ' id_category_default' : '').'" id="categoryBox_'.$id_category.'" value="'.$id_category.'"'.$checked.' />
			</td>
			<td>
				'.$id_category.'
			</td>
			<td>
				<img src="'.$images.$img.'" alt="" /> &nbsp;<label for="categoryBox_'.$id_category.'" class="t">'.stripslashes($current['infos']['name']).'</label>
			</td>
		</tr>';

		if (isset($categories[$id_category]))
			foreach ($categories[$id_category] AS $key => $row)
				if ($key != 'infos')
					Amazon_Tools::recurseCategoryForInclude($indexedCategories, $categories, $categories[$id_category][$key], $key, $id_category_default, $default_categories);

    return($html) ;
	}

	/**
	 * jsonDecode convert json string to php array / object
	 *
	 * @param string $json
	 * @param boolean $assoc  (since 1.4.2.4) if true, convert to associativ array
	 * @return array
	 */
	public static function jsonDecode($json, $assoc = false)
	{
		if (function_exists('json_decode'))
			return json_decode($json, $assoc);
		else
		{
			include_once(dirname(__FILE__).'/json/json.php');
			$pearJson = new Services_JSON(($assoc) ? SERVICES_JSON_LOOSE_TYPE : 0);
			return $pearJson->decode($json);
		}
	}

	/**
	 * Convert an array to json string
	 *
	 * @param array $data
	 * @return string json
	 */
	public static function jsonEncode($data)
	{
		if (function_exists('json_encode'))
			return json_encode($data);
		else
		{
			include_once(dirname(__FILE__).'/json/json.php');
			$pearJson = new Services_JSON();
			return $pearJson->encode($data);
		}
	}
        
        /*
         * For PS 1.2 compatibility
         */
	static public function getHttpHost($http = false, $entities = false, $ignore_port = false)
	{
                if (method_exists('Tools', 'getHttpHost'))
                {
                    return( Tools::getHttpHost($http, $entities, $ignore_port) ) ;
                }
                else
                {
                    $host = (isset($_SERVER['HTTP_X_FORWARDED_HOST']) ? $_SERVER['HTTP_X_FORWARDED_HOST'] : $_SERVER['HTTP_HOST']);
                    if ($entities)
                            $host = htmlspecialchars($host, ENT_COMPAT, 'UTF-8');
                    if ($http)
                            $host = (Amazon::configurationGet('PS_SSL_ENABLED') ? 'https://' : 'http://').$host;
                    return $host;
                }
	}   
        
        static public function getProductImages($id_product, $id_product_attribute, $id_lang)
        {
            $product = new Product($id_product) ;

            if ( intval($id_product_attribute) )
            {
                $images = $product->getCombinationImages($id_lang) ;
                $id_images = array() ;

                if ( is_array($images) && count($images) )
                {
                    if ( isset($images[$id_product_attribute]) )
                    {
                        foreach($images[$id_product_attribute] as $key => $image)
                            $id_images[]  = $image['id_image'] ;
                    }
                    else $id_images = false ;
                }
                else
                {
                    $images = $product->getImages($id_lang) ;
                    if ( is_array($images) && count($images) )
                    {
                        foreach($images as $key => $image)
                            $id_images[] = $image['id_image'] ;
                    }
                    else $id_images = false ;
                }
            }
            else
            {
                $images = $product->getImages($id_lang) ;
                if ( is_array($images) && count($images) )
                {
                    foreach($images as $key => $image)
                        $id_images[] = $image['id_image'] ;
                }
                else
                    $id_images = false ;
            }
            $images = array() ;

            if ( $id_images )
                foreach($id_images as $id_image)
                    $images[] = self::getImageUrl($id_image, $id_product) ;
            return($images) ;
       }

       static public function getImageUrl($id_image, $productid)
       {
            $image_type = 'large' ;
            $ext = 'jpg' ;

            #image url
            if ( preg_match('/^1\.[4-5]/', _PS_VERSION_) )
            {
                $image_obj = new Image($id_image);

                // PS > 1.4.3
                if ( method_exists($image_obj, 'getExistingImgPath') )
                {
                    $img_path = $image_obj->getExistingImgPath();
                    $imageurl = $img_path ;
                }
                else
                {
                    $imageurl = $productid.'-'.$id_image;
                }
            }
            else
                $imageurl = $productid.'-'.$id_image;

            if (version_compare(_PS_VERSION_, '1.5.3', '>='))
                    $image_type = ImageType::getFormatedName('large') ;
            if (version_compare(_PS_VERSION_, '1.5', '>='))
                    $image_type = 'large_default' ;
            else    $image_type = 'large' ;

            $imageurl = sprintf('%s-%s.%s', $imageurl, $image_type, $ext) ;

            return $imageurl;
       }

       // Source : http://www.edmondscommerce.co.uk/php/ean13-barcode-check-digit-with-php/
       // Many thanks ;)
       public static function EAN_UPC_Check($code){
            //first change digits to a string so that we can access individual numbers
            $digits = sprintf('%012s', substr(sprintf('%013s', $code), 0, 12)) ;
            // 1. Add the values of the digits in the even-numbered positions: 2, 4, 6, etc.
            $even_sum = $digits{1} + $digits{3} + $digits{5} + $digits{7} + $digits{9} + $digits{11};
            // 2. Multiply this result by 3.
            $even_sum_three = $even_sum * 3;
            // 3. Add the values of the digits in the odd-numbered positions: 1, 3, 5, etc.
            $odd_sum = $digits{0} + $digits{2} + $digits{4} + $digits{6} + $digits{8} + $digits{10};
            // 4. Sum the results of steps 2 and 3.
            $total_sum = $even_sum_three + $odd_sum;
            // 5. The check character is the smallest number which, when added to the result in step 4,  produces a multiple of 10.
            $next_ten = (ceil($total_sum/10))*10;
            $check_digit = $next_ten - $total_sum;
            return ((int)$code == (int)($digits . $check_digit));
        }
        
        // https://sellercentral.amazon.fr/gp/help/help-page.html/ref=pt_200692370_cont_scsearch?ie=UTF8&itemID=200692370
        // TODO: Add UPC Check
        public static function EAN_UPC_isPrivate($code){
            return(in_array(substr(sprintf('%013s', $code), 0, 1), array('2'))) ;
        }        

        /*
        found there : 
        http://fr.php.net/eval 
        David Schumann 
        04-Nov-2003 08:17 
        To evaluate math expressions (multiply, divide, addition, subtraction, percentages), 
        use the following function, based on Taras Young's 'evalsum' function posted earlier
        MERCI ! 
        */
        static private function _matheval($equation){
                $equation = preg_replace("/[^0-9+\-.*\/()%]/","",$equation);
                $equation = preg_replace("/([+-])([0-9]+)(%)/","*(1\$1.\$2)",$equation);
                // you could use str_replace on this next line
                // if you really, really want to fine-tune this equation
                $equation = preg_replace("/([0-9]+)(%)/",".\$1",$equation);
                if ( $equation == "" ) {
                        $return = 0;
                } else {
                        eval("\$return=" . $equation . ";" );
                }
                return $return;
        }       
       
 }

?>