<?php



require_once(dirname(__FILE__).'/../../../config/config.inc.php');
require_once(dirname(__FILE__).'/../../../init.php');

require_once(dirname(__FILE__).'/../classes/amazon.tools.class.php');
require_once(dirname(__FILE__).'/../classes/amazon.webservice.class.php');

require_once(dirname(__FILE__).'/../amazon.php');

class AmazonConnexionCheck extends Module
{
    private $module   = 'amazon';
    public  $name   = 'amazon';

    private $_amazon ;
    private $_debug ;

    function __construct()
    {
      global $cookie, $_MODULE;

      $langFile = _PS_MODULE_DIR_.$this->module.'/'.Language::getIsoById(intval($cookie->id_lang)).'.php';
      $mySelf   = basename(__FILE__, '.php') ;

      if(file_exists($langFile))
      {
        require_once $langFile;
        foreach($_MODULE  as $key=>$value)
            $_MODULE[str_replace($mySelf . '_' , $this->name . '_', $key)] = $value;
      }

      $this->path = _PS_MODULE_DIR_ . '/' . $this->name . '/' ;
      $this->url = __PS_BASE_URI__ . basename(_PS_MODULE_DIR_) . '/' . $this->name ;
      $this->images = $this->url . '/images/';

      $this->_amazon = new Amazon() ;

      parent::__construct() ;
    }
    public function l($string, $specific = false, $id_lang = null)
    {
      return( $this->_amazon->l($string, $specific = false, $id_lang = null) ) ;
    }



    public function Dispatch()
    {
       switch( Tools::getValue('action'))
       {
         case 'check' :
            $this->Check() ;
            break ;
       }
    }


    public function Check()
    {
        $id_lang = Tools::getValue('id_lang') ;

        $debugMode       = unserialize(base64_decode(Amazon::configurationGet('AMAZON_DEBUG'))) ;
        $this->_debug    = intval($debugMode) ? true : false ;

        $merchantId             = Tools::getValue('merchantId') ;
        $marketPlaceId          = Tools::getValue('marketPlaceId') ;
        $awsKeyId               = Tools::getValue('awsKeyId') ;
        $awsSecretKey           = Tools::getValue('awsSecretKey') ;
        $marketPlaceRegion      = Tools::getValue('marketPlaceRegion') ;
        $marketPlaceCurrency    = Tools::getValue('marketPlaceCurrency') ;

        if ( ! isset($merchantId) || empty($merchantId) )
            die($this->l('Merchant Id is missing...')) ;

        if ( ! isset($marketPlaceId) || empty($marketPlaceId) )
            die($this->l('MarketPlace Id Id is missing...')) ;

        if ( ! isset($awsKeyId) || empty($awsKeyId) )
            die($this->l('AWS KeyId Id is missing...')) ;

        if ( ! isset($awsSecretKey) || empty($awsSecretKey) )
            die($this->l('AWS Secret Key Id is missing...')) ;

        if ( ! isset($marketPlaceRegion) || empty($marketPlaceRegion) )
            die($this->l('Market Place Platform is missing...')) ;

        if ( ! isset($marketPlaceCurrency) || empty($marketPlaceCurrency) )
            die($this->l('Market Place Currency is missing...')) ;

        $auth = array(
           'MerchantID'     => trim($merchantId),
           'MarketplaceID'  => trim($marketPlaceId),
           'AWSAccessKeyID' => trim($awsKeyId),
           'SecretKey'      => trim($awsSecretKey)
        ) ;

        $marketPlace = array() ;
        $marketPlace['Currency'] = $marketPlaceCurrency ;
        $marketPlace['Country'] = $marketPlaceRegion ;

        if ( ! $amazonApi = new Service($auth, $marketPlace, null, $this->_debug) )
          die($this->l('Unable to login')) ;

        $debug = ob_get_clean();

        $result = $amazonApi->ConnectionCheck() ;

        if ( $this->_debug )
        {
            echo nl2br(print_r($debug, true)) ;
            echo nl2br(print_r($result, true)) ;
        }
        if ( $result === true )
            die($this->l('Connection to Amazon : Ok')) ;
        elseif ( is_object($result) && isset($result->Error) )
            die($this->l('Warning: Connection to Amazon Failed !') . nl2br("\n" . print_r($result->Error, true)) ) ;
        else
            die($this->l('Warning: Connection to Amazon Failed !') . nl2br("\n" . print_r($result, true)) ) ;
    }
}
$pmConnexionCheck = new AmazonConnexionCheck() ;
$pmConnexionCheck->Dispatch() ;

?>