<?php



@require_once(dirname(__FILE__).'/../../../config/config.inc.php');
@require_once(dirname(__FILE__).'/../../../init.php');

require_once(dirname(__FILE__).'/../amazon.php');

require_once(dirname(__FILE__).'/../classes/amazon.tools.class.php');
require_once(dirname(__FILE__).'/../classes/amazon.order.class.php');
require_once(dirname(__FILE__).'/../classes/amazon.product.class.php');

define('AMAZON_TRADER', Amazon::configurationGet('AMAZON_TRADER') ? true : false ) ;

if ( defined('AMAZON_TRADER') && AMAZON_TRADER )
{
  require_once(dirname(__FILE__).'/../classes/amazon.strategies.class.php');
  require_once(dirname(__FILE__).'/../classes/amazon.webservice-bid.class.php');
}
class Product_Options extends Module
{
  private $module   = 'amazon';
  public $name   = 'amazon';
  private $strategies = false ;

  private $_amazon ;

  function __construct()
  {
    global $cookie, $_MODULE;

    if (version_compare(_PS_VERSION_, '1.5', '>='))
    {
        $this->id_lang = (int) Context::getContext()->language->id;
    }
    else
    {
        $this->id_lang = (int) $cookie->id_lang;
    }    

    $langFile = _PS_MODULE_DIR_.$this->module.'/'.Language::getIsoById($this->id_lang).'.php';
    $mySelf   = basename(__FILE__, '.php') ;

    if(file_exists($langFile))
    {
      require_once $langFile;
      foreach($_MODULE  as $key=>$value)
          $_MODULE[str_replace($mySelf . '_' , $this->name . '_', $key)] = $value;
    }

     $module = __PS_BASE_URI__ . basename(_PS_MODULE_DIR_) . '/' . $this->module . '/' ;

      $this->strategies = (bool)Amazon::configurationGet('AMAZON_TRADER') === true ? true : false ;

      $this->images = $module . 'images/';

      $this->_amazon = new Amazon() ;

      parent::__construct() ;
  }
  public function l($string, $specific = false, $id_lang = null)
  {
      global $cookie ;
      return( $this->_amazon->l($string, $specific, $id_lang) ) ;
  }

  private function _masterASIN($lang_id, $default)
  {
    $checked = $default ? 'checked="checked"' : '' ;
    $html = '
        <tr class="amazon-details">
            <td class="col-left">' . $this->l('ASIN') . ': </td>
            <td style="padding-bottom:5px;">
            <input type="text" id="amz-asin-' . $lang_id . '" name="amz-asin-' . $lang_id . '" value="' . $default . '" style="width:120px" />&nbsp;&nbsp;
                <input type="hidden" id="amz-asin-mustbeset" value="' . $this->l('EAN13 or UPC must be set !') . '" />
                <input type="button" class="button" id="amz-ean-asin-' . $lang_id . '" value="' . $this->l('UPC/EAN > ASIN') . '" />&nbsp;&nbsp;' ;
/*
                <input type="button" class="button" id="amz-asin-ean-' . $lang_id . '" value="' . $this->l('ASIN > UPC/EAN') . '" />&nbsp;&nbsp;' ;

*/
    $html .= '
                <img src="' . $this->images . 'green-loader.gif" alt="" id="asin-loader-' . $lang_id . '" style="display:none;position:relative;top:-4px;" /><br />
                <div class="asin-response" id="asin-response-'.$lang_id.'" style="display:none;" >&nbsp;</div>
            <span style="font-size:0.8em;color:grey;line-height:150%">' . $this->l('Master ASIN - Usefull only for products <b><u>without combinations</u></b>') . '</span>

            </td>
        </tr>
        ' ;
    return($html) ;
  }
  private function _forceUnavailable($lang_id, $default)
  {
    $checked = $default ? 'checked="checked"' : '' ;
    $html = '
        <tr class="amazon-details">
            <td class="col-left">' . $this->l('Disabled') . ': </td>
            <td style="padding-bottom:5px;">
            <input type="checkbox" name="amz-disable-' . $lang_id . '" value="1" ' . $checked . ' />
            <span style="margin-left:10px">' . $this->l('Check this box to make this product unavailable on Amazon') . '</span><br />
            <span style="font-size:0.8em;color:grey;line-height:150%">' . $this->l('Propagate this value to all products in this') . ' :
                        <a href="javascript:void(0)" id="amz-propagate-disable-category-' . $lang_id . '" class="amz-propagate-disable-cat amz-link">[ ' . $this->l('Category') . ' ]</a>
            &nbsp;&nbsp;<a href="javascript:void(0)" id="amz-propagate-disable-shop-' . $lang_id . '" class="amz-propagate-disable-shop amz-link">[ ' . $this->l('Shop') . ' ]</a>
            &nbsp;&nbsp;<a href="javascript:void(0)" id="amz-propagate-disable-manufacturer-' . $lang_id . '" class="amz-propagate-disable-manufacturer amz-link">[ ' . $this->l('Manufacturer') . ' ]</a></span></span>
            <span id="disable-loader-' . $lang_id . '" style="display:none"><img src="'.$this->images.'green-loader.gif" style="margin-left:5px;position:relative;top:-8px" alt="" /></span>

            </td>
        </tr>
        ' ;
    return($html) ;
  }

  private function _nopexport($lang_id, $default)
  {
    $checked = $default ? 'checked="checked"' : '' ;
    $html = '
        <tr class="amazon-details">
            <td class="col-left">' . $this->l('Price') . ': </td>
            <td style="padding-bottom:5px;">
            <input type="checkbox" name="amz-nopexport-' . $lang_id . '" value="1" ' . $checked . ' />
            <span style="margin-left:10px">' . $this->l('Do not synchronize the price') . '</span>
            </td>
        </tr>
        ' ;
    return($html) ;
  }

  private function _noqexport($lang_id, $default)
  {
    $checked = $default ? 'checked="checked"' : '' ;
    $html = '
        <tr class="amazon-details">
            <td class="col-left">' . $this->l('Quantity') . ': </td>
            <td style="padding-bottom:5px;">
            <input type="checkbox" name="amz-noqexport-' . $lang_id . '" value="1" ' . $checked . ' />
            <span style="margin-left:10px">' . $this->l('Do not synchronize the quantity') . '</span>
            </td>
        </tr>
        ' ;
    return($html) ;
  }

  private function _fba($lang_id, $default)
  {
    $checked = $default ? 'checked="checked"' : '' ;
    $html = '
        <tr class="amazon-details">
            <td class="col-left">' . $this->l('FBA') . ': </td>
            <td style="padding-bottom:5px;">
            <input type="checkbox" name="amz-fba-' . $lang_id . '" value="1" ' . $checked . ' />
            <span style="margin-left:10px">' . $this->l('Fulfilment by Amazon (FBA)') . '</span>
            </td>
        </tr>
        ' ;
    return($html) ;
  }

  
  private function   _latency($lang_id, $default)
  {
    $html = '
        <tr class="amazon-details">
            <td class="col-left">' . $this->l('Latency') . ': </td>
            <td style="padding-bottom:5px;">
            <input type="text" name="amz-latency-' . $lang_id . '" value="' . $default . '" style="width:40px" /><br />
            <span style="font-size:0.8em;color:grey;line-height:150%">' . $this->l('Latency delay in days before this product will be shipped') . '</span><br />
            <span style="font-size:0.8em;color:grey;line-height:150%">' . $this->l('Propagate this delay to all products in this') . ' :
                            <a href="javascript:void(0)" id="amz-propagate-latency-category-' . $lang_id . '" class="amz-propagate-latency-cat amz-link">[ ' . $this->l('Category') . ' ]
            </a>&nbsp;&nbsp;<a href="javascript:void(0)" id="amz-propagate-latency-shop-' . $lang_id . '" class="amz-propagate-latency-shop amz-link">[ ' . $this->l('Shop') . ' ]</a></span>
            <span id="latency-loader-' . $lang_id . '" style="display:none"><img src="'.$this->images.'green-loader.gif" style="margin-left:5px;position:relative;top:-8px" alt="" /></span>
            </td>
        </tr>
        ' ;
    return($html) ;
  }


  private function _forceInStock($lang_id, $default)
  {
    $checked = $default ? 'checked="checked"' : '' ;
    $html = '
        <tr class="amazon-details">
            <td class="col-left">' . $this->l('Force in Stock') . ': </td>
            <td style="padding-bottom:5px;">
            <input type="checkbox" name="amz-force-' . $lang_id . '" value="1" ' . $checked . ' />
            <span style="margin-left:10px">' . $this->l('The product will always appear on Amazon, even it\'s out of Stock') . '</span><br />
            <span style="font-size:0.8em;color:grey;line-height:150%">' . $this->l('Propagate this value to all products in this') . ' :
                            <a href="javascript:void(0)" id="amz-propagate-force-category-' . $lang_id . '" class="amz-propagate-force-cat amz-link">[ ' . $this->l('Category') . ' ]
            </a>&nbsp;&nbsp;<a href="javascript:void(0)" id="amz-propagate-force-shop-' . $lang_id . '" class="amz-propagate-force-shop amz-link">[ ' . $this->l('Shop') . ' ]</a>
            </a>&nbsp;&nbsp;<a href="javascript:void(0)" id="amz-propagate-force-manufacturer-' . $lang_id . '" class="amz-propagate-force-manufacturer amz-link">[ ' . $this->l('Manufacturer') . ' ]</a></span></span>
            <span id="force-loader-' . $lang_id . '" style="display:none"><img src="'.$this->images.'green-loader.gif" style="margin-left:5px;position:relative;top:-8px" alt="" /></span>
            </td>
        </tr>
        ' ;
    return($html) ;
  }

  private function   _extraText($lang_id, $default)
  {
    $html = '
        <tr class="amazon-details">
            <td class="col-left">' . $this->l('Extra Text') . ': </td>
            <td style="padding-bottom:5px;">
            <input type="text" name="amz-text-' . $lang_id . '" value="' . $default . '" style="width:400px" /><br />
            <span style="font-size:0.8em;color:grey;line-height:150%">' . $this->l('Short text which will appear on the product sheet on Amazon') . '</span><br />
            <span style="font-size:0.8em;color:grey;line-height:150%">' . $this->l('Propagate this text to all products in this') . ' : <a href="javascript:void(0)" class="amz-propagate-text-cat amz-link">[ ' . $this->l('Category') . ' ]</a>&nbsp;&nbsp;<a href="javascript:void(0)" class="amz-propagate-text-shop amz-link">[ ' . $this->l('Shop') . ' ]</a></span>

            <span id="extra-text-loader-' . $lang_id . '" style="display:none"><img src="'.$this->images.'green-loader.gif" style="margin-left:5px;position:relative;top:-8px" alt="" /></span>
            </td>
        </tr>
        ' ;
    return($html) ;
  }

  private function   _shipping($lang_id, $default1, $default2)
  {
    $checked1 = $default2 == 1 || ! $default1  ? ' checked="checked"' : '' ;
    $checked2 = $default2 == 2 ? ' checked="checked"' : '' ;

    $default1 = ($default1 == NULL) ? '' : sprintf('%.02f', $default1) ;

    $html = '
        <tr class="amazon-details">
            <td class="col-left">' . $this->l('Shipping Override') . ': </td>
            <td style="padding-bottom:5px;">
            <input type="text" name="amz-shipping-' . $lang_id . '" value="' . $default1 . '" style="width:60px" />&nbsp;&nbsp;&nbsp;
            <input type="radio" name="amz-overridetype-' . $lang_id . '" value="1" ' . $checked1 . '/><span style="position:relative;top:+3px;margin-left:5px;">' . $this->l('Standard') . '</span>&nbsp;&nbsp;&nbsp;
            <input type="radio" name="amz-overridetype-' . $lang_id . '" value="2" ' . $checked2 . '/><span style="position:relative;top:+3px;margin-left:5px;">' . $this->l('Express') . '</span>
            <br />
            <span style="font-size:0.8em;color:grey;line-height:150%">' . $this->l('Shipping price which override the default shipping price fixed in your Amazon Backoffice') . '</span><br />
            <span style="font-size:0.8em;color:grey;line-height:150%">' . $this->l('Propagate this shipping price to all products in this') . ' :
                            <a href="javascript:void(0)" id="amz-propagate-shipping-cat-' . $lang_id . '" class="amz-propagate-shipping-cat amz-link">[ ' . $this->l('Category') . ' ]</a>
                &nbsp;&nbsp;<a href="javascript:void(0)" id="amz-propagate-shipping-shop-' . $lang_id . '" class="amz-propagate-shipping-shop amz-link">[ ' . $this->l('Shop') . ' ]</a></span>

            <span id="shipping-loader-' . $lang_id . '" style="display:none"><img src="'.$this->images.'green-loader.gif" style="margin-left:5px;" alt="" /></span>
            </td>
        </tr>
        ' ;
    return($html) ;
  }

  private function   _extraPrice($lang_id, $default)
  {
    $html = '
        <tr class="amazon-details">
            <td class="col-left">' . $this->l('Price Override') . ': </td>
            <td style="padding-bottom:5px;">
            <input type="text" name="amz-price-' . $lang_id . '" value="' . (floatval($default) ? sprintf('%.02f', $default) : '') . '" style="width:95px" /><br />
            <span style="font-size:0.8em;color:grey;line-height:150%">' . $this->l('Net Price for Amazon. This value will override your Shop Price') . '</span><br />
            </td>
        </tr>
        ' ;
    return($html) ;
  }


  private function _strategies()
  {
    $html = '
        <tr class="amazon-details">
            <td class="col-left">' . $this->l('Strategies') . ': </td>
            <td style="padding-bottom:10px;">
            <span>' . $this->l('Advanced strategies for this Product') . ':&nbsp;&nbsp;</span>
            <input type="button" id="amazon-button2" class="button" value="' . $this->l('Configure') . '" />
            <input type="button" id="amazon-button3" class="button" style="float:right;margin-right:20px;background-color:red;color:yellow" value="' . $this->l('Re-Initialize') . '" />
            </td>
        </tr>
        ' ;
    return($html) ;
  }

  private function _lookup($id_lang, $asin)
  {
    $url = Amazon_Tools::goToProductPage($id_lang, $asin) ;

    $html = '
        <tr class="amazon-details">
            <td class="col-left">&nbsp;</td>
            <td style="padding-bottom:10px;">
            <input type="button" id="amazon-goto-' . $asin . '" class="button" rel="' . $url . '" value="' . $this->l('Go to the Amazon Product Page') . '" />

            </td>
        </tr>
        ' ;
    return($html) ;
  }


  // Tabs
  //
  private function _tabs()
  {
    $html = '';

    $selected_tab = $this->_selected_tab() ;

    $html .= '
            <div style="clear:both"></div>
            <ul id="menuTab">' ;
    $i = 0 ;

    foreach ($this->_languages() as $language)
    {
      $image = $this->images . 'geo_flags/'.$language['iso_code'].'.gif' ;

      $html .= '<li id="menu-' . $language['iso_code'] .'" class="menuTabButton ' . ($selected_tab == $language['iso_code'] ? 'selected' : '') . '"><span>&nbsp;<img src="' . $image . '" alt="' . $language['name'] . '" />&nbsp;' . $language['name'] . '</span>  </li>' ;
      $i++ ;
    }

    $html .= '
          </ul>
    ' ;

    return($html);
  }

  private function _selected_tab()
  {
      global $cookie ;
      return(($selected_tab = Tools::getValue('selected_tab')) ? $selected_tab : ($cookie->id_lang ? strtolower(Language::getIsoById($cookie->id_lang)) : strtolower(Language::getIsoById(Configuration::get('PS_LANG_DEFAULT')))))  ;
  }

  // Return availables languages
  //
  private function _languages()
  {
      $languages = Language::getLanguages();
      $available_languages = array() ;
      $marketplaceIds = unserialize( base64_decode(Amazon::configurationGet('AMAZON_MARKETPLACE_ID')) ) ;

      $active = unserialize(base64_decode(Amazon::configurationGet('AMAZON_ACTIVE'))) ;

      foreach ($languages as $language)
      {
        // For active languages
        //
        if ( $language['active'] === false )  continue ;

        // Active
        //
        if ( ! isset($active[ $language['id_lang'] ]) )
            continue ;

        // Allow only available platforms
        //
        switch ( $language['iso_code'] )
        {
          case 'fr' :
          case 'de' :
          case 'us' :
          case 'en' :
          case 'it' :
          case 'es' :
          case 'ca' :
          case 'jp' :
              $pass = true ;
              break;
          default :
              $pass = false ;
              continue ;
        }
        if ( ! $pass ) continue ;

        if ( ! isset($marketplaceIds[ $language['id_lang'] ]) || empty($marketplaceIds[ $language['id_lang'] ]) ) continue ;

        $available_languages[] = $language ;
       }
       return($available_languages);
  }


  public function productOptions()
  {
    $this->id_product = Tools::getValue('id_product') ;

    $selected_tab = $this->_selected_tab() ;       
    
    
    $html = '
            <tr>
                <td colspan="2"><span id="amazon-options"><img src="../modules/amazon/images/a16.gif" alt="" />&nbsp;&nbsp;<b>Amazon Market Place</b>&nbsp;&nbsp;&nbsp;<span style="color:grey">[</span><img src="../modules/amazon/images/plus.png" rel="../modules/amazon/images/minus.png" alt="" style="position:relative;top:-1px;" id="amz-toggle-img" /><span style="color:grey;margin-left:-1px;">]</span></span></td>
            </tr>
            <tr class="amazon-details">
                <td class="col-left" style="padding:15px 0 5px 5px;">' . $this->l('Amazon Platform') . '<br /></td><td>' . '<span style="color:brown;">(' . $this->l('Please note that all these options are optionals'). ')</span> </td>
                <td style="padding-bottom:5px;">
                <input type="hidden" name="selected_tab" value="' . $selected_tab . '" />
                <input type="hidden" name="id_product" value="' . Tools::getValue('id_product') . '" />
                <input type="hidden" id="amz-text-strategy-reinit" value="' . $this->l('Be carefull ! Are you sure to want to re-initialize all strategies ?') . '" />
                <input type="hidden" id="amz-text-propagate-cat" value="' . $this->l('Be carefull ! Are you sure to want to propagate this extra text to all the products of this categories ?') . '" />
                <input type="hidden" id="amz-text-propagate-shop" value="' . $this->l('Be carefull ! Are you sure to want to propagate this extra text to the entire shop ?') . '" />
                <input type="hidden" id="amz-text-propagate-latency-cat" value="' . $this->l('Be carefull ! Are you sure to want to propagate this latency delay to all the products of this categories ?') . '" />
                <input type="hidden" id="amz-text-propagate-latency-shop" value="' . $this->l('Be carefull ! Are you sure to want to propagate this latency delay to the entire shop ?') . '" />
                <input type="hidden" id="amz-text-propagate-shipping-cat" value="' . $this->l('Be carefull ! Are you sure to want to propagate this shipping price to all the products of this categories ?') . '" />
                <input type="hidden" id="amz-text-propagate-shipping-shop" value="' . $this->l('Be carefull ! Are you sure to want to propagate this shipping price to the entire shop ?') . '" />
                <input type="hidden" id="amz-text-propagate-disable-cat" value="' . $this->l('Be carefull ! Are you sure to want to change this value for all the products of this categories for Amazon ?') . '" />
                <input type="hidden" id="amz-text-propagate-disable-shop" value="' . $this->l('Be carefull ! Are you sure to want to change this value for all the products of the entire shop for Amazon ?') . '" />
                <input type="hidden" id="amz-text-propagate-disable-manufacturer" value="' . $this->l('Be carefull ! Are you sure to want to change this value for all the products having the same Manufacturer ?') . '" />
                <input type="hidden" id="amz-text-propagate-force-cat" value="' . $this->l('Be carefull ! Are you sure to want to change this value for all the products of this categories for Amazon ?') . '" />
                <input type="hidden" id="amz-text-propagate-force-shop" value="' . $this->l('Be carefull ! Are you sure to want to change this value for all the products of the entire shop for Amazon ?') . '" />
                <input type="hidden" id="amz-text-propagate-force-manufacturer" value="' . $this->l('Be carefull ! Are you sure to want to change this value for all the products having the same Manufacturer ?') . '" />
                </td>
            </tr>
            ' ;


      $html .= '
            <tr class="amazon-details">
                <td style="padding-bottom:5px;" colspan="2">';


    $html .= $this->_tabs() ;

    $html .= '
        
      <div id="tabList">' ;

    foreach ($this->_languages() as $language)
    {
      $id_lang = $language['id_lang'] ;

      $html .= '
         
         <div style="' . ($selected_tab == $language['iso_code'] ? '' : 'display:none;') . '" id="menudiv-' . $language['iso_code'] .'"  class="tabItem ' . ($selected_tab == $language['iso_code'] ? 'selected' : '').' ">
         
         <fieldset style="border:1px solid #B8B8B8;background-color:#F8F7F7;">
         <input type="hidden" id="lang-' . $id_lang . '" value="' . $language['iso_code'] . '" />
         <input type="hidden" name="nopexport" value="0" />
         <input type="hidden" name="noqexport" value="0" />
         <table width="100%">
            <tr class="amazon-details">
                <td class="col-left">&nbsp;</td>
                <td style="padding-bottom:5px;">
                ' ;

      $defaults = Amazon_Product::getProductOptions($this->id_product, $id_lang) ;

      $html .= $this->_masterASIN($id_lang, $defaults['asin1']) ;

      $html .= $this->_extraPrice($id_lang, $defaults['price']) ;

      $html .= $this->_forceUnavailable($id_lang, $defaults['disable']) ;

      $html .= $this->_forceInStock($id_lang, $defaults['force']) ;

      $html .= $this->_nopexport($id_lang, $defaults['nopexport']) ;

      $html .= $this->_noqexport($id_lang, $defaults['noqexport']) ;
      
      $html .= $this->_fba($id_lang, $defaults['fba']) ;

      $html .= $this->_latency($id_lang, $defaults['latency']) ;

      $html .= $this->_extraText($id_lang, $defaults['text']) ;

      $html .= $this->_shipping($id_lang, $defaults['shipping'], $defaults['shipping_type']) ;

      if ( $defaults['asin1'] )
        $html .= $this->_lookup($id_lang, $defaults['asin1']) ;

      $html .= '
      <span style="padding-right:20px;"><input type="hidden" name="amazon_option_lang[]" value="'.$id_lang.'" />' ;

      $html .= '<img src="../img/l/'.$id_lang.'.jpg" style="position:relative;top:-3px;" alt="' . $language['name'] . '" />&nbsp;&nbsp;' . preg_replace('/\(.*/', '', $language['name']) . '</span>' ;


      $html .= '

            </td>
            </tr>
         </table>
         </fieldset>
         ';


      $html .= '</div>' ;

    }

    $html .= '
         </div>
        </td>
       </tr>';

    if ( defined('AMAZON_TRADER') && AMAZON_TRADER )
        $html .= $this->_strategies() ;

    $html .= '
        <tr class="amazon-details">
            <td colspan="2" style="padding-bottom:5px;">
                <hr style="margin-left:25%;width:50%" />
                <span style="margin-left:25%;color:brown;font-weight:bold;font-size:0.8em">' . $this->l('Don\'t forget to click on the record button linked to this sub-tab if you modify this configuration !') . '</span>
            </td>
        </tr>
        <tr class="amazon-details">
            <td class="col-left"></td>
            <td style="padding:0 30px 5px 0;float:right;">
                <div class="conf" style="display:none" id="result-amz"></div>
                <span id="amazon-save-loader" style="display:none"><img src="'.$this->images.'green-loader.gif" style="float:right;margin-left:5px;position:relative;top:+3px" alt="" /></span>
                <input type="button" style="float:right" id="amazon-save-options" class="button" value="' . $this->l('Save Amazon Parameters'). '" . />

             </td>
        </tr>' ;

   
    if ( version_compare(_PS_VERSION_, '1.5', '<') )
    {
        $html .=
            '<tr>
                <td colspan="2" style="padding-bottom:5px;"><hr style="width:100%" /></td>
            </tr>
       ' ;

    }

    
    echo $html ;
  }


}
$amazonProductOptions = new Product_Options() ;
$amazonProductOptions->productOptions() ;

?>