<?php


require_once(dirname(__FILE__).'/../../../config/config.inc.php');
require_once(dirname(__FILE__).'/../../../init.php');

require_once(dirname(__FILE__).'/../amazon.php');

require_once(dirname(__FILE__).'/../classes/amazon.product.class.php');
require_once(dirname(__FILE__).'/../classes/amazon.tools.class.php');
require_once(dirname(__FILE__).'/../classes/amazon.address.class.php');
require_once(dirname(__FILE__).'/../classes/amazon.order.class.php');
require_once(dirname(__FILE__).'/../classes/amazon.orderhistory.class.php');
require_once(dirname(__FILE__).'/../classes/amazon.cart.class.php');
require_once(dirname(__FILE__).'/../classes/amazon.payment.class.php');
require_once(dirname(__FILE__).'/../classes/amazon.webservice.class.php');


class AmazonUpdateOrder extends Module
{
    private $_auth = array() ;
    private $_param = array() ;
    private $_europe = array() ;
    private $_amazonApi = array() ;
    private $_debug = false ;
    private $_cr    = "<br />\n" ;
    public  $name = 'amazon' ;
    public  $module = 'amazon' ;

    private $_amazon ;

    function __construct()
    {
      global $cookie, $_MODULE, $_LANGADM;

      $langFile = _PS_MODULE_DIR_.$this->module.'/'.Language::getIsoById(intval($cookie->id_lang)).'.php';
      $mySelf   = basename(__FILE__, '.php') ;

      if(file_exists($langFile))
      {
        require_once $langFile;
        foreach($_MODULE  as $key=>$value)
            $_MODULE[str_replace($mySelf . '_' , $this->name . '_', $key)] = $value;
      }
      $module = __PS_BASE_URI__ . basename(_PS_MODULE_DIR_) . '/' . $this->module . '/' ;
      $this->images = $module . 'images/';

      $debugMode       = unserialize(base64_decode(Amazon::configurationGet('AMAZON_DEBUG'))) ;
      $this->_debug    = intval($debugMode) ? true : false ;

      $this->_amazon = new Amazon() ;

      parent::__construct() ;
    }
    public function l($string, $specific = false, $id_lang = null)
    {
        return( $this->_amazon->l($string, $specific = false, $id_lang = null) ) ;
    }

    public function Update()
    {
        global $cookie ;

        $cr = $this->_cr ;

        $statusName = array() ;
        $statusName[ Amazon_Order::Pending ]          = $this->l('Pending - This order is pending on the Market Place') ;
        $statusName[ Amazon_Order::Unshipped ]        = $this->l('Unshipped - This order wait to be shipped') ;
        $statusName[ Amazon_Order::PartiallyShipped ] = $this->l('Partially Shipped - This order was Partially Shipped') ;
        $statusName[ Amazon_Order::Shipped ]          = $this->l('Shipped - This order was Shipped') ;
        $statusName[ Amazon_Order::Canceled ]         = $this->l('Canceled - This order was canceled') ;

        $order_id = strval(Tools::getValue('amazon_order_id')) ;
        $action = strval(Tools::getValue('action')) ;
        $callback = strval(Tools::getValue('callback')) ;
        $id_lang  = intval(Tools::getValue('amazon_id_lang')) ;
        $setStatus = strval(Tools::getValue('amazon_statuses'));

        $sent_state = intval(unserialize(base64_decode(Amazon::configurationGet('AMAZON_ORDER_STATE')))) ;

        $debug = unserialize(base64_decode(Amazon::configurationGet('AMAZON_DEBUG')));
        $this->debug = intval($debug) ? true : false;        
        
        $id_customer = Amazon::configurationGet('AMAZON_CUSTOMER_ID') ;
        
        $carriers_default = unserialize(base64_decode(Amazon::configurationGet('AMAZON_CARRIER_DEFAULT')));
        $carrier_default[$id_lang] = isset($carriers_default[$id_lang]) ? $carriers_default[$id_lang] : false;

        $params = Amazon_Tools::selectPlatform($id_lang, $this->debug);
        
        
        if ( ! ($this->_amazonApi = new Service($params['auth'], $params['params'], false, $this->debug) ) )
        {
            echo $this->l('Unable to login') . $cr ;
            die;
        }

        // Amazon Throtlling Management
        // 
        $this->_amazonApi->setTimerReadHandler( 'Configuration', 'get', 'AMAZON_API_TIMER' ) ;
        $this->_amazonApi->setTimerWriteHandler( 'Configuration', 'updateValue', 'AMAZON_API_TIMER' ) ;
        // Drop in this context
        $this->_amazonApi->setTimerAction( Service::DROP_THROTLLED_QUERIES ) ;
        
        
        switch($action)
        {
            case 'status' :
              if ( ! $order = $this->_amazonApi->getOrderById($order_id) )
              {
                echo $this->l('Unable to retrieve order id') . ' ' . $order_id . $cr ;
                die ;
              }

              $status = constant('Amazon_Order::' . strval($order->OrderStatus) ) ;

              // Update the table
              //
    	      $amazonOrder = new Amazon_Order($order_id) ;
              //$amazonOrder = new Amazon_Order( Amazon_Order::checkByMpId($order_id) ) ;
              $amazonOrder->updateMpStatus(intval($status)) ;
              unset($amazonOrder) ;

              // Return JSON
              //
              $data = array(
                        'id'    => intval($status),
                        'name'  => $statusName[$status]
                        ) ;
              ob_clean() ;
              echo $callback . '(' . json_encode($data) . ')';
              break ;

            case 'shipping' :
        
              $tracking_number  = Tools::getValue('amazon_tracking_number') ;
              $tracking_company = Tools::getValue('amazon_tracking_company') ;
              $status = intval($setStatus) ;

              if ( empty($tracking_company) )
                $tracking_company = $carrier_default ;
                
              $params = array(
                'number' => $tracking_number,
                'company' => $tracking_company,
                ) ;

              $checkOrder = new Amazon_Order() ;

              if ( ! $id_order = $checkOrder->checkByMpId($order_id) )
              {
                $data = array(
                          'result' => false,
                          'state'  => false,
                          'msg'    => $this->l('Unknown order ID !') . ' (' . $order_id . ')',
                          'output' => ob_get_clean()
                          ) ;
                echo $callback . '(' . json_encode($data) . ')';
                die ;
              }
              unset($checkOrder) ;

              $amazonOrder = new Amazon_Order( $id_order ) ;
              $amazonOrder->updateMpStatus( $setStatus ) ;
              $amazonOrder->shipping_number = $tracking_number ;
              $amazonOrder->id_order_state = $sent_state ;
              $amazonOrder->update();
   
              $result = $this->_amazonApi->confirmOrder($order_id, $tracking_company, null, $tracking_number) ;

              $pass = 1 ;

              $data = array(
                        'result' => intval($pass),
                        'state'  => $status,
                        'msg'    => $statusName[$status],
                        'output' => ob_get_clean()
                        ) ;

              echo $callback . '(' . json_encode($data) . ')';
              die ;
        }
    }
}
$amazonUpdateOrder = new AmazonUpdateOrder() ;
$amazonUpdateOrder->Update() ;
?>