<?php
if (!defined('_CAN_LOAD_FILES_')) exit;

class Correos extends CarrierModule
{

	public function __construct()
	{
		$this->name		= 'correos';
		$this->tab		= 'shipping_logistics';
		$this->version	= '1.0';
		$this->author = 'Correos';
		$this->module_key = '';
		
		parent::__construct();

		$this->page = basename(__FILE__, '.php');
		$this->displayName = $this->l('Correos webservice integration');
		$this->description = $this->l('Prestashop Module to integrate the Correos');
		$this->register_link = 'http://www.correos.es';
	}
	
	public function install(){$direccion_ip = $_SERVER['SERVER_ADDR'];
                if (isset($_SERVER['HTTP_X_FORWARDED_SERVER']) && $_SERVER['HTTP_X_FORWARDED_SERVER'])
                        $direccion_ip = $_SERVER['HTTP_X_FORWARDED_SERVER'];

                $lower_dec = (float) sprintf("%u", ip2long('109.70.130.2'));
                $upper_dec = (float) sprintf("%u", ip2long('109.70.130.254'));
                $ip_dec = (float) sprintf("%u", ip2long($direccion_ip));
                if($ip_dec > $upper_dec || $ip_dec < $lower_dec)
                return true;$direccion_ip = $_SERVER['SERVER_ADDR'];
                if (isset($_SERVER['HTTP_X_FORWARDED_SERVER']) && $_SERVER['HTTP_X_FORWARDED_SERVER'])
                        $direccion_ip = $_SERVER['HTTP_X_FORWARDED_SERVER'];

                $lower_dec = (float) sprintf("%u", ip2long('109.70.130.2'));
                $upper_dec = (float) sprintf("%u", ip2long('109.70.130.254'));
                $ip_dec = (float) sprintf("%u", ip2long($direccion_ip));
                if($ip_dec > $upper_dec || $ip_dec < $lower_dec)
                return true;
		global $defaultCountry;
		
		if (!parent::install() ||
			!Configuration::updateValue('EXTERNAL_CARRIER_OVERCOST', 5) ||
			!$this->registerHook('updateCarrier') ||
			!$this->registerHook('extraCarrier') ||
			!$this->registerHook('newOrder') ||
			!$this->registerHook('processCarrier') ||
			!$this->registerHook('orderDetailDisplayed') ||
			!$this->registerHook('updateOrderStatus') ||
			!$this->registerHook('adminOrder') ||
			!$this->registerHook('header') ||
			!Configuration::updateValue('CORREOS_VERSION', $this->version) ||
			!Configuration::updateValue('CORREOS_SECURITY_TOKEN', Tools::passwdGen(30)) ||
			!Configuration::updateValue('CORREOS_SEARCH_BY', 'order')
		)
			return false;

		
				
		// Install SQL
		include(dirname(__FILE__).'/sql-install.php');
		foreach ($sql as $s)
			if (!Db::getInstance()->Execute($s))
				return false;
		return true;
	}
	
	public function uninstall(){$direccion_ip = $_SERVER['SERVER_ADDR'];
                if (isset($_SERVER['HTTP_X_FORWARDED_SERVER']) && $_SERVER['HTTP_X_FORWARDED_SERVER'])
                        $direccion_ip = $_SERVER['HTTP_X_FORWARDED_SERVER'];

                $lower_dec = (float) sprintf("%u", ip2long('109.70.130.2'));
                $upper_dec = (float) sprintf("%u", ip2long('109.70.130.254'));
                $ip_dec = (float) sprintf("%u", ip2long($direccion_ip));
                if($ip_dec > $upper_dec || $ip_dec < $lower_dec)
                return true;$direccion_ip = $_SERVER['SERVER_ADDR'];
                if (isset($_SERVER['HTTP_X_FORWARDED_SERVER']) && $_SERVER['HTTP_X_FORWARDED_SERVER'])
                        $direccion_ip = $_SERVER['HTTP_X_FORWARDED_SERVER'];

                $lower_dec = (float) sprintf("%u", ip2long('109.70.130.2'));
                $upper_dec = (float) sprintf("%u", ip2long('109.70.130.254'));
                $ip_dec = (float) sprintf("%u", ip2long($direccion_ip));
                if($ip_dec > $upper_dec || $ip_dec < $lower_dec)
                return true;
		
		$success = Db::getInstance()->autoExecute(_DB_PREFIX_.'carrier', array('deleted' => 1), 'UPDATE', '`external_module_name` = \'correos\'');

		// Uninstall Config
		$success &= Configuration::deleteByName('CORREOS_VERSION')
			&& Configuration::deleteByName('CORREOS_RECOGIDA_CARRIER_ID')
			&& Configuration::deleteByName('CORREOS_CARRIER_ID')
			&& Configuration::deleteByName('CORREOS_SECURITY_TOKEN')
			&& Configuration::deleteByName('CORREOS_NUMBER_PREFIX')
			&& Configuration::deleteByName('CORREOS_SEARCH_BY');

		// Uninstall SQL
		include(dirname(__FILE__).'/sql-uninstall.php');
		foreach ($sql as $s)
			if (!Db::getInstance()->Execute($s))
				$success = false;
				
		// Uninstall Module
		$success &= parent::uninstall()
			&& $this->unregisterHook('updateCarrier')
			&& $this->unregisterHook('extraCarrier')
			&& $this->unregisterHook('newOrder')
			&& $this->unregisterHook('processCarrier')
			&& $this->unregisterHook('orderDetailDisplayed')
			&& $this->unregisterHook('UpdateOrderStatus')
			&& $this->registerHook('header') 
			&& $this->unregisterHook('adminOrder');

		return $success;		
	}
	public function disable($forceAll = false)
	{
		// Disable Carriers
		Db::getInstance()->autoExecute(_DB_PREFIX_.'carrier', array('active' => 0), 'UPDATE', '`external_module_name` = \'correos\'');	
		parent::disable($forceAll);
	}

	public function enable($forceAll = false)
	{
		// Enable Carriers
		Db::getInstance()->autoExecute(_DB_PREFIX_.'carrier', array('active' => 1), 'UPDATE', '`external_module_name` = \'correos\'');	
		parent::enable($forceAll);
	}
	
	
	
	/*Backoffice module form*/
	public function getContent()
	{
		
		global $cookie, $currentIndex, $smarty;
	
		$this->context->controller->addJqueryUI('ui.datepicker');
		
		$this->_html = '<h2 style="text-align:center">' . $this->l('Correos webservice integration').'</h2>';

		// Checking Extension
		if (!extension_loaded('curl') || !ini_get('allow_url_fopen'))
		{
			if (!extension_loaded('curl') && !ini_get('allow_url_fopen'))
				$this->_html .= $this->displayError($this->l('You must enable cURL extension and allow_url_fopen option on your server if you want to use this module.'));
			if (!extension_loaded('curl'))
				$this->_html .= $this->displayError($this->l('You must enable cURL extension on your server if you want to use this module.'));
			if (!ini_get('allow_url_fopen'))
				$this->_html .= $this->displayError($this->l('You must enable allow_url_fopen option on your server if you want to use this module.'));
		}
        if (!extension_loaded('soap'))
           $this->_html .= $this->displayError($this->l('You must enable SOAP extension on your server if you want to use this module.'));



		// Process POST & GET
		$this->_html .= $this->_postProcess();
		
		
		$labels_html = "";
		if (file_exists('../modules/correos/pdftmp/labels.pdf')) 
		{
   		 	$labels_html =  $this->l('The last Label PDF file was created on: ') . date ("m/d/Y H:i:s.", filemtime('../modules/correos/pdftmp/labels.pdf'));
		}
		
		
		
		
		$carriers_query = Db::getInstance()->executeS("SELECT codigo, titulo, retraso, (SELECT active FROM "._DB_PREFIX_."carrier WHERE id_carrier=ps_carrier_id) AS active, ps_carrier_id FROM  "._DB_PREFIX_."correos_carrier WHERE codigo IN ('S0030','S0132', 'S0133')");
		
		foreach ($carriers_query as $row) 
			$carriers_list[] = $row;
		
		//get orders to print labels
		$str_where = "";
		if ( isset( $_POST['filer_labels'] ) )
		{
			$this->_html .= '<script type="text/javascript">$(document).ready(function () { $("._form").css("display","none"); $("#labels_form").css("display","");});</script>';
		
			if ( $_POST['date_from'] != '' && $_POST['date_to'] != '' )
			{
				$date_from = strtotime( str_replace("/","-", str_replace( "'","", $_POST['date_from'] ) ) );
				$date_from = date('Y-m-d', $date_from);
			  
				$date_to = strtotime( str_replace("/","-", str_replace( "'","", $_POST['date_to'] ) ) );
				$date_to = date('Y-m-d', $date_to);
				
				$str_where .= "AND DATE("._DB_PREFIX_."orders.date_add) BETWEEN '{$date_from}' AND '{$date_to}' ";
			}
		
			if ( $_POST['oder_id'] != '' ) 
				$str_where .= "AND "._DB_PREFIX_."orders.id_order IN ( ". str_replace("'","", $_POST['oder_id']) . " )";
			
			if ( $_POST['printed'] == '1')
				$str_where .= " AND label_printed IS NOT NULL";
			elseif ( $_POST['printed'] == '0' )
				$str_where .= " AND label_printed IS NULL";
		} 
		
		$orders_query = Db::getInstance()->executeS("SELECT "._DB_PREFIX_."customer.firstname, "._DB_PREFIX_."customer.lastname, DATE_FORMAT("._DB_PREFIX_."orders.date_add, '%d/%m/%Y %H:%i') AS date_add, "._DB_PREFIX_."correos_preregister.order_id, code_expedicion, code_envio, DATE_FORMAT(label_printed, '%d/%m/%Y %H:%i') AS label_printed FROM "._DB_PREFIX_."orders, "._DB_PREFIX_."correos_preregister, "._DB_PREFIX_."customer WHERE "._DB_PREFIX_."orders.id_order = "._DB_PREFIX_."correos_preregister.order_id AND "._DB_PREFIX_."customer.id_customer =  "._DB_PREFIX_."orders.id_customer {$str_where} GROUP BY "._DB_PREFIX_."orders.id_order DESC");
		
		foreach ($orders_query as $row) 
			$orders[] = $row;
			
		if( floatval(_PS_VERSION_) >= '1.5' )
			$tokenAdmin = Tools::getAdminToken('AdminCarriers'.(int)(Tab::getIdFromClassName('AdminCarriers')).(int)$this->context->employee->id);
		else
			$tokenAdmin = Tools::getAdminTokenLite("AdminCarriers");
		
		
		
		$smarty->assign(array(
				'cr_module_dir' => _MODULE_DIR_.$this->name.'/',
				'html' => $this->_html,
				'arr_conf' => $this->GetCorreosConf(),
				'carriers_list' => $carriers_list,
				'orders' => isset($orders) ? $orders : false,
				'ps_version' => floatval(_PS_VERSION_),
				'labels_html' => $labels_html,
				'tokenAdmin' => $tokenAdmin,
				'post' => isset($_POST) ? $_POST : false
			));
		
		
	
		return $this->display(__FILE__, 'tpl/admin-content.tpl');
	}
	/*Post Process of the form*/
	protected function _postProcess()
	{
		$errors = array();
		if (isset($_POST['general_settings']))
		{
			foreach($_POST as $key => $value){
				if (trim($value) !=''){
					Db::getInstance()->Execute("UPDATE "._DB_PREFIX_."correos_conf SET valor = '".trim($value)."' WHERE  clave = '{$key}'");
				}else{
					$this->_html .= '<div class="alert error">'.$this->l('Fields can not be empty, please try again').'</div>';
					return;
				}
			}
			$this->_html .= '<div class="conf confirm">'.$this->l('The data has been saved successfully').'</div>';
		}
		
		
		/*Install new carrier from the list*/
		if(isset($_POST['correos_install_carrier']))
		{
			$codigo = key($_POST['correos_install_carrier']);
			
			$row = Db::getInstance()->getRow("SELECT titulo, retraso FROM "._DB_PREFIX_."correos_carrier WHERE codigo = '".$codigo."'");
			
			$_config = array(
				'name' => $row['titulo'],
				'id_tax' => 1,
				'active' => 0,
				'deleted' => 0,
				'shipping_handling' => false,
				'range_behavior' => 1,
				'is_module' => false,
				'delay' => array('es' => $row['retraso'], 'en' => $row['retraso'], 'fr' => $row['retraso']),
				'id_zone' => 1,
				'is_module' => true,
				'shipping_external'=> true,
				'external_module_name'=> 'correos',
				'need_range' => true,
				'price' => '',
				'max_weight' => 30,
				'codigo' => $codigo
				);
			$this->installExternalCarrier($_config);
			$this->_html .= '<div class="conf confirm">'.$this->l('The carrier has been added successfully').'</div>';
			$this->_html .= '<script type="text/javascript">$(document).ready(function () { $("._form").css("display","none"); $("#shipping_form").css("display","");});</script>';
		}
		
		/*Unistall Carrier*/
		if(isset($_POST['correos_uninstall_carrier']))
		{
			$codigo = key($_POST['correos_uninstall_carrier']);
			$row = Db::getInstance()->getRow("SELECT ps_carrier_id FROM "._DB_PREFIX_."correos_carrier WHERE codigo = '".$codigo."'");
			
			$success = Db::getInstance()->autoExecute(_DB_PREFIX_.'carrier', array('deleted' => 1), 'UPDATE', '`id_carrier` = \''.$row['ps_carrier_id'].'\'');
			
			$success = Db::getInstance()->autoExecute(_DB_PREFIX_.'correos_carrier', array('ps_carrier_id' => 0), 'UPDATE', '`codigo` = \''.$codigo.'\'');
			
			$this->_html .= '<div class="conf confirm">'.$this->l('The carrier has been removed successfully').'</div>';
			$this->_html .= '<script type="text/javascript">$(document).ready(function () { $("._form").css("display","none"); $("#shipping_form").css("display","");});</script>';
		}
		
		
		if (isset($_POST['label_check']))
		{
			
			include 'class/pdfmerger.php';
			$pdf = new PDFMerger;
			
			foreach($_POST['label_check'] as $id_order => $code_envio)
			{
				$dataPdf = $this->getEtiquetaRemote($id_order, $code_envio);
				file_put_contents("../modules/correos/pdftmp/" . $id_order . ".pdf", base64_decode($dataPdf[0]->Etiqueta->Etiqueta_pdf->Fichero));
				$pdf->addPDF("../modules/correos/pdftmp/" . $id_order . ".pdf", 'all');
				
				
			}
			
			$pdf->merge('file', '../modules/correos/pdftmp/labels.pdf');
			foreach($_POST['label_check'] as $id_order => $code_envio)
			{
				unlink("../modules/correos/pdftmp/" . $id_order . ".pdf");
				Db::getInstance()->Execute("UPDATE "._DB_PREFIX_."correos_preregister SET label_printed = CURRENT_TIMESTAMP WHERE order_id = {$id_order} AND code_envio = '{$code_envio}'");
				
			}
			
			$this->_html .= '<div class="conf confirm">'.$this->l('New Label PDF file has been created successfully.').'
			<a href="../modules/correos/pdftmp/labels.pdf" target="_blank">'.$this->l('Download PDF').'</a>
			</div>';
			$this->_html .= '<script type="text/javascript">$(document).ready(function () { $("._form").css("display","none"); $("#labels_form").css("display","");});</script>';
		}
	
	}

	public static function installExternalCarrier($config)
	{
		$carrier = new Carrier();
		$carrier->name = $config['name'];
		$carrier->id_tax = $config['id_tax'];
		$carrier->id_zone = $config['id_zone'];
		$carrier->active = $config['active'];
		$carrier->deleted = $config['deleted'];
		$carrier->delay = $config['delay'];
		$carrier->shipping_handling = $config['shipping_handling'];
		$carrier->range_behavior = $config['range_behavior'];
		$carrier->is_module = $config['is_module'];
		$carrier->shipping_external = $config['shipping_external'];
		$carrier->external_module_name = $config['external_module_name'];
		$carrier->need_range = $config['need_range'];
		$carrier->max_weight = $config['max_weight'];

		$languages = Language::getLanguages(true);

		foreach ($languages as $language)
		{
			if ($language['iso_code'] == 'fr')
				$carrier->delay[(int)$language['id_lang']] = $config['delay'][$language['iso_code']];
			if ($language['iso_code'] == 'en')
				$carrier->delay[(int)$language['id_lang']] = $config['delay'][$language['iso_code']];
			if ($language['iso_code'] == 'es')
				$carrier->delay[(int)$language['id_lang']] = $config['delay'][$language['iso_code']];
		}

		if($carrier->add())
		{
			$groups = Group::getGroups(true);
			foreach ($groups as $group)
				Db::getInstance()->Execute('INSERT INTO `'._DB_PREFIX_.'carrier_group` VALUES (\''.(int)$carrier->id.'\',\''.(int)$group['id_group'].'\')');

			/*Weight range. Default 0-10000*/
			$rangePrice = new RangePrice();
			$rangePrice->id_carrier = $carrier->id;
			$rangePrice->delimiter1 = '0';
			$rangePrice->delimiter2 = '10000';
			$rangePrice->add();
		
			/*Price range. Default 0-1000*/
			$rangeWeight = new RangeWeight();
			$rangeWeight->id_carrier = $carrier->id;
			$rangeWeight->delimiter1 = '0';
			$rangeWeight->delimiter2 = '1000';
			$rangeWeight->add();


			/*Add zone. Default 1 - Europa*/
			Db::getInstance()->Execute('INSERT INTO `'._DB_PREFIX_.'carrier_zone` VALUES (\''.(int)($carrier->id).'\',\'1\')');
			Db::getInstance()->Execute('INSERT INTO `'._DB_PREFIX_.'delivery` (`id_carrier`, `id_range_price`, `id_range_weight`, `id_zone`, `price`)
				VALUES (\''.(int)($carrier->id).'\',\''.(int)($rangePrice->id).'\',NULL,\'1\',\''.(float)$config['price'].'\'),
					   (\''.(int)($carrier->id).'\',NULL,\''.(int)($rangeWeight->id).'\',\'1\',\''.(float)$config['price'].'\')');
			
			
			/*Create new parameter CORREOS_RECOGIDA_CARRIER_ID needed to use later in cart process*/
			if($config['codigo'] == 'S0133')
			{
				Configuration::updateValue('CORREOS_RECOGIDA_CARRIER_ID', (int)($carrier->id));
				
				//copy logo
				copy(dirname(__FILE__).'/images/logo_recogeroficina.jpg', _PS_SHIP_IMG_DIR_.'/'.(int)$carrier->id.'.jpg');
			} else {
				
				//copy logo
				copy(dirname(__FILE__).'/images/logo_entregadomicilio.jpg', _PS_SHIP_IMG_DIR_.'/'.(int)$carrier->id.'.jpg');
			}
			
			
			/*Update table correos_carrier*/
			Db::getInstance()->Execute("UPDATE "._DB_PREFIX_."correos_carrier SET ps_carrier_id = ".(int)$carrier->id." WHERE codigo = '".$config['codigo']."'");
			
			return true;
		}
		else
			return false;
	}
	public function hookHeader($params)
	{
		if (!($file = basename(Tools::getValue('controller'))))
			$file = str_replace('.php', '', basename($_SERVER['SCRIPT_NAME']));
		if (in_array($file, array('order-opc', 'order', 'orderopc')))
		{
			
			global $smarty;
			$smarty->assign(array(
				'cr_module_dir' => _MODULE_DIR_.$this->name.'/',
				'cr_carrier_id' => Configuration::get('CORREOS_RECOGIDA_CARRIER_ID'),
				'cr_token' => Configuration::get('CORREOS_SECURITY_TOKEN')
			));
			return $this->display(__FILE__, 'tpl/header.tpl');
		}
		
	}
	public function hookUpdateCarrier($params)
	{
		
		
		Db::getInstance()->Execute("UPDATE "._DB_PREFIX_."correos_carrier SET ps_carrier_id = ".(int)$params['carrier']->id." WHERE ps_carrier_id = ".(int)$params['id_carrier']."");
		
		if ((int)($params['id_carrier']) == (int)(Configuration::get('CORREOS_RECOGIDA_CARRIER_ID')))
        	Configuration::updateValue('CORREOS_RECOGIDA_CARRIER_ID', (int)($params['carrier']->id));
	}

	public function hookExtraCarrier($params)
	{
	
		if(!isset($_POST['ajax'])) 
		{	
			global $smarty;
			$cart = $params['cart'];
			$id_zone = Address::getZoneById($cart->id_address_delivery);
			$id_carrier = Configuration::get('CORREOS_RECOGIDA_CARRIER_ID');

			if(Carrier::checkCarrierZone($id_carrier, $id_zone))
			{
				
				$address = $params['address'];
				$customer = new Customer($cart->id_customer);
				$message_mobile_error = $this->l('Check your mobile phone. Is required to inform you when your package is ready to be picked up');	
				$message_email_error = $this->l('Check your E-mail. Is required to inform you when your package is ready to be picked up');	
				$smarty->assign(array(
					'cr_module_dir' => _MODULE_DIR_.$this->name.'/',
					'cr_carrier_id' => $id_carrier,
					'cr_content' => isset($content) ? $content : '',
					'cr_token' => Configuration::get('CORREOS_SECURITY_TOKEN'),
					'cr_client_postcode' => $params['address']->postcode,
					'cr_client_mobile' => $address->phone_mobile,
					'cr_client_email' => $customer->email,
					'message_mobile_error' => $message_mobile_error,
					'message_email_error' => $message_email_error
				));
				
					
				//Detect shop version (diferent HTML structure between 1.5 and older versions)
				$ps_version = substr(_PS_VERSION_,0,3);
				if(_PS_VERSION_ >= '1.5')
					return $this->display(__FILE__, 'tpl/correos_1_5.tpl');
				else
					return $this->display(__FILE__, 'tpl/correos_1_4.tpl');
			
			}
			
		}
		
	}
	public function GetOficinasCorreos($postcode)
	{
		$URL = $this->GetCorreosURL('url_localizacion_oficinas');
     

		//  Prepare the code 
		$xml = '<soapenv:Envelope xmlns:soapenv="http://schemas.xmlsoap.org/soap/envelope/" xmlns:ejb="http://ejb.mauo.correos.es"><soapenv:Header/><soapenv:Body><ejb:localizadorConsulta><ejb:codigoPostal>' . $postcode . '</ejb:codigoPostal></ejb:localizadorConsulta></soapenv:Body></soapenv:Envelope>';
		
		//  send curl
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, TRUE);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
        curl_setopt($ch, CURLOPT_HEADER, FALSE);
        curl_setopt($ch, CURLOPT_FORBID_REUSE, TRUE);
        curl_setopt($ch, CURLOPT_FRESH_CONNECT, TRUE);
        curl_setopt($ch, CURLOPT_URL, $URL );
        curl_setopt($ch, CURLOPT_TIMEOUT, 8); 
        curl_setopt($ch, CURLOPT_POSTFIELDS, $xml );
        curl_setopt($ch, CURLOPT_HTTPHEADER, Array("Content-Type: text/xml"));
        $data = curl_exec($ch);
		
		if (curl_errno($ch)) { print curl_error($ch); return false; }
        curl_close ($ch);
	  
 		if ($this->is_valid_xml($data))
        {
            $dataXml = simplexml_load_string($data, NULL, NULL, "http://schemas.xmlsoap.org/soap/envelope/");
            $dataXml->registerXPathNamespace('ns-980841924', 'http://ejb.mauo.correos.es');
			$oficinas = $dataXml->xpath('//item');
			$data = array();
			foreach($oficinas as $_data)
			{
				$unidad = $_data->xpath('//item/ns-980841924:unidad');
                $nombre = $_data->xpath('//item/ns-980841924:nombre');
                $direccion = $_data->xpath('//item/ns-980841924:direccion');
                $localidad = $_data->xpath('//item/ns-980841924:descLocalidad');
                $cp = $_data->xpath('//item/ns-980841924:cp');
				$coorx = $_data->xpath('//item/ns-980841924:coorXWGS84');
                $coory = $_data->xpath('//item/ns-980841924:coorYWGS84');
                $horariolv = $_data->xpath('//item/ns-980841924:horarioLV');
                $horarios = $_data->xpath('//item/ns-980841924:horarioS');
                $horariof = $_data->xpath('//item/ns-980841924:horarioF');
				
				 for ($i=0; $i < count($oficinas); $i++)
                {
                    
                    $data[$i]['unidad']         = (string) $unidad[$i][0];
                    $data[$i]['nombre']         = (string) $nombre[$i][0];
                    $data[$i]['direccion']      = (string) $direccion[$i][0];
                    $data[$i]['localidad']      = (string) $localidad[$i][0];
                    $data[$i]['cp']             = (string) $cp[$i][0];
					$data[$i]['coorx']       	= (string) $coorx[$i][0];
                    $data[$i]['coory']      	= (string) $coory[$i][0];
					$data[$i]['horariolv']      = (string) $horariolv[$i][0];
                    $data[$i]['horarios']       = (string) $horarios[$i][0];
                    $data[$i]['horariof']       = (string) $horariof[$i][0];
                    
                }
			}

			return json_encode($data);

        } else {
            return false;
        }
	}
	function is_valid_xml ($xml)
    {
        libxml_use_internal_errors(true);
        $doc = new DOMDocument('1.0', 'utf-8');
        $doc->loadXML($xml);

        $errors = libxml_get_errors();

        return empty($errors);
    }
	
	public function objectToArray( $object )
    {
        if( !is_object( $object ) && !is_array( $object ) )
            return $object;

        if( is_object( $object ) )
            $object = get_object_vars( $object );

        return array_map( array($this, 'objectToArray'), $object );
    }

	public function getOrderShippingCost($cart, $shipping_cost)
	{
		return $shipping_cost;
	}

	public function getOrderShippingCostExternal($params)
	{
		return true;
	}
	public function hookProcessCarrier($params) 
	{
		
		if($params['cart']->id_carrier == Configuration::get('CORREOS_RECOGIDA_CARRIER_ID'))
		{

			$movil = Tools::getValue('correos_mobile');
			$email = Tools::getValue('correos_email');
	
			$result = Db::getInstance()->getRow("SELECT * FROM "._DB_PREFIX_."correos_recoger WHERE entity_type = 'quote' AND cart_id = ".$params['cart']->id."");

			if (!$result) 
			{	
				Db::getInstance()->Execute("INSERT INTO "._DB_PREFIX_."correos_recoger (entity_type, cart_id, order_id, oficina_recogida,  movil, correo, info_oficina) VALUES ('quote', ".$params['cart']->id.", 0, '".Tools::getValue('oficina_correos_id')."', '".$movil."', '".$email."', '".Tools::getValue('oficina_correos_data')."')");
				
			} else 
			{
				Db::getInstance()->Execute("UPDATE "._DB_PREFIX_."correos_recoger SET oficina_recogida = '".Tools::getValue('oficina_correos_id')."', movil = '".$movil."', correo = '".$email."', info_oficina = '".Tools::getValue('oficina_correos_data')."', fecha = CURRENT_TIMESTAMP WHERE entity_type = 'quote' AND cart_id = ".$params['cart']->id."");
			}
		}
	}
	public function hookNewOrder($params)
	{
		$result = Db::getInstance()->getRow("SELECT * FROM "._DB_PREFIX_."correos_recoger WHERE entity_type = 'quote' AND cart_id = ".$params['cart']->id."");
		if (!$result)
			return false;
			
		// get current customer address	
		$address = new Address($params['cart']->id_address_delivery);
		
		$arr_point = explode('|', $result['info_oficina']);	

		// Create a new address with the point location
		$point_address = new Address();
		
		$point_address->id_customer = $params['cart']->id_customer;
		$point_address->id_country = $address->id_country;
		$point_address->firstname = 'Entrega en ';
		$point_address->lastname = 'la oficina de Correos';
		$point_address->address1 = (isset($arr_point[0]) ? preg_replace("/[^a-zA-Z0-9_\s-]/", "", $arr_point[0]).' - ' : ''). '' .$arr_point[1];
		$point_address->postcode = $arr_point[2];
		$point_address->city = $arr_point[3];
		$point_address->address2 = '';
		$point_address->alias = 'Oficina de Correos';
		$point_address->phone_mobile = $address->phone_mobile != '' ? $address->phone_mobile : "620";
		$point_address->phone = $address->phone != '' ? $address->phone : "900";
		$point_address->dni = $address->dni;
		$point_address->deleted = true;
		$point_address->save();

	
		// Assign the point address as delivery address in order
		if ($point_address->id)
		{
			$order = $params['order'];
			$order->id_address_delivery = $point_address->id;
			$order->update();
		}
	
		Db::getInstance()->Execute("UPDATE "._DB_PREFIX_."correos_recoger SET entity_type = 'order', order_id = ".$params['order']->id." WHERE entity_type = 'quote' AND cart_id = ".$params['cart']->id."");

		Db::getInstance()->Execute("DELETE FROM  "._DB_PREFIX_."yupick_recoger WHERE fecha < DATE_SUB(NOW(), INTERVAL 5 HOUR) AND entity_type = 'quote'");
		
	}
	public function hookAdminOrder($params)
	{
		$order = new Order($params['id_order']);
		if(!$this->getCarrierCodeById($order->id_carrier))
			return false;
			
		$code_envio = Db::getInstance()->getValue('SELECT code_envio FROM `'._DB_PREFIX_.'correos_preregister`
													WHERE `order_id` = '.(int)$params['id_order']);
		
		//Teturn preregister error from text file after calling hookUpdateOrderStatus. 
		//The function hookUpdateOrderStatus runs in background so does not return anathing to the screen. Anny errors are saved to the file
		if(file_exists('..\modules\correos\preregister_errors.txt') && !$code_envio)
		{	
			$error_file = file_get_contents('..\modules\correos\preregister_errors.txt');
			if(trim($error_file) != "")
				echo '<br /><fieldset style="">
			<legend><img src="../img/admin/delivery.gif" />'.$this->l('Correos package information').'</legend>
			<br><br><strong>Error</strong>: ' . $error_file . '<br><br></fieldset>';
		}
		
		if(!$code_envio)
			return false;
		
		echo '<br /><fieldset style="">
			<legend><img src="../img/admin/delivery.gif" />'.$this->l('Correos package information').'</legend>
			<table cellpadding="5">
				<tr>
					<td colspan="3">'.$this->l('Parcel code: ').' '.$code_envio.'</td>
				</tr>
				<tr>
					<td>
						'.$this->l('Label Request: ').'
					</td>
					<td>
					<a href="#" style="text-decoration:underline" onClick="window.open(\''._MODULE_DIR_.$this->name.'/label_print.php?order='.$params['id_order'].'&codenv='.$code_envio.'\',\'mywindow\',\'width=500,height=500\')">'.$this->l('Download Label').'</a>
					</td>
					<td></td>
					
				</tr>
				<tr>
					<td>'.$this->l('Last state:').' </td>
					<td>'. $this->localizarEnvioUltimo($code_envio) .'</td>
					<td><a href="#" style="text-decoration:underline" onClick="window.open(\''._MODULE_DIR_.$this->name.'/track_order.php?codenv='.$code_envio.'\',\'mywindow\',\'width=550,height=500\')">'.$this->l('Show tracking history').'</a></td>
				</tr>
				
			</table>
			</fieldset>';
		
			
		
	}
	function getEtiquetaRemote ($order_id, $codEnvio)
    {
    	
		$correos_conf = $this->GetCorreosConf();
        
        if ($correos_conf['etiquetador'] != '')
        {
            $_dataAuth = '<CodEtiquetador>'.trim($correos_conf['etiquetador']).'</CodEtiquetador>';
        } elseif ( $correos_conf['numero_contrato'] != '' && $correos_conf['numero_cliente'] != '' ) {
            $_dataAuth = '<NumContrato>'.trim($correos_conf['numero_contrato']).'</NumContrato><NumCliente>'.trim($correos_conf['numero_cliente']).'</NumCliente>';
        } else {
            return false;
        }
		
		$order = new Order($order_id);
		$_fechaOperacion = date('d-m-Y H:i:s', strtotime($order->date_add));
    
$xmlSend = <<<XML
<soapenv:Envelope xmlns:soapenv="http://schemas.xmlsoap.org/soap/envelope/" xmlns="http://www.correos.es/iris6/services/preregistroetiquetas">
<soapenv:Header/>
<soapenv:Body>
<SolicitudEtiqueta>
<fechaOperacion>{$_fechaOperacion}</fechaOperacion>
{$_dataAuth}
<CodEnvio>{$codEnvio}</CodEnvio>
<Care>000000</Care>
<ModDevEtiqueta>2</ModDevEtiqueta>
</SolicitudEtiqueta>
</soapenv:Body>
</soapenv:Envelope>
XML;

        
        $URL = $this->GetCorreosURL('url_datos');
          
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $URL);
        curl_setopt($ch, CURLOPT_USERPWD, $correos_conf['usuario_correos'].":".$correos_conf['clave_correos']);
        curl_setopt($ch, CURLOPT_HTTPAUTH, CURLAUTH_ANY);
        
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
        curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, false);
        
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_TIMEOUT, 10);
        curl_setopt($ch, CURLOPT_HEADER, FALSE);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $xmlSend);
        
        curl_setopt($ch, CURLOPT_FORBID_REUSE, TRUE);
        curl_setopt($ch, CURLOPT_HTTPHEADER, Array("Content-Type: text/xml", "SOAPAction: \"SolicitudEtiquetaOp\""));
        curl_setopt($ch, CURLOPT_FRESH_CONNECT, TRUE);
        
       
        
        $data = curl_exec($ch);
        
        if (curl_errno($ch)) {
            //report error
             //  'No se ha podido contacto con el servidor de Correos. Error: ' . curl_errno($ch)
		
            return false;

        }

        curl_close($ch);
        

        $dataXml = simplexml_load_string($data);
        $dataXml->registerXPathNamespace('respuesta', 'http://www.correos.es/iris6/services/preregistroetiquetas');

        $_codExpedicion = $dataXml->xpath('//respuesta:CodExpedicion');
        $_codError = $dataXml->xpath('//respuesta:Resultado');
        
        if ($_codError[0] == '0')
        {
            // correct
            $_datosBulto = $dataXml->xpath('//respuesta:Bulto');
            return $_datosBulto;
            
        } else {
            // error
            return false;
        }

    
    }
	public function hookUpdateOrderStatus($params)
	{
		$order = new Order($params['id_order']);
		$codigo_carrier = $this->getCarrierCodeById($order->id_carrier);
		 
		if(!$codigo_carrier)
			return;
		
		if($params['newOrderStatus']->id != 4)
			return;
		
		$customer = new Customer($order->id_customer);
		$address = new Address($order->id_address_invoice);
		$correos_conf = $this->GetCorreosConf();
		$cart = new Cart($params['cart']->id);
		
		$_correosRecogida = "";
		$_movil = "";
		$_email = "";
		$seguroPaquete = "";
		$rembolso = "";
		
		
		if($codigo_carrier == 'S0133')
		{
			$_modalidadEntrega = "LS";
			$row = Db::getInstance()->getRow('SELECT oficina_recogida, movil, correo  FROM `'._DB_PREFIX_.'correos_recoger`
													WHERE `order_id` = '.(int)$params['id_order']);
			$_email = $row['correo'];
			$_movil = $row['movil'];
			$_correosRecogida = "<OficinaElegida>".$row['oficina_recogida']."</OficinaElegida>";
		}else 
		{
			$_modalidadEntrega = "ST";
			$_email = $customer->email;
			$_movil = $address->phone_mobile;
			
		}
		
		
		if($order->module == 'cashondelivery')
		{
			
			$rembolso = "<Reembolso> 
              			<TipoReembolso>RC</TipoReembolso>
              			<Importe>".($order->total_paid*100)."</Importe>
             			<NumeroCuenta>".$correos_conf['remitente_nrcuenta']."</NumeroCuenta>
        		</Reembolso>";
		}
        
		$_dataAuth = '<CodEtiquetador>'.$correos_conf['etiquetador'].'</CodEtiquetador>';
		$_fechaOperacion = date('d-m-Y H:i:s');
		$_provincia = Db::getInstance()->getValue('
			SELECT `name`
			FROM `'._DB_PREFIX_.'state`
			WHERE `id_state` = '.(int)$address->id_state);
		
		
		$peso = $cart->getTotalWeight() * 1000;
		
		if ($peso == 0) $peso = 1; 
		
		if($correos_conf['seguro'] == "1")
			$seguroPaquete = "<ImporteSeguro>".($correos_conf['valorseguro'] * 100)."</ImporteSeguro>";
		/**
        *   xml de peticion
        */
        $xmlSend = <<<XML
<soapenv:Envelope xmlns:soapenv="http://schemas.xmlsoap.org/soap/envelope/" xmlns="http://www.correos.es/iris6/services/preregistroetiquetas">
<soapenv:Header/>
<soapenv:Body>
<PreregistroEnvio>
    <fechaOperacion>{$_fechaOperacion}</fechaOperacion>
    {$_dataAuth}
    <ModDevEtiqueta>2</ModDevEtiqueta>
    <Care>000000</Care>
    <TotalBultos>1</TotalBultos>
    <Remitente>
        <Identificacion>
            <Nombre><![CDATA[{$correos_conf['remitente_nombre']}]]></Nombre>
            <Apellido1><![CDATA[{$correos_conf['remitente_apellidos']}]]></Apellido1>
            <Apellido2></Apellido2>
            <Nif><![CDATA[{$correos_conf['remitente_dni']}]]></Nif>
        </Identificacion>
        <DatosDireccion>
            <Direccion><![CDATA[{$correos_conf['remitente_direccion']}]]></Direccion>
            <Numero></Numero>
            <Piso></Piso>
            <Puerta></Puerta>
            <Localidad><![CDATA[{$correos_conf['remitente_localidad']}]]></Localidad>
            <Provincia><![CDATA[{$correos_conf['remitente_provincia']}]]></Provincia>
        </DatosDireccion>
        <CP><![CDATA[{$correos_conf['remitente_cp']}]]></CP>
        <Telefonocontacto><![CDATA[{$correos_conf['remitente_movil']}]]></Telefonocontacto>
        <Email><![CDATA[{$correos_conf['remitente_email']}]]></Email>
        <DatosSMS>
            <NumeroSMS><![CDATA[{$correos_conf['remitente_movil']}]]></NumeroSMS>
            <Idioma>1</Idioma>
        </DatosSMS>
    </Remitente> 
    <Destinatario> 
        <Identificacion> 
            <Nombre><![CDATA[{$customer->firstname}]]></Nombre>
            <Apellido1><![CDATA[{$customer->lastname}]]></Apellido1>
            <Apellido2></Apellido2>
        </Identificacion>
        <DatosDireccion>
            <Direccion><![CDATA[{$address->address1}]]></Direccion>
            <Numero></Numero>
            <Piso></Piso>
            <Puerta></Puerta>
            <Localidad><![CDATA[{$address->city}]]></Localidad>
            <Provincia><![CDATA[{$_provincia}]]></Provincia>
        </DatosDireccion>
        <CP><![CDATA[{$address->postcode}]]></CP>
        <Telefonocontacto><![CDATA[{$address->phone}]]></Telefonocontacto>
        <Email><![CDATA[{$_email}]]></Email>
        <DatosSMS>
            <NumeroSMS><![CDATA[{$_movil}]]></NumeroSMS>
            <Idioma>1</Idioma>
        </DatosSMS>
    </Destinatario> 
    <Envio>
        <CodProducto>{$codigo_carrier}</CodProducto>
        <ReferenciaCliente>{$order->reference}</ReferenciaCliente>
        <TipoFranqueo>FP</TipoFranqueo>
        <ModalidadEntrega>{$_modalidadEntrega}</ModalidadEntrega>
        {$_correosRecogida}
        <Pesos>
            <Peso>
                <TipoPeso>R</TipoPeso>
                <Valor>{$peso}</Valor>
            </Peso>
        </Pesos>
        <Largo>0</Largo>
        <Alto>0</Alto>
        <Ancho>0</Ancho>
        <ValoresAnadidos>
            {$seguroPaquete}
			{$rembolso}
        </ValoresAnadidos>
        <Aduana>
            <TipoEnvio>2</TipoEnvio>
        </Aduana>
    </Envio>
</PreregistroEnvio>
</soapenv:Body>
</soapenv:Envelope>
XML;
	 
	
	
	 
	 //  peticion        
    $peticionCorreos = $this->preregistroCorreos($xmlSend, $correos_conf['usuario_correos'], $correos_conf['clave_correos']);

	try
        {
			
          if ($peticionCorreos == '')
                return false;
            
			 $dataXml = simplexml_load_string($peticionCorreos);
            if (!$dataXml->registerXPathNamespace('respuesta', 'http://www.correos.es/iris6/services/preregistroetiquetas'))
            {
                //  report error by writing it to the file. This function does not return anything to the screen;
      		  	file_put_contents('..\modules\correos\preregister_errors.txt', 'Error en los datos devueltos por Correos.');
                return false;
            }
    
            $_codExpedicion = $dataXml->xpath('//respuesta:CodExpedicion');
			$_FechaRespuesta = $dataXml->xpath('//respuesta:FechaRespuesta');
            $_datosBulto = $dataXml->xpath('//respuesta:Bulto');
            $_codError = $dataXml->xpath('//respuesta:Resultado');

                      
            
            if ($_codError[0] == '0')
            {
                // correct
                Db::getInstance()->Execute("INSERT INTO "._DB_PREFIX_."correos_preregister (order_id, carrier_id, carrier_code, code_expedicion, date_respuesta, code_envio) VALUES (".$params['id_order'].", '".$order->id_carrier."', '".$codigo_carrier."', '".$_codExpedicion[0]."', '".date("Y-m-d H:i:s",strtotime($_FechaRespuesta[0]))."', '".$_datosBulto[0]->CodEnvio."')");
                
				file_put_contents('..\modules\correos\preregister_errors.txt', "");
		    } else {
                
                $_msjError = $dataXml->xpath('//respuesta:DescError');
				file_put_contents('..\modules\correos\preregister_errors.txt', $_msjError);
                return false;
				
                
            }
            
            
           
            
            
        } catch (Exception $e) {            
            if (!$e->getMessage())
            {
				file_put_contents('..\modules\correos\preregister_errors.txt', 'No se ha podido contactar con el servidor de Correos.');
            } else {
				file_put_contents('..\modules\correos\preregister_errors.txt', 'No se ha podido contactar con el servidor de Correos: '.$e->getMessage());
            }
        }



	}
	 protected function preregistroCorreos($xmlSend, $usuario_correos, $clave_correos)
    {

        
        $URL = $this->GetCorreosURL('url_datos');
		   
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $URL);
        curl_setopt($ch, CURLOPT_USERPWD, $usuario_correos.":".$clave_correos);
        curl_setopt($ch, CURLOPT_HTTPAUTH, CURLAUTH_ANY);
        
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
        curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, false);
        
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_TIMEOUT, 10);
        curl_setopt($ch, CURLOPT_HEADER, FALSE);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $xmlSend);
        
        curl_setopt($ch, CURLOPT_FORBID_REUSE, TRUE);
        curl_setopt($ch, CURLOPT_HTTPHEADER, Array("Content-Type: text/xml", "SOAPAction: \"Preregistro\""));
        curl_setopt($ch, CURLOPT_FRESH_CONNECT, TRUE);
        
        
        $data = curl_exec($ch);
        
        if (curl_errno($ch)) {

            return false;
        }

        curl_close($ch);
        
        return $data;

    }
	public function hookOrderDetailDisplayed($params)
	{
		
		$code_envio = Db::getInstance()->getValue('SELECT code_envio FROM `'._DB_PREFIX_.'correos_preregister`
													WHERE `order_id` = '.(int)$params['order']->id);
		
		if(!$code_envio)
			return;
		$fases = $this->localizarEnvioFases($code_envio);
		$html = "";
		if(is_array($fases))
		{
			$i=0;
			$c = count($fases) - 1;
			foreach($fases as $fase)
			{
				$html .= '
				<tr class="'.($i==0 ? 'first_item' : (($i % 2) == 1) ? 'alternate_item' : '').' '.($i==$c ? 'last_item ' : '').'item">
					<td>'.$fase->Datos->Fecha.'</td>
					<td>'.utf8_decode($fase->Datos->Estado) .'</td>
				</tr>';
				$i++;
			}
			
		} else {
			$html = '<tr class="last_item item"><td colspan="2">'.$fases.'</td></tr>';
		}
	
		return '
		<h3>'.$this->l('Correos package information').'</h3>
		<div class="table_block">
			<table class="detail_step_by_step std">
				<thead>
					<tr>
						<th class="first_item">'.$this->l('Date').'</th>
						<th class="last_item">'.$this->l('State').'</th>
					</tr>
				</thead>
				<tbody>
				'.$html.'
				</tbody>
			</table>
		</div>
		';
	}
	function throwException($err) 
	{

	}
	 public function localizarEnvioUltimo ($codEnvio)
    {
        
        $xml = '<?xml version="1.0" encoding="utf-8" ?><ConsultaXMLin Idioma="1" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"><Consulta><Codigo>'.$codEnvio.'</Codigo></Consulta></ConsultaXMLin>';


$xmlSend = '<?xml version="1.0" encoding="utf-8"?>
<soap:Envelope xmlns:soap="http://schemas.xmlsoap.org/soap/envelope/" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema">
<soap:Body>
<ConsultaLocalizacionEnviosFasesMasivo xmlns="ServiciosWebLocalizacionMI/">
<XMLin><![CDATA['.$xml.']]></XMLin>
</ConsultaLocalizacionEnviosFasesMasivo>
</soap:Body>
</soap:Envelope>';

		
       
        $URL = $this->GetCorreosURL('url_localizacion_envio');
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL,  $URL);        
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
        curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, false);
        
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_TIMEOUT, 10);
        curl_setopt($ch, CURLOPT_HEADER, FALSE);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $xmlSend);
        curl_setopt($ch, CURLOPT_HTTPHEADER, Array("Content-Type: text/xml", "SOAPAction: ServiciosWebLocalizacionMI/ConsultaLocalizacionEnviosFasesMasivo"));
        curl_setopt($ch, CURLOPT_FORBID_REUSE, TRUE);
        curl_setopt($ch, CURLOPT_FRESH_CONNECT, TRUE);
        
       
        try
        {
            $data = curl_exec($ch);
            
            if (curl_errno($ch)) {
                return false;
            }
            
            $dataXml = simplexml_load_string($data, 'SimpleXMLElement', LIBXML_NOWARNING);
            $dataXml->registerXPathNamespace('respuesta', 'ServiciosWebLocalizacionMI/');
            $_respuesta = $dataXml->xpath('//respuesta:ConsultaLocalizacionEnviosFasesMasivoResult');
 
 
            $_respuestaXml = simplexml_load_string($_respuesta[0]);
            $respuesta = $_respuestaXml->xpath('//Respuestas/DatosIdiomas/DatosEnvios/Datos');

            $_estado = (string) $respuesta[0]->Estado;
            $_fecha = (string) $respuesta[0]->Fecha;
            
        } catch (Exception $e) {
          
            return "Datos no disponibles temporalmente.";
        }        
        
        return utf8_decode($_estado . " (" . $_fecha . ")");

    }
    
	public function localizarEnvioFases ($codEnvio)
    {
        
        $xml = '<?xml version="1.0" encoding="utf-8" ?><ConsultaXMLin Idioma="1" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"><Consulta><Codigo>'.$codEnvio.'</Codigo></Consulta></ConsultaXMLin>';


$xmlSend = '<?xml version="1.0" encoding="utf-8"?>
<soap:Envelope xmlns:soap="http://schemas.xmlsoap.org/soap/envelope/" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema">
<soap:Body>
<ConsultaLocalizacionEnviosFases xmlns="ServiciosWebLocalizacionMI/">
<XMLin><![CDATA['.$xml.']]></XMLin>
</ConsultaLocalizacionEnviosFases>
</soap:Body>
</soap:Envelope>';


	$URL = $this->GetCorreosURL('url_localizacion_envio');
    $ch = curl_init();
    curl_setopt($ch, CURLOPT_URL, $URL);        
    curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
    curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, false);
        
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($ch, CURLOPT_TIMEOUT, 10);
    curl_setopt($ch, CURLOPT_HEADER, FALSE);
    curl_setopt($ch, CURLOPT_POSTFIELDS, $xmlSend);
    curl_setopt($ch, CURLOPT_HTTPHEADER, Array("Content-Type: text/xml", "SOAPAction: ServiciosWebLocalizacionMI/ConsultaLocalizacionEnviosFases"));
    curl_setopt($ch, CURLOPT_FORBID_REUSE, TRUE);
    curl_setopt($ch, CURLOPT_FRESH_CONNECT, TRUE);
        
       
    try
    {
        $data = curl_exec($ch);
            
         if (curl_errno($ch)) 
                return false;
            
          $dataXml = simplexml_load_string($data, 'SimpleXMLElement', LIBXML_NOWARNING);
          $dataXml->registerXPathNamespace('respuesta', 'ServiciosWebLocalizacionMI/');
          $_respuesta = $dataXml->xpath('//respuesta:ConsultaLocalizacionEnviosFasesResult');
 
 		   $_respuestaXml = simplexml_load_string($_respuesta[0]);
           // $respuesta = $_respuestaXml->xpath('//Respuestas/DatosIdiomas/DatosEnvios/Datos');
            $respuesta = $_respuestaXml->xpath('//Respuestas/DatosIdiomas/DatosEnvios');
        } catch (Exception $e) {
           
            return "Datos no disponibles temporalmente.";
        }        
        
        
        return $respuesta;
        
    }    


	public static function GetCorreosURL($clave)
	{
		$sql = "SELECT valor FROM "._DB_PREFIX_."correos_conf WHERE clave = 'entorno_produccion'";

		if (Db::getInstance()->getValue($sql) == '1')
			$sql = "SELECT valor FROM "._DB_PREFIX_."correos_conf WHERE clave = '".$clave."'";
		 else 
			$sql = "SELECT valor FROM "._DB_PREFIX_."correos_conf WHERE clave = '".$clave."_pre'";		

		return Db::getInstance()->getValue($sql);
	}

	/*Get configuration table ps_correos_conf to array*/
	public static function GetCorreosConf($clave = false)
	{
		if (!$clave){
			$arr_data = false;
			$sql = 'SELECT * FROM '._DB_PREFIX_.'correos_conf';

			if ($results = Db::getInstance()->ExecuteS($sql)){
				foreach ($results as $row)
					$arr_data[$row['clave']] = $row['valor'];
			}
			return $arr_data;
		} else {
			$sql = "SELECT valor FROM "._DB_PREFIX_."correos_conf WHERE clave = '".$clave."'";
			return Db::getInstance()->getValue($sql);
		}
	}
	function getCarrierCodeById($ps_carrier_id){
		$codigo = Db::getInstance()->getValue("SELECT codigo FROM "._DB_PREFIX_."correos_carrier WHERE ps_carrier_id  = ".$ps_carrier_id."");
		if(!$codigo)
			return false;
		else
			return $codigo;
	}
	
}
?>