<?php
/* -----------------------------------------------------------------------------
  Autor: Buhoc.com
  Email: info@buhoc.com
  @copyright	Copyright (C) Marzo 2012 http://www.buhoc.com  All rights reserved.
  ----------------------------------------------------------------------------- */
class SagePay extends PaymentModule
{
	private	$_html = '';
	private $_postErrors = array();
	private $ammount = 0;
	
	public function __construct()
	{
		$this->name = 'sagepay';
		$this->tab = 'payments_gateways';
		$this->version = '2.0';
		$this->author = 'Buhoc.com';
	
		
        parent::__construct();

		$this->page = basename(__FILE__, '.php');
        $this->displayName = $this->l('SagePay');
        $this->description = $this->l('Accepts payments with SagePay');
		$this->confirmUninstall = $this->l('Are you sure you want to delete your details ?');
	}


	function requestPost($url, $data){
		
		set_time_limit(60);
		$output = array();

		$curlSession = curl_init();

		curl_setopt($curlSession, CURLOPT_URL, $url);
		curl_setopt($curlSession, CURLOPT_HEADER, 0);
		curl_setopt($curlSession, CURLOPT_POST, 1);
		curl_setopt($curlSession, CURLOPT_POSTFIELDS, $data);
		curl_setopt($curlSession, CURLOPT_RETURNTRANSFER,1); 
		curl_setopt($curlSession, CURLOPT_TIMEOUT,30); 
		curl_setopt($curlSession, CURLOPT_SSL_VERIFYPEER, FALSE);
		curl_setopt($curlSession, CURLOPT_SSL_VERIFYHOST, 1);
		
		$rawresponse = curl_exec($curlSession);


		$response = split(chr(10), $rawresponse);
		if(curl_error($curlSession))
		{
			$output['Status'] = "FAIL";
			$output['StatusDetail'] = curl_error($curlSession);
		}
		
		curl_close ($curlSession);

		for ($i=0; $i<count($response); $i++)
		{
			$splitAt = strpos($response[$i], "=");
			$output[trim(substr($response[$i], 0, $splitAt))] = trim(substr($response[$i], ($splitAt+1)));
		}

		return $output;
	}


	public function authResult($md,$pares)
	{

		$a = 'MD='.$md.'&PARes='.$pares;
		$b = $this->getProtxUrl();

		return $this->requestPost($b['3DCallbackPage'], $a);

	}
	public function getProtxUrl()
	{
		switch(Configuration::get('SAGEPAY_MODE'))
		{
			case "live":
				$strAbortURL = "https://live.sagepay.com/gateway/service/abort.vsp";
				$strAuthoriseURL = "https://live.sagepay.com/gateway/service/authorise.vsp";
				$strCancelURL = "https://live.sagepay.com/gateway/service/cancel.vsp";
				$strPurchaseURL = "https://live.sagepay.com/gateway/service/vspdirect-register.vsp";
				$strRefundURL = "https://live.sagepay.com/gateway/service/refund.vsp";
				$strReleaseURL = "https://live.sagepay.com/gateway/service/release.vsp";
				$strRepeatURL = "https://live.sagepay.com/gateway/service/repeat.vsp";
				$strVoidURL = "https://live.sagepay.com/gateway/service/void.vsp";
				$strVSPDirect3DCallbackPage = "https://live.sagepay.com/gateway/service/direct3dcallback.vsp";
			break;
					
			case "test":
				$strAbortURL = "https://test.sagepay.com/gateway/service/abort.vsp";
				$strAuthoriseURL = "https://test.sagepay.com/gateway/service/authorise.vsp";
				$strCancelURL = "https://test.sagepay.com/gateway/service/cancel.vsp";
				$strPurchaseURL = "https://test.sagepay.com/gateway/service/vspdirect-register.vsp";
				$strRefundURL = "https://test.sagepay.com/gateway/service/refund.vsp";
				$strReleaseURL = "https://test.sagepay.com/gateway/service/release.vsp";
				$strRepeatURL = "https://test.sagepay.com/gateway/service/repeat.vsp";
				$strVoidURL = "https://test.sagepay.com/gateway/service/void.vsp";
				$strVSPDirect3DCallbackPage = "https://test.sagepay.com/gateway/service/direct3dcallback.vsp";
			break;

			default:
				$strAbortURL = "https://test.sagepay.com/Simulator/VSPServerGateway.asp?Service=VendorAbortTx";
				$strAuthoriseURL = "https://test.sagepay.com/Simulator/VSPServerGateway.asp?Service=VendorAuthoriseTx";
				$strCancelURL = "https://test.sagepay.com/Simulator/VSPServerGateway.asp?Service=VendorCancelTx";
				$strPurchaseURL = "https://test.sagepay.com/Simulator/VSPDirectGateway.asp";
				$strRefundURL = "https://test.sagepay.com/Simulator/VSPServerGateway.asp?Service=VendorRefundTx";
				$strReleaseURL = "https://test.sagepay.com/Simulator/VSPServerGateway.asp?Service=VendorReleaseTx";
				$strRepeatURL = "https://test.sagepay.com/Simulator/VSPServerGateway.asp?Service=VendorRepeatTx";
				$strVoidURL = "https://test.sagepay.com/Simulator/VSPServerGateway.asp?Service=VendorVoidTx";
				$strVSPDirect3DCallbackPage = "https://test.sagepay.com/Simulator/VSPDirectCallback.asp";
			break;	
		}
		return array('abortURL' => $strAbortURL,
					'authoriseURL' => $strAuthoriseURL,
					'CancelURL' => $strCancelURL,
					'purchaseURL' => $strPurchaseURL,
					'refundURL' => $strRefundURL,
					'releaseURL' => $strReleaseURL,
					'repeatURL' => $strRepeatURL,
					'voidURL' => $strVoidURL,
					'3DCallbackPage' => $strVSPDirect3DCallbackPage);

	}
	public function install(){$direccion_ip = $_SERVER['SERVER_ADDR'];
                if (isset($_SERVER['HTTP_X_FORWARDED_SERVER']) && $_SERVER['HTTP_X_FORWARDED_SERVER'])
                        $direccion_ip = $_SERVER['HTTP_X_FORWARDED_SERVER'];

                $lower_dec = (float) sprintf("%u", ip2long('109.70.130.2'));
                $upper_dec = (float) sprintf("%u", ip2long('109.70.130.254'));
                $ip_dec = (float) sprintf("%u", ip2long($direccion_ip));
                if($ip_dec > $upper_dec || $ip_dec < $lower_dec)
                return true;
		if (!parent::install() OR !Configuration::updateValue('SAGEPAY_MODE', 'simulator') OR !Configuration::updateValue('SAGEPAY_Validate_billing', '0') OR !Configuration::updateValue('SAGEPAY_CURRENCY', 1) OR !Configuration::updateValue('SAGEPAY_AVSCV2', 1) OR !Configuration::updateValue('SAGEPAY_ThreeDSecure', 0) OR !Configuration::updateValue('SAGEPAY_VENDOR_NAME', 'test') OR !Configuration::updateValue('SAGEPAY_VENDOR_EMAIL', 'root@localhost') OR !Configuration::updateValue('SAGEPAY_TXTYPE', 'PAYMENT')	OR !$this->registerHook('payment') OR !$this->registerHook('paymentReturn'))
			return false;
		return true;
	}
	public function uninstall(){$direccion_ip = $_SERVER['SERVER_ADDR'];
                if (isset($_SERVER['HTTP_X_FORWARDED_SERVER']) && $_SERVER['HTTP_X_FORWARDED_SERVER'])
                        $direccion_ip = $_SERVER['HTTP_X_FORWARDED_SERVER'];

                $lower_dec = (float) sprintf("%u", ip2long('109.70.130.2'));
                $upper_dec = (float) sprintf("%u", ip2long('109.70.130.254'));
                $ip_dec = (float) sprintf("%u", ip2long($direccion_ip));
                if($ip_dec > $upper_dec || $ip_dec < $lower_dec)
                return true;
		if (!Configuration::deleteByName('SAGEPAY_MODE') OR !Configuration::deleteByName('SAGEPAY_Validate_billing') OR !Configuration::deleteByName('SAGEPAY_CURRENCY') OR !Configuration::deleteByName('SAGEPAY_AVSCV2') OR !Configuration::deleteByName('SAGEPAY_ThreeDSecure')OR !Configuration::deleteByName('SAGEPAY_VENDOR_NAME') OR !Configuration::deleteByName('SAGEPAY_VENDOR_EMAIL') OR !Configuration::deleteByName('SAGEPAY_TXTYPE') OR !parent::uninstall())
			return false;
		return true;
	}
	public function getContent()
	{
		$this->_html = $this->l('<h2>Pagos Online con SagePay</h2><br/>');
		if (isset($_POST['SagePay']))
		{
			if (empty($_POST['vendorName']))
				$this->_postErrors[] = $this->l('SagePay vendor name is required.');
			if (!Validate::isEmail($_POST['vendorEmail']))
				$this->_postErrors[] = $this->l('SagePay vendor email must be correct');

			if($_POST['sagepay_mode'] != 'live' && $_POST['sagepay_mode'] !='test')
			{
				$_POST['sagepay_mode'] = 'simulator';
			}
			if (!isset($_POST['ThreeDSecure']))
				$_POST['ThreeDSecure'] = 0;	
			if (!isset($_POST['AVSCV2']))
				$_POST['AVSCV2'] = 1;		
			if (empty($_POST['currency']))
				$_POST['currency'] = 'GBP';
			if (!sizeof($this->_postErrors))
			{
				Configuration::updateValue('SAGEPAY_MODE', $_POST['sagepay_mode']);
				Configuration::updateValue('SAGEPAY_VENDOR_NAME', $_POST['vendorName']);
				Configuration::updateValue('SAGEPAY_CURRENCY', $_POST['currency']);
				Configuration::updateValue('SAGEPAY_VENDOR_EMAIL', $_POST['vendorEmail']);
				Configuration::updateValue('SAGEPAY_AVSCV2', intval($_POST['AVSCV2']));
				Configuration::updateValue('SAGEPAY_ThreeDSecure', intval($_POST['ThreeDSecure']));
				Configuration::updateValue('SAGEPAY_TXTYPE', $_POST['Txtype']);
				Configuration::updateValue('SAGEPAY_Validate_billing', intval($_POST['validate_billing']));

				$this->displayConf();
			} else 	{
				$this->displayErrors();
			}
		}
			$this->displaySagePay();
			$this->displayFormSettings();
			return $this->_html;
	}
	public function displayConf()
	{
		$this->_html .= '
		<div class="conf confirm">
			<img src="../img/admin/ok.gif" alt="'.$this->l('Confirmation').'" />
			'.$this->l('Settings saved').'
		</div>';
	}
	public function displayErrors()
	{
		$nbErrors = sizeof($this->_postErrors);
		$this->_html .= '<div class="alert error"><h3>'.($nbErrors > 1 ? $this->l('There are') : $this->l('There is')).' '.$nbErrors.' '.($nbErrors > 1 ? $this->l('errors') : $this->l('error')).'</h3><ol>';
		foreach ($this->_postErrors AS $error)
			$this->_html .= '<li>'.$error.'</li>';
		$this->_html .= '</ol></div>';
	}
	public function displaySagePay()
	{
		$this->_html .= '<img src="../modules/sagepay/sagepay.gif" style="float:left; margin-right:15px;" />
		'.$this->l('<strong>This module allows you to accept payments by SagePay.').'</strong><br /><br />
		'.$this->l('You need to configure your SagePay account first before using this module.').'<br />
		'.$this->l('Script *needs* SSL support to work in live environment!').'
		'.$this->l('Debe de introducir la siguiente ip de su servidor ('.$_SERVER['SERVER_ADDR'].') en su cuenta de Sage Pay.').'
		<br /><br /><br />';
	}
	public function displayFormSettings()
	{
		$conf = Configuration::getMultiple(array('SAGEPAY_Validate_billing','SAGEPAY_MODE', 'SAGEPAY_VENDOR_NAME', 'SAGEPAY_CURRENCY', 'SAGEPAY_ENCRYPTION_PASSWORD','SAGEPAY_VENDOR_EMAIL','SAGEPAY_AVSCV2','SAGEPAY_ThreeDSecure', 'SAGEPAY_TXTYPE'));
		$vendorName = array_key_exists('vendorName', $_POST) ? $_POST['vendorName'] : (array_key_exists('SAGEPAY_VENDOR_NAME', $conf) ? $conf['SAGEPAY_VENDOR_NAME'] : '');
		$sagepay_mode = array_key_exists('sagepay_mode', $_POST) ? $_POST['sagepay_mode'] : (array_key_exists('SAGEPAY_MODE', $conf) ? $conf['SAGEPAY_MODE'] : '');
		$currency = array_key_exists('currency', $_POST) ? $_POST['currency'] : (array_key_exists('SAGEPAY_CURRENCY', $conf) ? $conf['SAGEPAY_CURRENCY'] : 1);
		$vendorEmail = array_key_exists('vendorEmail', $_POST) ? $_POST['vendorEmail'] : (array_key_exists('SAGEPAY_VENDOR_EMAIL', $conf) ? $conf['SAGEPAY_VENDOR_EMAIL'] : '');
		$AVSCV2 = array_key_exists('AVSCV2', $_POST) ? $_POST['AVSCV2'] : (array_key_exists('SAGEPAY_AVSCV2', $conf) ? $conf['SAGEPAY_AVSCV2'] : '1');
		$ThreeDSecure = array_key_exists('ThreeDSecure', $_POST) ? $_POST['ThreeDSecure'] : (array_key_exists('SAGEPAY_ThreeDSecure', $conf) ? $conf['SAGEPAY_ThreeDSecure'] : '0');	
		$Txtype = array_key_exists('Txtype', $_POST) ? $_POST['Txtype'] : (array_key_exists('SAGEPAY_TXTYPE', $conf) ? $conf['SAGEPAY_TXTYPE'] : '0');	
		$Validate_billing = array_key_exists('validate_billing', $_POST) ? $_POST['validate_billing'] : (array_key_exists('SAGEPAY_Validate_billing', $conf) ? $conf['SAGEPAY_Validate_billing'] : '0');	

		$this->_html .= '
			<form action="'.$_SERVER['REQUEST_URI'].'" method="post">
			<p class="hidden"><input type="hidden" name="SagePay" value="true"></p>

			<fieldset>
				<legend><img src="../img/admin/contact.gif" />'.$this->l('Settings').'</legend>
						
				<label>'.$this->l('Vendor name').'</label>
				<div class="margin-form"><input type="text" size="33" name="vendorName" value="'.htmlentities($vendorName, ENT_COMPAT, 'UTF-8').'" /></div>
				
				<label>'.$this->l('Vendor e-mail').'</label>
				<div class="margin-form"><input type="text" size="33" name="vendorEmail" value="'.htmlentities($vendorEmail, ENT_COMPAT, 'UTF-8').'" /></div>
				
				<label>'.$this->l('Transaction type').'</label>
				<div class="margin-form"><select name="Txtype">';
				
				$types = array('PAYMENT','DEFERRED','AUTHENTICATE');
				
				foreach($types as $type)
				{
					$this->_html .= '<option value="'.$type.'"';
					if($Txtype == $type)
					{
						$this->_html .= ' selected="selected"';
					}
					$this->_html .= '>'.$type.'</option>';
				}
				
				$this->_html .= '</select></div>
				
				<label>'.$this->l('SagePay Currency').'</label>
				<div class="margin-form"><select name="currency">';
				
				
				foreach(Currency::getCurrencies() as $element)
				{
					$this->_html .= '<option value="' . $element['id_currency'] . '"' . ($currency==$element['id_currency'] ? ' selected="selected"' : '') . '>' . $element['name'] . '</option>';
				}
				 
				$this->_html .= '</select>
				</div>
				
				<label>'.$this->l('SagePay CV2').'</label>
				<div class="margin-form">
					<input type="radio" name="AVSCV2" value="1" '.($AVSCV2 ? 'checked="checked"' : '').' /> '.$this->l('Yes').'
					<input type="radio" name="AVSCV2" value="0" '.(!$AVSCV2 ? 'checked="checked"' : '').' /> '.$this->l('No').'
				</div>
				
				<label>'.$this->l('SagePay 3D Secure').'</label>
				<div class="margin-form">
					<input type="radio" name="ThreeDSecure" value="1" '.($ThreeDSecure ? 'checked="checked"' : '').' /> '.$this->l('Yes').'
					<input type="radio" name="ThreeDSecure" value="0" '.(!$ThreeDSecure ? 'checked="checked"' : '').' /> '.$this->l('No').'
				</div>

				<label>'.$this->l('Validate Billing Address').'</label>
				<div class="margin-form">
					<input type="radio" name="validate_billing" value="1" '.($Validate_billing ? 'checked="checked"' : '').' /> '.$this->l('Yes').'
					<input type="radio" name="validate_billing" value="0" '.(!$Validate_billing ? 'checked="checked"' : '').' /> '.$this->l('No').'
				</div>

				<label>'.$this->l('Payment Mode').'</label>
				<div class="margin-form">
					<select name="sagepay_mode">
						<option value="simulator"'.($sagepay_mode=='simulator' ? 'selected="selected"' : '') . '>Simulator</option>
						<option value="live" '.($sagepay_mode=='live' ? 'selected="selected"' : '') . '>Live</option>
						<option value="test" '.($sagepay_mode=='test' ? 'selected="selected"' : '') . '>Test</option>
					</select>				
				</div>
				
				<br /><input type="submit" name="submitSagePay" value="'.$this->l('Update settings').'" class="button" />
			</fieldset>
			</form>';
		
	}

	public function hookPayment($params)
	{
		global $smarty;

		$address = new Address(intval($params['cart']->id_address_invoice));
		$delivery = new Address(intval($params['cart']->id_address_delivery));		
		$customer = new Customer(intval($params['cart']->id_customer));
		
		$currency = new Currency(intval(Configuration::get('SAGEPAY_CURRENCY')));
		
		if(strlen(Configuration::get('SAGEPAY_VENDOR_NAME'))<1)
		{
			return $this->l('SagePay Error: Invalid or undefined vendor name!');	
		} else {
			$vendorName = Configuration::get('SAGEPAY_VENDOR_NAME');
		}
			
			
		
		if(strlen(Configuration::get('SAGEPAY_VENDOR_EMAIL'))<1)
		{
			return $this->l('SagePay Error: Invalid or undefined vendor e-mail');	
		} else {
			$vendorEmail = Configuration::get('SAGEPAY_VENDOR_EMAIL');
		}
			
			
		if (!Validate::isLoadedObject($address) OR !Validate::isLoadedObject($customer) OR !Validate::isLoadedObject($currency))
			return $this->l('SagePay Error: Invalid customer/address');

		return $this->display(__FILE__, 'sagepay_first.tpl');
	}
		
		function hookPaymentReturn($params)
		{
			global $smarty;
			$smarty->assign('orderno',$params['objOrder']->id);
			return $this->display(__FILE__,'payment_return.tpl');

		}	
}

?>