<?php


if (!defined('_PS_VERSION_'))
	exit;

class sendToACustomer extends Module
{
	private $_html = '';
	private $_postErrors = array();
	public $context;

	function __construct($dontTranslate = false)
 	{
 	 	$this->name = 'sendtoacustomer';
 	 	$this->version = '1.5';
		$this->author = 'Buhoc';
 	 	$this->tab = 'front_office_features';
		$this->need_instance = 0;
		$this->secure_key = Tools::encrypt($this->name);

		parent::__construct();

		if (!$dontTranslate)
		{
			$this->displayName = $this->l('Send to a customer mail');
			$this->description = $this->l('Send to a customer mail for info product.');
 		}
	}

	public function install()
	{
	 	return (parent::install() AND Configuration::updateValue('sendtoacustomer_mail', '') && Configuration::updateValue('sendtoacustomer_text', '') && $this->registerHook('extraRight') && $this->registerHook('header'));
	}

	public function uninstall()
	{
		return (parent::uninstall() && $this->unregisterHook('header') && $this->unregisterHook('extraRight'));
		return (Configuration::deleteByName('sendtoacustomer_mail') AND Configuration::deleteByName('sendtoacustomer_text') AND parent::uninstall());
	
	}
public function getContent()
	{
		// If we try to update the settings
		$output = '';
		if (isset($_POST['submitModule']))
		{	
			Configuration::updateValue('sendtoacustomer_mail', (($_POST['mail_name'] != '') ? $_POST['mail_name']: ''));		
			Configuration::updateValue('sendtoacustomer_text', (($_POST['text_cap'] != '') ? $_POST['text_cap']: ''));	
			$output = '<div class="conf confirm">'.$this->l('Configuration updated').'</div>';
		}
		
		return '
		<h2>'.$this->displayName.'</h2>
		'.$output.'
		<form action="'.Tools::htmlentitiesutf8($_SERVER['REQUEST_URI']).'" method="post">
			<fieldset class="width2">				
				<label for="mail_name">'.$this->l('E-mail de recepción: ').'</label>
				<input type="text" id="mail_name" name="mail_name" value="'.Tools::safeOutput((Configuration::get('sendtoacustomer_mail') != "") ? Configuration::get('sendtoacustomer_mail') : "").'" />
				<div class="clear">&nbsp;</div>	
				<label for="text_cap">'.$this->l('Texto cabecera: ').'</label>
				<input type="text" id="text_cap" name="text_cap" value="'.Tools::safeOutput((Configuration::get('sendtoacustomer_text') != "") ? Configuration::get('sendtoacustomer_text') : "").'" />
				<div class="clear">&nbsp;</div>										
				<br /><center><input type="submit" name="submitModule" value="'.$this->l('Actualizar').'" class="button" /></center>
			</fieldset>
		</form>';
	}
	public function hookExtraRight($params)
	{
		/* Product informations */
		$product = new Product((int)Tools::getValue('id_product'), false, $this->context->language->id);
		$image = Product::getCover((int)$product->id);


		$this->context->smarty->assign(array(
			'stf_product' => $product,
			'stf_product_cover' => (int)$product->id.'-'.(int)$image['id_image'],
			'stf_secure_key' => $this->secure_key
		));
global $smarty;

		$smarty->assign(array(
			'mail_name' => Configuration::get('sendtoacustomer_mail'),
			'text_cap' => Configuration::get('sendtoacustomer_text')
			
		));
		return $this->display(__FILE__, 'sendtoacustomer-extra.tpl');
	}

	public function hookHeader($params)
	{
		$this->context->controller->addCSS($this->_path.'css/sendtoacustomer.css', 'all');
		return $this->display(__FILE__, 'header.tpl');
	}
}