<?php
class BlockFadingText extends Module 
{
 	private $_html = '';
 	private $_bft_text;
 	private $_bft_order;
 	private $_bft_delay;
 	
 	function __construct()
	{
		$this->name = 'blockfadingtext';
		$this->tab = floatval(substr(_PS_VERSION_,0,3))<1.4?'Presto-Changeo':'front_office_features';
		$this->version = '1.2';
		if (floatval(substr(_PS_VERSION_,0,3)) >= 1.4)
			$this->author = 'Presto-Changeo';
		
		parent::__construct(); // The parent construct is required for translations
		$this->_refreshProperties();

		$this->displayName = $this->l('Block Fading Text');
		$this->description = $this->l('Create a rotating fading text for site news, testimonials or anything else.');
	}

	function install()
	{
		if (!parent::install() || !$this->registerHook('leftColumn')
		||!Configuration::updateValue('BFT_DELAY',5000))
			return false;
		$query = 'CREATE TABLE IF NOT EXISTS `'._DB_PREFIX_.'bft_content` (
  			`content` MEDIUMTEXT NOT NULL
			) ENGINE=MyISAM DEFAULT CHARSET=utf8;';
		Db::getInstance()->Execute(trim($query));
		$result = Db::getInstance()->ExecuteS("SELECT * FROM `"._DB_PREFIX_."bft_content`");
		if (sizeof($result) == 0)
			Db::getInstance()->Execute('INSERT INTO `'._DB_PREFIX_.'bft_content` (`content`) VALUES ("")');
		return true;
	}

	function uninstall()
	{
		if (!parent::uninstall())
			return false;
		return true;
	}

	private function _refreshProperties()
	{
		$query = 'CREATE TABLE IF NOT EXISTS `'._DB_PREFIX_.'bft_content` (
  			`content` MEDIUMTEXT NOT NULL
			) ENGINE=MyISAM DEFAULT CHARSET=utf8;';
		Db::getInstance()->Execute(trim($query));
		$result = Db::getInstance()->ExecuteS("SELECT * FROM `"._DB_PREFIX_."bft_content`");
		$tmp = "";
		if (sizeof($result) == 0)
			Db::getInstance()->Execute('INSERT INTO `'._DB_PREFIX_.'bft_content` (`content`) VALUES ("")');
		else
			$tmp = $result[0]['content'];
		$this->_bft_text = !is_array($tmp) && trim($tmp) != ""?unserialize($tmp):(!is_array($this->_bft_text) && trim($this->_bft_text) != ""?unserialize($this->_bft_text):array());
		$this->_bft_order = intval(Configuration::get('BFT_ORDER'));
		$this->_bft_delay = intval(Configuration::get('BFT_DELAY'));
	}
	
	public function getContent()
	{
		$ps_version  = floatval(substr(_PS_VERSION_,0,3));
		$this->_html = ($ps_version >= 1.5?'<div style="width:980px; margin: 0 auto;">':'').'<img src="http://updates.presto-changeo.com/logo.jpg" border="0" /><h2>'.$this->displayName.'</h2>';
		$this->_postProcess();
		$this->_displayForm();
		
		$this->_html .= ($ps_version == 1.5?'</div>':'');
		return $this->_html;
	}
	
    private function _displayForm()
    {
    	global $cookie;
		$iso = Language::getIsoById($cookie->id_lang);
		$ps_version  = floatval(substr(_PS_VERSION_,0,3));
		$this->_html .= '
    		<link rel="stylesheet" type="text/css" href="'._MODULE_DIR_.'blockfadingtext/css/bft.css">
    		<script type="text/javascript" src="'._MODULE_DIR_.'blockfadingtext/js/jquery.tablednd_0_5.js"></script>
    		<script type="text/javascript">
				var baseDir = \''._MODULE_DIR_.'blockfadingtext/'.'\';
				var total_groups = \''.sizeof($this->_bft_text).'\';
				var alternate = \'0\';
				var bft_psv = \''.$ps_version.'\';
				var bft_confirm_reset = \''.$this->l('Are you sure you want to reset all the settings').'?\';
				</script>';
		if (file_exists(_PS_ROOT_DIR_.'/js/tinymce/jscripts/tiny_mce/jquery.tinymce.js'))
    	{
    		$this->_html .= '
		<script type="text/javascript" src="'.__PS_BASE_URI__.'js/tinymce/jscripts/tiny_mce/jquery.tinymce.js"></script>
		<script type="text/javascript">
		function tinyMCEInit(element)
		{
			aw_tiny = true;
			$().ready(function() {
				$(element).tinymce({
					// Location of TinyMCE script
					script_url : \''.__PS_BASE_URI__.'js/tinymce/jscripts/tiny_mce/tiny_mce.js\',
					// General options
					theme : "advanced",
					plugins : "safari,pagebreak,style,layer,table,advimage,advlink,inlinepopups,media,searchreplace,contextmenu,paste,directionality,fullscreen",
					// Theme options
					theme_advanced_buttons1 : "newdocument,|,bold,italic,underline,strikethrough,|,justifyleft,justifycenter,justifyright,justifyfull,styleselect,formatselect,fontselect,fontsizeselect",
					theme_advanced_buttons2 : "cut,copy,paste,pastetext,pasteword,|,search,replace,|,bullist,numlist,|,outdent,indent,blockquote,|,undo,redo,|,link,unlink,anchor,image,cleanup,help,code,,|,forecolor,backcolor",
					theme_advanced_buttons3 : "tablecontrols,|,hr,removeformat,visualaid,|,sub,sup,|,charmap,media,|,ltr,rtl,|,fullscreen",
					theme_advanced_buttons4 : "insertlayer,moveforward,movebackward,absolute,|,styleprops,|,cite,abbr,acronym,del,ins,attribs,|,pagebreak",
					theme_advanced_toolbar_location : "top",
					theme_advanced_toolbar_align : "left",
					width : "700px",
					theme_advanced_statusbar_location : "bottom",
					theme_advanced_resizing : true,
					content_css : "'.__PS_BASE_URI__.'themes/'._THEME_NAME_.'/css/global.css",
					// Drop lists for link/image/media/template dialogs
					template_external_list_url : "lists/template_list.js",
					external_link_list_url : "lists/link_list.js",
					external_image_list_url : "lists/image_list.js",
					media_external_list_url : "lists/media_list.js",
					elements : "nourlconvert",
					convert_urls : false,
					language : "'.(file_exists(_PS_ROOT_DIR_.'/js/tinymce/jscripts/tiny_mce/langs/'.$iso.'.js') ? $iso : 'en').'"
				});
			});
		}
		</script>';
    	}
    	elseif (file_exists(_PS_ROOT_DIR_.'/js/tinymce/jscripts/tiny_mce/tiny_mce.js'))
    	{
			$this->_html .= ' <script type="text/javascript" src="'.__PS_BASE_URI__.'js/tinymce/jscripts/tiny_mce/tiny_mce.js"></script>
				<script type="text/javascript">
		function tinyMCEInit(element)
		{
			aw_tiny = true;
						tinyMCE.init({
						mode : "textareas",
						theme : "advanced",
						plugins : "safari,pagebreak,style,layer,table,advimage,advlink,inlinepopups,media,searchreplace,contextmenu,paste,directionality,fullscreen",
						// Theme options
						theme_advanced_buttons1 : "newdocument,|,bold,italic,underline,strikethrough,|,justifyleft,justifycenter,justifyright,justifyfull,styleselect,formatselect,fontselect,fontsizeselect",
						theme_advanced_buttons2 : "cut,copy,paste,pastetext,pasteword,|,search,replace,|,bullist,numlist,|,outdent,indent,blockquote,|,undo,redo,|,link,unlink,anchor,image,cleanup,help,code,,|,forecolor,backcolor",
						theme_advanced_buttons3 : "tablecontrols,|,hr,removeformat,visualaid,|,sub,sup,|,charmap,media,|,ltr,rtl,|,fullscreen",
						theme_advanced_buttons4 : "insertlayer,moveforward,movebackward,absolute,|,styleprops,|,cite,abbr,acronym,del,ins,attribs,|,pagebreak",
						theme_advanced_toolbar_location : "top",
						theme_advanced_toolbar_align : "left",
						theme_advanced_statusbar_location : "bottom",
						theme_advanced_resizing : false,
						content_css : "'.__PS_BASE_URI__.'themes/'._THEME_NAME_.'/css/global.css",
						document_base_url : "'.__PS_BASE_URI__.'",
						width: "600",
						height: "auto",
						font_size_style_values : "8pt, 10pt, 12pt, 14pt, 18pt, 24pt, 36pt",
						// Drop lists for link/image/media/template dialogs
						template_external_list_url : "lists/template_list.js",
						external_link_list_url : "lists/link_list.js",
						external_image_list_url : "lists/image_list.js",
						media_external_list_url : "lists/media_list.js",
						elements : "nourlconvert,ajaxfilemanager",
						file_browser_callback : "ajaxfilemanager",
						entity_encoding: "raw",
						convert_urls : false,
						language : "'.(file_exists(_PS_ROOT_DIR_.'/js/tinymce/jscripts/tiny_mce/langs/'.$iso.'.js') ? $iso : 'en').'"
						
					});
					}
				</script>';
    	}else if (file_exists(_PS_ROOT_DIR_.'/js/tiny_mce/tiny_mce.js'))
    	{



			$this->_html .= ' <script type="text/javascript" src="'.__PS_BASE_URI__.'js/tiny_mce/tiny_mce.js"></script>



				<script type="text/javascript">
		function tinyMCEInit(element)
		{
			aw_tiny = true;

						tinyMCE.init({

						mode : "textareas",
						theme : "advanced",



						plugins : "safari,pagebreak,style,table,advimage,advlink,inlinepopups,media,contextmenu,paste,fullscreen,xhtmlxtras,preview",
						// Theme options
						theme_advanced_buttons1 : "newdocument,|,bold,italic,underline,strikethrough,|,justifyleft,justifycenter,justifyright,justifyfull,styleselect,formatselect,fontselect,fontsizeselect",
						theme_advanced_buttons2 : "cut,copy,paste,pastetext,pasteword,|,search,replace,|,bullist,numlist,|,outdent,indent,blockquote,|,undo,redo,|,link,unlink,anchor,image,cleanup,help,code,,|,forecolor,backcolor",
						theme_advanced_buttons3 : "tablecontrols,|,hr,removeformat,visualaid,|,sub,sup,|,charmap,media,|,ltr,rtl,|,fullscreen",
						theme_advanced_buttons4 : "insertlayer,moveforward,movebackward,absolute,|,styleprops,|,cite,abbr,acronym,del,ins,attribs,|,pagebreak",
						theme_advanced_toolbar_location : "top",
						theme_advanced_toolbar_align : "left",
						theme_advanced_statusbar_location : "bottom",
						theme_advanced_resizing : false,
						content_css : "'.__PS_BASE_URI__.'themes/'._THEME_NAME_.'/css/global.css",

						document_base_url : "'.__PS_BASE_URI__.'",
						width: "600",
						height: "auto",
						font_size_style_values : "8pt, 10pt, 12pt, 14pt, 18pt, 24pt, 36pt",
						// Drop lists for link/image/media/template dialogs
						template_external_list_url : "lists/template_list.js",
						external_link_list_url : "lists/link_list.js",
						external_image_list_url : "lists/image_list.js",
						media_external_list_url : "lists/media_list.js",
						elements : "nourlconvert,ajaxfilemanager",
						file_browser_callback : "ajaxfilemanager",
						entity_encoding: "raw",
						convert_urls : false,
						language : "'.(file_exists(_PS_ROOT_DIR_.'/js/tiny_mce/langs/'.$iso.'.js') ? $iso : 'en').'"

						

					});


					}


				</script>';
    	}
    	$this->_html .= '
			<script type="text/javascript" src="'.$this->_path.'js/bft.js"></script>
			<form action="'.$_SERVER['REQUEST_URI'].'" name="order_form" id="order_form" method="post">
			<input type="hidden" name="bft_tinymce" id="bft_tinymce" value="" />
			<fieldset class="width3" style="width:90%"><legend><img src="'.$this->_path.'logo.gif" />'.$this->l('Block Fading Text').'</legend>
			<li style="margin-left:10px">'.$this->l('To change the header of the block from "News and Updates", use the Backoffice -> Tools -> Translations-> Module Translations').'</li>
			<br />
			<input class="button" type="button" value="'.$this->l('Turn on TinyMCE Editor').'" onclick="$(\'#bft_tinymce\').val(1);tinyMCEInit(\'textarea\');" /> '.$this->l('You will not be able to change the order until you click "Update"').'.
			<br />
			<br />
			<b>'.$this->l('Display Order').'</b>: &nbsp;&nbsp;'.$this->l('Ordered').' <input type="radio" id="bft_order" name="bft_order" value="1" '.(Tools::getValue('bft_order', $this->_bft_order) != "2"?"checked":"").' />&nbsp;
			&nbsp;&nbsp;&nbsp;'.$this->l('Random').' <input type="radio" id="bft_order" name="bft_order" value="2" '.(Tools::getValue('bft_order', $this->_bft_order) == "2"?"checked":"").' />&nbsp;
			<br />
			<br />
			<input type="submit" value="'.$this->l('Update').'" name="submitChanges" class="button" />
			&nbsp;&nbsp;&nbsp;
			<input onclick="return confirm(bft_confirm_reset)" type="submit" value="'.$this->l('Reset').'" name="resetData" class="button" />
			<br />
			<br />
			<table id="text" border="0" width="800" class="table tableDnD">
			<tr>
				<th align="left" style="width:1%">
					'.$this->l('Order').'
				</th>
				<th align="left" style="width:10%">
					'.$this->l('Fade Delay').'
				</th>
				<th align="left" style="width:89%">
					'.$this->l('Content').'
				</th>
				</tr>';
    			$ordered_text = $this->reorder();
    			$i = 1;
        		if (sizeof($ordered_text) > 0)
        		{
	        		foreach ($ordered_text as $text)
    	    		{
        				$this->_html .= '
        					<tr id="td_'.$text['id'].'" '.($i%2==0?"":"class=\"alt_row\"").'>
        						<td align="left" valign="top" style="cursor:move" class="pointer dragHandle center">
        							<img src="'.$this->_path.'img/arrow.png" />
        						</td>
        						<td align="left" valign="top">
        							<input type="text" style="width:40px" name="bft_delay_'.$text['id'].'" id="bft_delay_'.$text['id'].'" value="'.$text["delay"].'" /> &nbsp;'.$this->l('in milliseconds').'.
       							</td>
        						<td align="left" valign="top">
        							<textarea name="bft_text_'.$text['id'].'" id="bft_text_'.$text['id'].'" style="width:200px;height:300px">'.$text["content"].'</textarea>
        						</td>
        					</tr>';
        				$i++;
    	    		}
        		}
        		$mdtime = "new";
        		$this->_html .= '
        			<tr id="td_'.$mdtime.'" '.($i%2==0?"":"class=\"alt_row\"").'>
        				<td align="left" valign="top" style="cursor:move" class="pointer dragHandle center">
        					<img src="'.$this->_path.'img/arrow.png" />
        				</td>
        				<td align="left" valign="top">
        					<input type="text" style="width:40px" name="bft_delay_'.$mdtime.'" id="bft_delay_'.$mdtime.'" value="5000" /> &nbsp;'.$this->l('in milliseconds').'.
       					</td>
        				<td align="left" valign="top">
        					<textarea name="bft_text_'.$mdtime.'" id="bft_text_'.$mdtime.'" style="width:200px;height:300px"></textarea>
        					<input type="hidden" name="bft_total_groups" value="'.$mdtime.'" />
        				</td>
        			</tr>';
        		$this->_html .= '
				<tr>
					<td colspan="2" align="center">
						<input type="submit" value="'.$this->l('Update').'" name="submitChanges" class="button" />
					</td>
				</tr>
        		</table>
			</fieldset>
		</form>';
	}

	private function _postProcess()
	{
		//print_r($_POST);
		$tinymce = false;
		if (isset($_POST['bft_tinymce']) && $_POST['bft_tinymce'] == 1)
			$tinymce = true;
		if (Tools::isSubmit('resetData'))
		{
			Db::getInstance()->Execute('DELETE FROM `'._DB_PREFIX_.'bft_content`');
			$this->_bft_text = array();
			$this->_refreshProperties();
			print '<div class="conf confirm">
				<img src="../img/admin/ok.gif" alt="" title="" />
				'.$this->l('Settings updated').'
			</div>';
			return;
		}
		if (Tools::isSubmit('submitChanges'))
		{
			Configuration::updateValue('BFT_ORDER', Tools::getValue("bft_order"));
			Configuration::updateValue('BFT_DELAY', Tools::getValue("bft_delay"));
			$n_text = array();
			foreach ($this->_bft_text AS $key => $val)
			{
				if (Tools::getValue("bft_text_".$val["id"]) != "")
				{
					if ($tinymce)
						$n_text[$key]["content"] = utf8_encode(html_entity_decode(Tools::getValue("bft_text_".$val["id"]), ENT_QUOTES));
					else
						$n_text[$key]["content"] = Tools::getValue("bft_text_".$val["id"]);
					$n_text[$key]["delay"] = Tools::getValue("bft_delay_".$val["id"]);
					$n_text[$key]["id"] = $val["id"];
				}
			}
			if ( Tools::getValue("bft_text_new") != "")
				array_push($n_text, array("id"=>md5(time()), "content"=> ($tinymce?utf8_encode(html_entity_decode(Tools::getValue("bft_text_new"), ENT_QUOTES)):Tools::getValue("bft_text_new")),"delay"=>Tools::getValue("bft_delay_new")));
			$tmp = addslashes(serialize($n_text));
			$query = 'UPDATE `'._DB_PREFIX_.'bft_content` SET content = "'.$tmp.'"';
			Db::getInstance()->Execute($query);
			$this->_bft_text = $tmp;
			$this->_refreshProperties();
			print '<div class="conf confirm">
				<img src="../img/admin/ok.gif" alt="" title="" />
				'.$this->l('Settings updated').'
			</div>';
		}
	}

	private function uniqueRand($arr)
 	{
 		$tmp_arr = array();
 		foreach ($arr AS $i => $n)
 			array_push($tmp_arr,$i);
  		$return = array();
   		while (sizeof($return) < sizeof($arr))
   		{
 			$smaller = array();
   			$rand = rand(0, sizeof($tmp_arr)-1);
   			array_push($return, $tmp_arr[$rand]);
   			foreach ($tmp_arr AS $i => $n)
   				if ($i != $rand)
   					array_push($smaller, $n);
   			$tmp_arr = $smaller; 
   		}

  		return $return;
 	}
 	
	private function reorder($decode = false)
	{
		$arr = $this->_bft_text;
		$narr = array();
		$tmp = 0;
		$tmpS = 0;
		foreach ($arr AS $key => $row){
			if ($key == 0)
				$tmp = 1;
			
		
		}
		if (isset($arr[1]) && !isset($arr[0]))
			$tmpS = 1;
		if ($this->_bft_order == 1 || !$decode)
		{
			foreach ($arr AS $key => $row)
				$narr[($key)+$tmp] = $decode?array("id"=>$row["id"],"content" => nl2br(html_entity_decode($row["content"])),"delay"=>$row["delay"]):$row;
			ksort($narr);
		}
		else
		{
			
			$rand = $this->uniqueRand($arr);
			
			
			//print_r( $rand);  echo $tmp;
			foreach ($arr AS $key => $row){
				//echo $key.'-'. $rand[$key-1];
				$narr[$rand[$key - $tmpS]+$tmp] = $decode?array("id"=>$row["id"],"content" => nl2br(html_entity_decode($row["content"])),"delay"=>$row["delay"]):$row;
				//print_r($narr[($rand[$key])+$tmp]);
				//echo $rand[$key]+$tmp;
			}
		}
		return $narr;
	}
	
	function hookLeftColumn($params)
	{
		global $smarty;
		$smarty->assign(array(
			'bft_delay' => $this->_bft_delay,
			'bft_text' => $this->reorder(true)));
		return $this->display(__FILE__, 'blockfadingtext.tpl');
	}

	function hookRightColumn($params)
	{
		return $this->hookLeftColumn($params);
	}
	
	function hookHome($params)
	{
		return $this->hookLeftColumn($params);
	}

	function hookTop($params)
	{
		return $this->hookLeftColumn($params);
	}
}
?>