<?php
/*
*Módulo desarrollado por Buhoc (Marca registrada)
*info@buhoc.com
*638922422
*www.buhoc.com
*/

if (!defined('_CAN_LOAD_FILES_'))
	exit;
	
class Socialhome extends Module
{
	public function __construct()
	{
		$this->name = 'socialhome';
		$this->tab = 'front_office_features';
		$this->version = '1.5';

		parent::__construct();

		$this->displayName = $this->l('Social Home Buhoc');
		$this->description = $this->l('Displays  Social links in Homepage');
	}
	
	public function install()
	{
		return (parent::install() AND Configuration::updateValue('socialhome_google', '') && Configuration::updateValue('socialhome_twitter', '') && Configuration::updateValue('socialhome_dribbble', '') && Configuration::updateValue('socialhome_facebook', '') && Configuration::updateValue('socialhome_lindekin', '') && Configuration::updateValue('socialhome_forrts', '')&& $this->registerHook('displayHeader') && $this->registerHook('displayHome'));
	}
	
	public function uninstall()
	{
		//Delete configuration			
		return (Configuration::deleteByName('socialhome_google') AND Configuration::deleteByName('socialhome_twitter') AND Configuration::deleteByName('socialhome_dribbble') AND Configuration::deleteByName('socialhome_facebook') AND Configuration::deleteByName('socialhome_lindekin') AND Configuration::deleteByName('socialhome_forrts') AND parent::uninstall());
	}
	
	public function getContent()
	{
		// If we try to update the settings
		$output = '';
		if (isset($_POST['submitModule']))
		{	
			Configuration::updateValue('socialhome_google', (($_POST['google_url'] != '') ? $_POST['google_url']: ''));
			Configuration::updateValue('socialhome_twitter', (($_POST['twitter_url'] != '') ? $_POST['twitter_url']: ''));		
			Configuration::updateValue('socialhome_dribbble', (($_POST['dribbble_url'] != '') ? $_POST['dribbble_url']: ''));	
			Configuration::updateValue('socialhome_facebook', (($_POST['facebook_url'] != '') ? $_POST['facebook_url']: ''));	
			Configuration::updateValue('socialhome_lindekin', (($_POST['lindekin_url'] != '') ? $_POST['lindekin_url']: ''));
			Configuration::updateValue('socialhome_forrts', (($_POST['forrts_url'] != '') ? $_POST['forrts_url']: ''));				
			$output = '<div class="conf confirm">'.$this->l('Configuration updated').'</div>';
		}
		
		return '
		<h2>'.$this->displayName.'</h2>
		'.$output.'
		<form action="'.Tools::htmlentitiesutf8($_SERVER['REQUEST_URI']).'" method="post">
			<fieldset class="width2">				
				<label for="google_url">'.$this->l('Google Plus URL: ').'</label>
				<input type="text" id="google_url" name="google_url" value="'.Tools::safeOutput((Configuration::get('socialhome_google') != "") ? Configuration::get('socialhome_google') : "").'" />
				<div class="clear">&nbsp;</div>		
				<label for="twitter_url">'.$this->l('Twitter URL: ').'</label>
				<input type="text" id="twitter_url" name="twitter_url" value="'.Tools::safeOutput((Configuration::get('socialhome_twitter') != "") ? Configuration::get('socialhome_twitter') : "").'" />
				<div class="clear">&nbsp;</div>		
				<label for="dribbble_url">'.$this->l('Dribbble URL: ').'</label>
				<input type="text" id="dribbble_url" name="dribbble_url" value="'.Tools::safeOutput((Configuration::get('socialhome_dribbble') != "") ? Configuration::get('socialhome_dribbble') : "").'" />
				<div class="clear">&nbsp;</div>		
				<label for="facebook_url">'.$this->l('Facebook URL: ').'</label>
				<input type="text" id="facebook_url" name="facebook_url" value="'.Tools::safeOutput((Configuration::get('socialhome_facebook') != "") ? Configuration::get('socialhome_facebook') : "").'" />
				<div class="clear">&nbsp;</div>	
				<label for="lindekin_url">'.$this->l('Lindekin URL: ').'</label>
				<input type="text" id="lindekin_url" name="lindekin_url" value="'.Tools::safeOutput((Configuration::get('socialhome_lindekin') != "") ? Configuration::get('socialhome_lindekin') : "").'" />
				<div class="clear">&nbsp;</div>
				<label for="forrts_url">'.$this->l('Forrts URL: ').'</label>
				<input type="text" id="forrts_url" name="forrts_url" value="'.Tools::safeOutput((Configuration::get('socialhome_forrts') != "") ? Configuration::get('socialhome_forrts') : "").'" />
				<div class="clear">&nbsp;</div>									
				<br /><center><input type="submit" name="submitModule" value="'.$this->l('Update settings').'" class="button" /></center>
			</fieldset>
		</form>';
	}
	
	public function hookDisplayHeader()
	{
		$this->context->controller->addCSS(($this->_path).'css/socialhome.css', 'all');
		return $this->display(__FILE__, 'socialhome-header.tpl');
	}
		
	public function hookDisplayHome()
	{
		global $smarty;

		$smarty->assign(array(
			'google_url' => Configuration::get('socialhome_google'),
			'twitter_url' => Configuration::get('socialhome_twitter'),
			'dribbble_url' => Configuration::get('socialhome_dribbble'),
			'facebook_url' => Configuration::get('socialhome_facebook'),
			'lindekin_url' => Configuration::get('socialhome_lindekin'),
			'forrts_url' => Configuration::get('socialhome_forrts')
		));
		return $this->display(__FILE__, 'socialhome.tpl');
	}
	public function hookTop($params)
	{
		return $this->hookDisplayHome($params);
	}

}
?>
